// Programme d'appel de DLL LoadFlow
//		22/ 01 / 1996 !

#include <owl\owlpch.h>
#include <owl\opensave.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>

#include "loadflow.h"
#include "transtab.h"
#include "lunch.rh"

class TLunchWindow : public TWindow {
  public:
	TLunchWindow();

  protected:
	void SetupWindow();
	void CmAbout();

	void CmGS();
	void CmNR();
	void CmNRB();
	void CmFDL();

	void CmEuler();
	void CmTrapeze();
	void CmRK4();

	void CmFileOpen();
	void CmFileView();
	void UpdateCaption();

  private:
	char FileName[MAXPATH];

  DECLARE_RESPONSE_TABLE(TLunchWindow);
};

DEFINE_RESPONSE_TABLE1(TLunchWindow, TWindow)
  EV_COMMAND(CM_ABOUT, CmAbout),

  EV_COMMAND(CM_GS, CmGS),
  EV_COMMAND(CM_NR, CmNR),
  EV_COMMAND(CM_NRB, CmNRB),
  EV_COMMAND(CM_FDL, CmFDL),

  EV_COMMAND(CM_EULER, CmEuler),
  EV_COMMAND(CM_TRAPEZE, CmTrapeze),
  EV_COMMAND(CM_RK4, CmRK4),

  EV_COMMAND(CM_FILEOPEN, CmFileOpen),
  EV_COMMAND(CM_FILEVIEW, CmFileView),
END_RESPONSE_TABLE;


// --------------- TLunchWindow -----------------
TLunchWindow::TLunchWindow()
  : TWindow(0, 0, 0)
{
	Attr.W=300;
	Attr.H=150;
}

void TLunchWindow::SetupWindow()
{
	TWindow::SetupWindow();
	strcpy(FileName, "");
	UpdateCaption();
}


void TLunchWindow::UpdateCaption()
{
  char captionBuffer[70];
  if (strlen(FileName))
	 wsprintf(captionBuffer, "%s - %s", GetApplication()->GetName(),
				 (LPCSTR)FileName);
  else
	 sprintf(captionBuffer, "%s", GetApplication()->GetName());
  Parent->SetCaption(captionBuffer);
}


void TLunchWindow::CmGS()
{
if (strcmp(FileName, ""))
	CallLoadFlow( this, id_GS, FileName, "out.lfo");
}

void TLunchWindow::CmNR()
{
if (strcmp(FileName, ""))
	CallLoadFlow( this, id_NR, FileName, "out.lfo");
}

void TLunchWindow::CmNRB()
{
if (strcmp(FileName, ""))
	CallLoadFlow( this, id_NRB, FileName, "out.lfo");
}

void TLunchWindow::CmFDL()
{
if (strcmp(FileName, ""))
	CallLoadFlow( this, id_FDL, FileName, "out.lfo");
}

void TLunchWindow::CmEuler()
{
if (strcmp(FileName, ""))
	CallTransStab( this, id_Euler, FileName, "out.tso", "Graph.tsg");
}

void TLunchWindow::CmTrapeze()
{
if (strcmp(FileName, ""))
	CallTransStab( this, id_Trapeze, FileName, "out.tso", "Graph.tsg");
}

void TLunchWindow::CmRK4()
{
if (strcmp(FileName, ""))
	CallTransStab( this, id_RK4, FileName, "out.tso", "Graph.tsg");
}

void TLunchWindow::CmFileView()
{
if (strcmp(FileName, ""))
	{
	char SS[MAXPATH];
	strcpy( SS, "notepad.exe ");
	strcat( SS, FileName);
	WinExec( SS, SW_SHOW);
	}
}
void TLunchWindow::CmFileOpen()
{
  TOpenSaveDialog::TData data (
	 OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_NOREADONLYRETURN,
	 "Load Flow Input (*.LFI)|*.lfi|Trans Stab Input (*.TSI)|*.tsi|",
	 0,
	 "",
	 "LFI|TSI"
  );
  if (TFileOpenDialog(this, data).Execute() == IDOK) {
//	 char fileTitle[MAXPATH];
	 TOpenSaveDialog::GetFileTitle(data.FileName, FileName, MAXPATH);
	 // call init all things sauf ceux de simul
	 UpdateCaption();
	 }
}

class TApp : public TApplication {
  public:
	 TApp() : TApplication() {}
	 void InitMainWindow() {
 //		EnableBWCC();
		MainWindow = new TFrameWindow(0, "",
												 new TLunchWindow, TRUE);
		SetName("Lunch LoadFlow");
		MainWindow->AssignMenu("MENU_LUNCH");
		MainWindow->SetIcon(this, "ICON_LUNCH");
	 }
};

int
OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return TApp().Run();
}
