{ This Unit contains the Power Component objects
  for the PowerD.pas program
  with Tap & Shift Transfo
  and Visual 3 Phase Fault, Opened Line, Switch Bus Load...
}
unit PowComp;

interface
uses WinTypes, WinProcs,OWindows, ODialogs, Strings, Objects;

const
{ GeneratorEdit }
  id_Name      = 101;
  id_PG        = 102;
  id_Qgmin     = 103;
  id_Qgmax     = 104;
  id_GVsch     = 105;
  Id_GCon      = 106;
{ BusEdit }

  id_BV         = 102;
  id_BAngle     = 103;
  id_BPg        = 104;
  id_BQg        = 105;
  id_BPL        = 106;
  id_BQL        = 107;
  id_BQgmin     = 108;
  id_BQgmax     = 109;
  id_BVsch      = 110;

  id_TypePQ    = 111;
  id_TypePV    = 112;
  id_TypeSlack = 113;

  id_UnLocked  = 114;
  id_Locked    = 115;

  id_32        = 116;
  id_64        = 117;
  id_96        = 118;
  id_128       = 119;

  id_NamesList = 120;
{ TransfoEdit }
  id_Amag      = 102;
  id_Adelta    = 103;
  id_TZR       = 104;
  Id_TZX       = 105;
  Id_TSmax     = 106;
  id_TCon1     = 107;
  Id_TCon2     = 108;
{ DrainEdit }
  id_PD        = 102;
  id_QD        = 103;
  Id_DCon      = 104;
{ LineEdit }
  id_LZR       = 102;
  Id_LZX       = 103;
  id_G         = 104;
  Id_B         = 105;
  Id_LSmax     = 106;
  id_LCon1     = 107;
  Id_LCon2     = 108;

{ WorkSheet options }
  id_GeneratorOn   =   1;
  id_BusOn         =   2;
  id_LineOn        =   4;
  id_TransfoOn     =   8;
  id_DrainOn       =  16;
  id_CompensatorOn =  32;
  id_CapaOn        =  64;
  id_Moveable      = 128;
{ Study }
  id_LoadFlow  = 1;
  id_TransStab = 2;
{ WSInfo.TSInfo.Code }
  id_FaultedBus   =   1;
  id_OpenedLine   =   2;
  id_SwitchedLoad =   4;
  id_DroppedLoad  =   8;
  id_LossGen      =   16;



Type
     PowSymbType = (Generator, Bus, line, Transfo, Drain,
                    Compensator, Capa, Resistance, SelfInd, Link );

{ enregistre dans les SCH }
     TransStabInfoRec = Record
     Code : Word;
     freq, dt, t2,
     FBt0, FBt1, Gf, Bf,
     OLt0, OLt1,
     SLt0, SLt1, SLPL, SLQL,
     DLt0, DLt1, DLPL, DLQL,
     LGt0, LGt1,
     Tol, eps : Real;
     FaultedBus, OpenedLine, SwitchedLoad, DroppedLoad, LossGen,
     NIterMax  : Integer;
     end;

     WorkSheetInfoRec = Record
     WSOpt, Study  : Word;
     NetWorkList : PCollection;
     TSInfo : TransStabInfoRec;
     end;

     DlgGeneratorRec = Record
     Name , PG, Qgmin, Qgmax, Vsch, Con : Array[0..30] of Char;
     end;

     DlgBusRec = Record
     Name , V, Angle,
      Pg, Qg, PL, QL,
       Qgmin, Qgmax, Vsch : Array[0..30] of Char;
     TypePQ, TypePV, TypeSlack,
      UnLocked, Locked,
      S_32, S_64, S_96, S_128   : Bool;
     Con : Array[0..255] of Char;
     end;

     DlgTransfoRec = Record
     Name , Amag, Adelta, ZR, ZX, Smax, Con1, Con2 : Array[0..30] of Char;
     end;

     DlgDrainRec = Record
     Name , PD, QD, Con : Array[0..30] of Char;
     end;

     DlgLineRec = Record
     Name, ZR, ZX, G, B, Smax, Con1, Con2 : Array[0..30] of Char;
     end;

     DlgCompensatorRec = Record
     Name , Qgmin, Qgmax, Vsch, Con : Array[0..30] of Char;
     end;

     DlgCapaRec = Record
     Name , Bc, Con : Array[0..30] of Char;
     end;

     PLPoint = ^TLPoint;
     TLPoint = object(TObject)
     X, Y: Integer;
     constructor Init(AX, AY: Integer);
     constructor Load(var S: TStream);
     procedure Store(var S: TStream);
     end;

     PBusCon = ^TBusCon;
     TBusCon = object(TObject)
     Con : Integer;
     constructor Init( ACon : Integer);
     constructor Load(var S: TStream);
     procedure Store(var S: TStream);
     end;

     PPowerComponent = ^TPowerComponent;
     TPowerComponent = Object( TObject)
     HisType       : PowSymbType;
     X,Y, Rotation : Integer;
     Name  : Array [0..12] of Char;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Destructor Done; Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure PaintSelected( PaintDC : HDC; Var PaintInfo : TPaintStruct);
                Virtual;
     Function IsInIt( T : TPoint): Boolean; Virtual;
     Function AreYouIn( R : TRect): Boolean; Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PGenerator = ^TGenerator;
     TGenerator = Object( TPowerComponent)
     PG, Qgmin, Qgmax, Vsch  : Real;
     Con                : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PCompensator = ^TCompensator;
     TCompensator = Object( TPowerComponent)
     Qgmin, Qgmax, Vsch  : Real;
     Con                : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PBus = ^TBus;
     TBus = Object( TPowerComponent)
     V, Angle, Pg, Qg, PL, QL, Qgmin, Qgmax, Vsch : Real;
     BusType, Status, Size        : Integer;
     ConColl        : PCollection;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Destructor Done; Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure PaintSelected( PaintDC : HDC; Var PaintInfo : TPaintStruct);
                Virtual;
     Function IsInIt( T : TPoint): Boolean; Virtual;
     Function AreYouIn( R : TRect): Boolean; Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PTransfo = ^TTransfo;
     TTransfo = Object( TPowerComponent)
     Amag, Adelta, ZR, ZX, Smax : Real;
     Con1, Con2  : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PDrain = ^TDrain;
     TDrain = Object( TPowerComponent)
     PD, QD  : Real;
     Con     : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PLine = ^TLine;
     TLine = Object( TPowerComponent)
     LinePoints    : PCollection;
     ZR, ZX, B, G, Smax    : Real;
     Con1, Con2    : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Destructor Done; Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure PaintSelected( PaintDC : HDC; Var PaintInfo : TPaintStruct);
                Virtual;
     Function IsInIt( T : TPoint): Boolean; Virtual;
     Function AreYouIn( R : TRect): Boolean; Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure InvalidateLineRect( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                    Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

     PCapa = ^TCapa;
     TCapa = Object( TPowerComponent)
     Bc  : Real;
     Con : Integer;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec; Var R : TRect); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                     ; Study : Word); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;

Const
 PowSymbName : Array [PowSymbType] of PChar = (
     'Generator', 'Bus', 'Line', 'Transfo', 'Load',
     'Compensator', 'Capacitor',
     'Resistance', 'Self', 'Link' );

 RLPoint: TStreamRec = (
     ObjType: 150;
     VmtLink: Ofs(TypeOf(TLPoint)^);
     Load: @TLPoint.Load;
     Store: @TLPoint.Store);

 RPowerComponent : TStreamRec = (
     ObjType : 151;
     VmtLink : Ofs( TypeOf(TPowerComponent)^);
     Load : @TPowerComponent.Load;
     Store : @TPowerComponent.Store );

 RGenerator : TStreamRec = (
     ObjType : 152;
     VmtLink : Ofs( TypeOf(TGenerator)^);
     Load : @TGenerator.Load;
     Store : @TGenerator.Store );

 RBus : TStreamRec = (
     ObjType : 153;
     VmtLink : Ofs( TypeOf(TBus)^);
     Load : @TBus.Load;
     Store : @TBus.Store );

 RTransfo : TStreamRec = (
     ObjType : 154;
     VmtLink : Ofs( TypeOf(TTransfo)^);
     Load : @TTransfo.Load;
     Store : @TTransfo.Store );

 RDrain : TStreamRec = (
     ObjType : 155;
     VmtLink : Ofs( TypeOf(TDrain)^);
     Load : @TDrain.Load;
     Store : @TDrain.Store );

 RLine : TStreamRec = (
     ObjType : 156;
     VmtLink : Ofs( TypeOf(TLine)^);
     Load : @TLine.Load;
     Store : @TLine.Store );
 RBusCon : TStreamRec = (
     ObjType : 157;
     VmtLink : Ofs( TypeOf(TBusCon)^);
     Load : @TBusCon.Load;
     Store : @TBusCon.Store );

 RCompensator : TStreamRec = (
     ObjType : 158;
     VmtLink : Ofs( TypeOf(TCompensator)^);
     Load : @TCompensator.Load;
     Store : @TCompensator.Store );

 RCapa : TStreamRec = (
     ObjType : 159;
     VmtLink : Ofs( TypeOf(TCapa)^);
     Load : @TCapa.Load;
     Store : @TCapa.Store );

Var
    PowSymbImage : Array[PowSymbType,0..3] of HBitMap;
    PowSymbRot   : Array[PowSymbType] Of Integer;
    FaultImage   : HBitMap;

implementation

{ TLPoint Procedures }
constructor TLPoint.Init(AX, AY: Integer);
begin
  X := AX;
  Y := AY;
end;

constructor TLPoint.Load(var S: TStream);
begin
  S.Read(X, SizeOf(X));
  S.Read(Y, SizeOf(Y));
end;

procedure TLPoint.Store(var S: TStream);
begin
  S.Write(X, SizeOf(X));
  S.Write(Y, SizeOf(Y));
end;

{ TBusCon Procedures }
constructor TBusCon.Init(ACon: Integer);
begin
  Con := ACon;
end;

constructor TBusCon.Load(var S: TStream);
begin
  S.Read(Con, SizeOf(Con));
end;

procedure TBusCon.Store(var S: TStream);
begin
  S.Write(Con, SizeOf(Con));
end;

{ TPowerComponent procedures }
Constructor TPowerComponent.Init( AType : PowSymbType);
begin
Inherited Init;
HisType:=AType;
Rotation:=0;
StrCopy(Name,'');
End;

Constructor TPowerComponent.Load ( Var S : TStream);
Begin
Abstract;
End;

Procedure TPowerComponent.Store ( Var S : TStream);
Begin
Abstract;
End;

Destructor TPowerComponent.Done;
Begin
Inherited Done;
End;

Procedure TPowerComponent.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                                  Var PaintInfo : TPaintStruct);
Var  MemDC : HDC;
Begin
MemDC:=CreateCompatibleDC( PaintDC);
SelectObject( MemDC, PowSymbImage[ HisType, Rotation]);
BitBlt ( PaintDC, X,Y,32,32, MemDC,0,0, SrcAnd);
DeleteDC( MemDC);
End;

Procedure TPowerComponent.PaintSelected( PaintDC : HDC;
                                          Var PaintInfo : TPaintStruct);
Begin
Ellipse( PaintDC, X,Y,X+4,Y+4);
Ellipse( PaintDC, X+28,Y,X+32,Y+4);
Ellipse( PaintDC, X,Y+28,X+4,Y+32);
Ellipse( PaintDC, X+28,Y+28,X+32,Y+32);
End;

Function TPowerComponent.IsInIt( T : TPoint): Boolean;
Var R : TRect;
Begin
SetRect( R, X, Y, X+32, Y+32);
If PtInRect( R, T) Then IsInIt:=True
                   Else IsInIt:=False;
End;

Function TPowerComponent.AreYouIn( R : TRect): Boolean;
Var T : TPoint;
Begin
T.X:=X;
T.Y:=Y;
AreYouIn:=True;
If Not PtInRect( R, T) Then AreYouIn:=False;
T.X:=X+32;
T.Y:=Y+32;
If Not PtInRect( R, T) Then AreYouIn:=False;
End;

Procedure TPowerComponent.UpDate( Decal : TPoint; UnDC : HDC;
                                   WSInfo : WorkSheetInfoRec; Var R : TRect);
Begin
X:=X+Decal.X;
Y:=Y+Decal.Y;
End;

Procedure TPowerComponent.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Begin
Inc( Rotation);
Rotation:=Rotation Mod PowSymbRot[ HisType];
End;

Procedure TPowerComponent.Connect( SelectedList, NetWorkList : PCollection);
Begin
Abstract;
End;

Procedure TPowerComponent.UpDateCon( Num : Integer);
Begin
Abstract;
End;

Procedure TPowerComponent.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Begin
Abstract;
End;

Procedure TPowerComponent.UnConnect( NetWorkList : PCollection);
Begin
Abstract;
End;

{ TGenerator procedures }
Constructor TGenerator.Init( AType : PowSymbType);
begin
Inherited Init( AType);
PG:=0;
Qgmin:=0;
Qgmax:=0;
Vsch:=1;
Con:=-1;    { non connecte }
End;

Constructor TGenerator.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( PG, SizeOf(PG));
S.Read( Qgmin, SizeOf(Qgmin));
S.Read( Qgmax, SizeOf(Qgmax));
S.Read( Vsch, SizeOf(Vsch));
S.Read( Con, SizeOf(Con));
End;

Procedure TGenerator.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( PG, SizeOf(PG));
S.Write( Qgmin, SizeOf(Qgmin));
S.Write( Qgmax, SizeOf(Qgmax));
S.Write( Vsch, SizeOf(Vsch));
S.Write( Con, SizeOf(Con));
End;

Procedure TGenerator.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                             Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
     OldPen, DashedPen : HPen;
Begin
inherited Paint( PaintDC, WSInfo, PaintInfo);
{ Paint a Cross across the generator if LossGen Fault }
if (WSInfo.Study=id_TransStab) and
   (WSInfo.TSInfo.LossGen<>-1) and
   (WSInfo.TSInfo.LossGen=Con)
                       then
                       begin
                       DashedPen:=CreatePen( PS_SOLID, 2, $000000FF );
                       OldPen:=SelectObject( PaintDC, DashedPen);
                       { Paint with a Dashed Blue Pen }
                       MoveTo( PaintDC, X+3, Y+3);
                       LineTo( PaintDC, X+29, Y+29);
                       MoveTo( PaintDC, X+29, Y+3);
                       LineTo( PaintDC, X+3, Y+29);
                       SelectObject( PaintDC, OldPen);
                       DeleteObject( DashedPen);
                       end;

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_GeneratorOn)<>id_GeneratorOn) or (L=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
Case Rotation of
          0 : OffsetRect( R1, 16-(R.right-R.left)div 2, R.top-R.bottom-1);
          1 : OffsetRect( R1, 33, 16-(R.bottom-R.top)div 2);
          2 : OffsetRect( R1, 16-(R.right-R.left)div 2, 33);
          3 : OffsetRect( R1, -R.right+R.left-1, 16-(R.bottom-R.top)div 2);
     end;
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TGenerator.UpDate( Decal : TPoint; UnDC : HDC;
                             WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
SetRect(R1, X, Y, X+32, Y+32);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_GeneratorOn)<>id_GeneratorOn)
          or (L=0)  then
                    begin
                    inherited UpDate( Decal, UnDC, WSInfo, R);
                    exit;
                    end;
{ partie speciale au nom : R1normal +R2 }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
Case Rotation of
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        1 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        3 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);
{ partie avec decalage}
CopyRect( R1, R2);
OffsetRect( R1, Decal.X, Decal.Y);
Case Rotation of
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        1 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        3 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TGenerator.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32, Y+32);
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_GeneratorOn)<>id_GeneratorOn)
          or (L=0)  then exit;
{ partie speciale au nom }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ peut etre faut il ajouter +1 a R2.right-R2.left afin d'assurer total Del }
InflateRect( R1, 2*(R2.right-R2.left), 2*(R2.bottom-R2.top));
UnionRect( R, R, R1);
End;

Procedure TGenerator.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        MessageBox( GetFocus,
                        'A generator has to be connected with a bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
Num:=NetWorkList^.IndexOf( @Self);
{ verifie s'il etait deja connecte avec d'autres }
If Con<>-1 Then NetWorkList^.FirstThat( @HasEqualPcbNum);

Con:=NetWorkList^.IndexOf( P);
{ verifie s'il y est deja }
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TGenerator.UpDateCon( Num : Integer);
Begin
If Con=Num Then Con:=-1;
If Con>Num Then Dec(Con);
End;

Procedure TGenerator.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     GenData : DlgGeneratorRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'GeneratorEdit'));
New(E, InitResource(D, id_Name, SizeOf(GenData.Name)));
New(E, InitResource(D, id_PG, SizeOf(GenData.PG)));
New(E, InitResource(D, id_Qgmin, SizeOf(GenData.Qgmin)));
New(E, InitResource(D, id_Qgmax, SizeOf(GenData.Qgmax)));
New(E, InitResource(D, id_GVsch, SizeOf(GenData.Vsch)));
New(S, InitResource(D, id_GCon, SizeOf(GenData.Con)));
StrCopy(GenData.Name, Name);
Str( PG:7:5, GenData.PG);
Str( Qgmin:7:5, GenData.Qgmin);
Str( Qgmax:7:5, GenData.Qgmax);
Str( Vsch:7:5, GenData.Vsch);
If Con=-1 Then StrCopy( GenData.Con, 'None')
          Else Begin
               StrCopy( GenData.Con,
                PPowerComponent(NetWorkList^.At( Con))^.Name );
               If StrComp(GenData.Con,'')=0 Then StrCopy( GenData.Con,
                                                 'No name entered');
               End;


D^.TransferBuffer := @GenData;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,GenData.Name, 12);
                             Val( GenData.PG, PG, ValCode);
                             Val( GenData.Qgmin, Qgmin, ValCode);
                             Val( GenData.Qgmax, Qgmax, ValCode);
                             Val( GenData.Vsch, Vsch, ValCode);

                             End;
End;

Procedure TGenerator.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con:=-1;
End;

{ TCompensator procedures }
Constructor TCompensator.Init( AType : PowSymbType);
begin
Inherited Init( AType);
Qgmin:=0;
Qgmax:=0;
Vsch:=1;
Con:=-1;    { non connecte }
End;

Constructor TCompensator.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( Qgmin, SizeOf(Qgmin));
S.Read( Qgmax, SizeOf(Qgmax));
S.Read( Vsch, SizeOf(Vsch));
S.Read( Con, SizeOf(Con));
End;

Procedure TCompensator.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( Qgmin, SizeOf(Qgmin));
S.Write( Qgmax, SizeOf(Qgmax));
S.Write( Vsch, SizeOf(Vsch));
S.Write( Con, SizeOf(Con));
End;

Procedure TCompensator.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                               Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
     OldPen, DashedPen : HPen;
Begin
inherited Paint( PaintDC, WSInfo, PaintInfo);
{ Paint a Cross across the generator if LossGen Fault }
if (WSInfo.Study=id_TransStab) and
   (WSInfo.TSInfo.LossGen<>-1) and
   (WSInfo.TSInfo.LossGen=Con)
                       then
                       begin
                       DashedPen:=CreatePen( PS_SOLID, 2, $000000FF );
                       OldPen:=SelectObject( PaintDC, DashedPen);
                       { Paint with a Dashed Blue Pen }
                       MoveTo( PaintDC, X+3, Y+3);
                       LineTo( PaintDC, X+29, Y+29);
                       MoveTo( PaintDC, X+29, Y+3);
                       LineTo( PaintDC, X+3, Y+29);
                       SelectObject( PaintDC, OldPen);
                       DeleteObject( DashedPen);
                       end;

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CompensatorOn)<>id_CompensatorOn)
           or (L=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
Case Rotation of
          0 : OffsetRect( R1, 16-(R.right-R.left)div 2, R.top-R.bottom-1);
          1 : OffsetRect( R1, 33, 16-(R.bottom-R.top)div 2);
          2 : OffsetRect( R1, 16-(R.right-R.left)div 2, 33);
          3 : OffsetRect( R1, -R.right+R.left-1, 16-(R.bottom-R.top)div 2);
end;
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TCompensator.UpDate( Decal : TPoint; UnDC : HDC;
                               WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
SetRect(R1, X, Y, X+32, Y+32);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CompensatorOn)<>id_CompensatorOn)
          or (L=0)  then
                    begin
                    inherited UpDate( Decal, UnDC, WSInfo, R);
                    exit;
                    end;
{ partie speciale au nom : R1normal +R2 }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
Case Rotation of
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        1 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        3 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);
{ partie avec decalage}
CopyRect( R1, R2);
OffsetRect( R1, Decal.X, Decal.Y);
Case Rotation of
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        1 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        3 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TCompensator.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32, Y+32);
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CompensatorOn)<>id_CompensatorOn)
          or (L=0)  then exit;
{ partie speciale au nom }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, StrEnd(Name)-Name, R2, DT_CALCRECT);
InflateRect( R1, 2*(R2.right-R2.left), 2*(R2.bottom-R2.top));
UnionRect( R, R, R1);
End;

Procedure TCompensator.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        MessageBox( GetFocus,
                        'A Compensator has to be connected with a bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
Num:=NetWorkList^.IndexOf( @Self);
{ verifie s'il etait deja connecte avec d'autres }
If Con<>-1 Then NetWorkList^.FirstThat( @HasEqualPcbNum);

Con:=NetWorkList^.IndexOf( P);
{ verifie s'il y est deja }
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TCompensator.UpDateCon( Num : Integer);
Begin
If Con=Num Then Con:=-1;
If Con>Num Then Dec(Con);
End;

Procedure TCompensator.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgCompensatorRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'CompensatorEdit'));
New(E, InitResource(D, id_Name, SizeOf(Rec.Name)));
New(E, InitResource(D, 102, SizeOf(Rec.Qgmin)));
New(E, InitResource(D, 103, SizeOf(Rec.Qgmax)));
New(E, InitResource(D, 104, SizeOf(Rec.Vsch)));
New(S, InitResource(D, 105, SizeOf(Rec.Con)));
StrCopy(Rec.Name, Name);
Str( Qgmin:7:5, Rec.Qgmin);
Str( Qgmax:7:5, Rec.Qgmax);
Str( Vsch:7:5, Rec.Vsch);
If Con=-1 Then StrCopy( Rec.Con, 'None')
          Else Begin
               StrCopy( Rec.Con,
                PPowerComponent(NetWorkList^.At( Con))^.Name );
               If StrComp(Rec.Con,'')=0 Then StrCopy( Rec.Con,
                                                 'No name entered');
               End;


D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.Qgmin, Qgmin, ValCode);
                             Val( Rec.Qgmax, Qgmax, ValCode);
                             Val( Rec.Vsch, Vsch, ValCode);
                             End;
End;

Procedure TCompensator.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con:=-1;
End;

{ TBus procedures }
Constructor TBus.Init( AType : PowSymbType);
begin
Inherited Init( AType);
V:=1;
Angle:=0;
Pg:=0;
Qg:=0;
PL:=0;
QL:=0;
Qgmin:=0;
Qgmax:=0;
Vsch:=1;
BusType:=0;
Status:=0;
Size:=0;
ConColl:=New( PCollection, Init( 5, 5));
End;

Constructor TBus.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( V, SizeOf(V));
S.Read( Angle, SizeOf(Angle));
S.Read( Pg, SizeOf(Pg));
S.Read( Qg, SizeOf(Qg));
S.Read( PL, SizeOf(PL));
S.Read( QL, SizeOf(QL));
S.Read( Qgmin, SizeOf(Qgmin));
S.Read( Qgmax, SizeOf(Qgmax));
S.Read( Vsch, SizeOf(Vsch));
S.Read( BusType, SizeOf( BusType));
S.Read( Status, SizeOf( Status));
S.Read( Size, SizeOf( Size));
ConColl:=PCollection( S.Get);
End;

Procedure TBus.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( V, SizeOf(V));
S.Write( Angle, SizeOf(Angle));
S.Write( Pg, SizeOf(Pg));
S.Write( Qg, SizeOf(Qg));
S.Write( PL, SizeOf(PL));
S.Write( QL, SizeOf(QL));
S.Write( Qgmin, SizeOf(Qgmin));
S.Write( Qgmax, SizeOf(Qgmax));
S.Write( Vsch, SizeOf(Vsch));
S.Write( BusType, SizeOf( BusType));
S.Write( Status, SizeOf( Status));
S.Write( Size, SizeOf( Size));
S.Put( ConColl);
End;

Procedure TBus.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                       Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
     MemDC : HDC;
Begin
{ special bus painting }
MemDC:=CreateCompatibleDC( PaintDC);
SelectObject( MemDC, PowSymbImage[ HisType, Rotation]);
StretchBlt( PaintDC, X, Y, 32+(1-Rotation)*32*Size, 32+Rotation*32*Size,
            MemDC, 0, 0, 32, 32, SrcAnd);
{ Paint with a 3 Phase Fault }
if (WSInfo.Study=id_TransStab) and
   (WSInfo.TSInfo.FaultedBus<>-1)
          then
          if WSInfo.TSInfo.FaultedBus=WSInfo.NetWorkList^.IndexOf( @self)
                                 then
                                 begin
                                 SelectObject( MemDC, FaultImage);
                                 case Rotation of
                                 0 : BitBlt( PaintDC, X+16*Size, Y+19, 32,32,
                                             MemDC, 0, 0, SrcAnd);
                                 1 : BitBlt( PaintDC, X, Y+32+32*Size, 32,32,
                                             MemDC, 0, 0, SrcAnd);
                                     end;
                                 end;
DeleteDC( MemDC);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_BusOn)<>id_BusOn)
          or (L=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
if Rotation=0 then OffsetRect( R1, -R.right+R.left,
                                   16-(R.bottom-R.top)div 2)
              else OffsetRect( R1, 16-(R.right-R.left)div 2,
                                   -R.bottom+R.top);
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TBus.PaintSelected( PaintDC : HDC; Var PaintInfo : TPaintStruct);
Begin
Ellipse( PaintDC, X,Y,X+4,Y+4);
Ellipse( PaintDC, X-4+32+(1-Rotation)*32*Size,Y,
                  X+32+(1-Rotation)*32*Size,Y+4);
Ellipse( PaintDC, X,Y-4+32+Rotation*32*Size,X+4,Y+32+Rotation*32*Size);
Ellipse( PaintDC, X-4+32+(1-Rotation)*32*Size,Y-4+32+Rotation*32*Size,
                  X+32+(1-Rotation)*32*Size,Y+32+Rotation*32*Size);
End;

Function TBus.IsInIt( T : TPoint): Boolean;
Var R : TRect;
Begin
SetRect( R, X, Y, X+32+(1-Rotation)*32*Size, Y+32+Rotation*32*Size);
If PtInRect( R, T) Then IsInIt:=True
                   Else IsInIt:=False;
End;

Function TBus.AreYouIn( R : TRect): Boolean;
Var T : TPoint;
Begin
T.X:=X;
T.Y:=Y;
AreYouIn:=True;
If Not PtInRect( R, T) Then AreYouIn:=False;
T.X:=X+32+(1-Rotation)*32*Size;
T.Y:=Y+32+Rotation*32*Size;
If Not PtInRect( R, T) Then AreYouIn:=False;
End;

Procedure TBus.UpDate( Decal : TPoint; UnDC : HDC;
                       WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin                        { for FaultImage -| }
SetRect(R1, X, Y, X+32+(1-Rotation)*32*Size, Y+64+Rotation*32*Size);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y,
        X+Decal.X+32+(1-Rotation)*32*Size, Y+Decal.Y+64+Rotation*32*Size);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_BusOn)<>id_BusOn)
          or (L=0) then
                 begin
                 inherited UpDate( Decal, UnDC, WSInfo, R);
                 exit;
                 end;
SetRect(R1, X, Y, X, Y);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
if Rotation=0 then OffsetRect( R2, -R1.right+R1.left,
                                   16-(R1.bottom-R1.top)div 2)
              else OffsetRect( R2, 16-(R1.right-R1.left)div 2,
                                   -R1.bottom+R1.top);
UnionRect( R, R, R2);
SetRect(R1, X+Decal.X, Y+Decal.Y,
        X+Decal.X+32+(1-Rotation)*32*Size, Y+Decal.Y++32+Rotation*32*Size);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
if Rotation=0 then OffsetRect( R2, -R1.right+R1.left,
                                   16-(R1.bottom-R1.top)div 2)
              else OffsetRect( R2, 16-(R1.right-R1.left)div 2,
                                   -R1.bottom+R1.top);
UnionRect( R, R, R2);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TBus.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32*(Size+1), Y+32*(Size+2));
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_BusOn)<>id_BusOn)
          or (L=0) then exit;
{ partie speciale au nom }
SetRect(R1, X, Y, X, Y);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
OffsetRect( R2, -R1.right+R1.left-1, 16-(R1.bottom-R1.top)div 2);
UnionRect( R, R, R2);
CopyRect( R2, R1);
OffsetRect( R2, 16-(R1.right-R1.left)div 2, -R1.bottom+R1.top-1);
UnionRect( R, R, R2);
End;

Procedure TBus.Connect( SelectedList, NetWorkList : PCollection);
Var  MyC : PPowerComponent;
Begin
MyC:=SelectedList^.At(1);
If MyC^.HisType=Bus Then begin
                        MessageBox( GetFocus,
                        'A bus cannot be connected directly with another bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
{ inverse l'ordre }
SelectedList^.AtDelete(1);
SelectedList^.AtInsert(0, MyC);
MyC^.Connect( SelectedList, NetWorkList);
End;

Procedure TBus.UpDateCon( Num : Integer);
Var MyC : PPowerComponent;

 Function EqualIt ( PBC : PBusCon) : Boolean; Far;
 begin
 If PBC^.Con=Num Then EqualIt:=True
                 Else EqualIt:=False;
 end;

 Procedure UpDateIt ( PBC : PBusCon); Far;
 begin
 If PBC^.Con>Num Then Dec( PBC^.Con);
 end;
Begin
MyC:=ConColl^.FirstThat( @EqualIt);
If MyC<>Nil Then ConColl^.Free( MyC);
ConColl^.ForEach( @UpDateIt);
End;

Procedure TBus.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     SS: PStatic;
     R : PRadioButton;
     I,Num : Integer;
     S1 : Array [0..40] Of Char;
     BusData : DlgBusRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'BusEdit'));
New(E, InitResource(D, id_Name, SizeOf(BusData.Name)));
New(E, InitResource(D, id_BV, SizeOf(BusData.V)));
New(E, InitResource(D, id_BAngle, SizeOf(BusData.Angle)));
New(E, InitResource(D, id_BPg, SizeOf(BusData.Pg)));
New(E, InitResource(D, id_BQg, SizeOf(BusData.Qg)));
New(E, InitResource(D, id_BPL, SizeOf(BusData.PL)));
New(E, InitResource(D, id_BQL, SizeOf(BusData.QL)));
New(E, InitResource(D, id_BQgmin, SizeOf(BusData.Qgmin)));
New(E, InitResource(D, id_BQgmax, SizeOf(BusData.Qgmax)));
New(E, InitResource(D, id_BVsch, SizeOf(BusData.Vsch)));
New(R, InitResource(D, id_TypePQ));
New(R, InitResource(D, id_TypePV));
New(R, InitResource(D, id_TypeSlack));

New(R, InitResource(D, id_UnLocked));
New(R, InitResource(D, id_Locked));

New(R, InitResource(D, id_32));
New(R, InitResource(D, id_64));
New(R, InitResource(D, id_96));
New(R, InitResource(D, id_128));
New(SS, InitResource(D, id_NamesList, SizeOf(BusData.Con)));

StrCopy(BusData.Name, Name);
Str( V:7:5, BusData.V);
Str( Angle:7:5, BusData.Angle);
Str( Pg:7:5, BusData.Pg);
Str( Qg:7:5, BusData.Qg);
Str( PL:7:5, BusData.PL);
Str( QL:7:5, BusData.QL);
Str( Qgmin:7:5, BusData.Qgmin);
Str( Qgmax:7:5, BusData.Qgmax);
Str( Vsch:7:5, BusData.Vsch);
If BusType=0 Then Begin
                  BusData.TypePQ:=True;
                  BusData.TypePV:=False;
                  BusData.TypeSlack:=False;
                  End;
If BusType=1 Then Begin
                  BusData.TypePQ:=False;
                  BusData.TypePV:=True;
                  BusData.TypeSlack:=False;
                  End;
If BusType=2 Then Begin
                  BusData.TypePQ:=False;
                  BusData.TypePV:=False;
                  BusData.TypeSlack:=True;
                  End;

If Status=0 Then Begin
                 BusData.UnLocked:=True;
                 BusData.Locked:=False;
                 End;
If Status=1 Then Begin
                 BusData.UnLocked:=False;
                 BusData.Locked:=True;
                 End;

If Size=0 Then Begin
               BusData.S_32:=True;
               BusData.S_64:=False;
               BusData.S_96:=False;
               BusData.S_128:=False;
               End;
If Size=1 Then Begin
               BusData.S_32:=False;
               BusData.S_64:=True;
               BusData.S_96:=False;
               BusData.S_128:=False;
               End;
If Size=2 Then Begin
               BusData.S_32:=False;
               BusData.S_64:=False;
               BusData.S_96:=True;
               BusData.S_128:=False;
               End;
If Size=3 Then Begin
               BusData.S_32:=False;
               BusData.S_64:=False;
               BusData.S_96:=False;
               BusData.S_128:=True;
               End;

If ConColl^.Count=0 Then StrCopy( BusData.Con, 'No Components Connected')
                    Else StrCopy( BusData.Con, '');
For I:=0 to ConColl^.Count-1 do
   Begin
   Num:=PBusCon(ConColl^.At(I))^.Con;
   StrCat(BusData.Con,
       PowSymbName[ PPowerComponent(NetWorkList^.At( Num))^.HisType] );
   StrCat( BusData.Con, ' : ');
   StrCopy( S1, PPowerComponent(NetWorkList^.At( Num))^.Name );
   If StrComp(S1, '')=0 Then StrCopy( S1,'No name entered');
   StrCat( BusData.Con, S1);
   StrCat( BusData.Con, #13#10);
   End;

D^.TransferBuffer := @BusData;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,BusData.Name, 12);
                             Val( BusData.V, V, ValCode);
                             Val( BusData.Angle, Angle, ValCode);
                             Val( BusData.Pg, Pg, ValCode);
                             Val( BusData.Qg, Qg, ValCode);
                             Val( BusData.PL, PL, ValCode);
                             Val( BusData.QL, QL, ValCode);
                             Val( BusData.Qgmin, Qgmin, ValCode);
                             Val( BusData.Qgmax, Qgmax, ValCode);
                             Val( BusData.Vsch, Vsch, ValCode);
                             If BusData.TypePQ Then BusType:=0;
                             If BusData.TypePV Then BusType:=1;
                             If BusData.TypeSlack Then BusType:=2;
                             If BusData.UnLocked Then Status:=0;
                             If BusData.Locked   Then Status:=1;
                             If BusData.S_32  Then Size:=0;
                             If BusData.S_64  Then Size:=1;
                             If BusData.S_96  Then Size:=2;
                             If BusData.S_128 Then Size:=3;
                             End;
End;

Procedure TBus.UnConnect( NetWorkList : PCollection);
Var  Num : Integer;

  Procedure CheckPBC( PBC : PBusCon); Far;
  Var MyC : PPowerComponent;
  begin
  MyC:=NetWorkList^.At( PBC^.Con);
  Case MyC^.HisType of
       Generator : PGenerator( MyC)^.Con:=-1;
       Drain     : PDrain( MyC)^.Con:=-1;
       Transfo   :  Begin
                    If PTransfo( MyC)^.Con1=Num
                      Then Begin
                           PTransfo( MyC)^.Con1:=PTransfo( MyC)^.Con2;
                           PTransfo( MyC)^.Con2:=-1;
                           End;
                    If PTransfo( MyC)^.Con2=Num
                      Then PTransfo( MyC)^.Con2:=-1;
                    End;
       Line   :  Begin
                    If PLine( MyC)^.Con1=Num
                      Then Begin
                           PLine( MyC)^.Con1:=PLine( MyC)^.Con2;
                           PLine( MyC)^.Con2:=-1;
                           End;
                    If PLine( MyC)^.Con2=Num
                      Then PLine( MyC)^.Con2:=-1;
                    End;
       End;
  end;

Begin
Num:=NetWorkList^.IndexOf( @Self);
ConColl^.ForEach( @CheckPBC);
ConColl^.FreeAll;
End;

Destructor TBus.Done;
Begin
  Dispose( ConColl, Done);
  inherited Done;
End;

{ TTransfo procedures }
Constructor TTransfo.Init( AType : PowSymbType);
begin
Inherited Init( AType);
Amag:=1;
Adelta:=0;
ZR:=0;
ZX:=0;
Smax:=0;
Con1:=-1;    { non connecte }
Con2:=-1;    { non connecte }
End;

Constructor TTransfo.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( Amag, SizeOf(Amag));
S.Read( Adelta, SizeOf(Adelta));
S.Read( ZR, SizeOf(ZR));
S.Read( ZX, SizeOf(ZX));
S.Read( Smax, SizeOf(Smax));
S.Read( Con1, SizeOf(Con1));
S.Read( Con2, SizeOf(Con2));
End;

Procedure TTransfo.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( Amag, SizeOf(Amag));
S.Write( Adelta, SizeOf(Adelta));
S.Write( ZR, SizeOf(ZR));
S.Write( ZX, SizeOf(ZX));
S.Write( Smax, SizeOf(Smax));
S.Write( Con1, SizeOf(Con1));
S.Write( Con2, SizeOf(Con2));
End;

Procedure TTransfo.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                           Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
Begin
inherited Paint( PaintDC, WSInfo, PaintInfo);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_TransfoOn)<>id_TransfoOn)
          or (L=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
{ l'inverse du Bus i.e. 0 <=> OO  et  1 <=> 8 }
if Rotation=1 then OffsetRect( R1, -R.right+R.left,
                                   16-(R.bottom-R.top)div 2)
              else OffsetRect( R1, 16-(R.right-R.left)div 2,
                                   -R.bottom+R.top);
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TTransfo.UpDate( Decal : TPoint; UnDC : HDC;
                           WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
SetRect(R1, X, Y, X+32, Y+32);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_TransfoOn)<>id_TransfoOn)
          or (L=0) then
                 begin
                 inherited UpDate( Decal, UnDC, WSInfo, R);
                 exit;
                 end;
SetRect(R1, X, Y, X, Y);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
{ l'inverse du Bus i.e. 0 <=> OO  et  1 <=> 8 }
if Rotation=1 then OffsetRect( R2, -R1.right+R1.left,
                                   16-(R1.bottom-R1.top)div 2)
              else OffsetRect( R2, 16-(R1.right-R1.left)div 2,
                                   -R1.bottom+R1.top);
UnionRect( R, R, R2);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
{ l'inverse du Bus i.e. 0 <=> OO  et  1 <=> 8 }
if Rotation=1 then OffsetRect( R2, -R1.right+R1.left,
                                   16-(R1.bottom-R1.top)div 2)
              else OffsetRect( R2, 16-(R1.right-R1.left)div 2,
                                   -R1.bottom+R1.top);
UnionRect( R, R, R2);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TTransfo.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32, Y+32);
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_TransfoOn)<>id_TransfoOn)
          or (L=0) then exit;
{ partie speciale au nom }
SetRect(R1, X, Y, X, Y);
DrawText( UnDC, Name, L, R1, DT_CALCRECT);
CopyRect( R2, R1);
OffsetRect( R2, -R1.right+R1.left, 16-(R1.bottom-R1.top)div 2);
UnionRect( R, R, R2);
CopyRect( R2, R1);
OffsetRect( R2, 16-(R1.right-R1.left)div 2, -R1.bottom+R1.top);
UnionRect( R, R, R2);
End;

Procedure TTransfo.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;
     S   : Array [0..80] of char;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        case HisType of
                             Transfo : StrCopy( S,'A transformer ');
                             Resistance : StrCopy( S,'A resistance ');
                             SelfInd : StrCopy( S,'A self inductance ');
                             end;
                        StrCat( S,'has to be connected with a bus');
                        MessageBox( GetFocus, S,'Connect Error',
                                    MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
Num:=NetWorkList^.IndexOf( @Self);

If (Con1<>-1) And (Con2=-1) Then
                            begin
                            Con2:=NetWorkList^.IndexOf( P);
                            { pas de connection avec le meme bus }
                            if Con2=Con1 then begin
                               Con2:=-1;
                        case HisType of
                             Transfo : StrCopy( S,'A transformer ');
                             Resistance : StrCopy( S,'A resistance ');
                             SelfInd : StrCopy( S,'A self inductance ');
                             end;
                   StrCat(S,'has to be connected with two different buses');
                               MessageBox( GetFocus, S, 'Connect Error',
                                           MB_Ok+MB_IconExclamation);
                               Exit;
                               end;
                            end
                       Else Begin
  { elemine toute connection anterieure : 0 ou 2 PBus^.Concoll^.->PCB }
                            NetWorkList^.FirstThat( @HasEqualPcbNum);
                            NetWorkList^.FirstThat( @HasEqualPcbNum);

                            Con1:=NetWorkList^.IndexOf( P);
                            Con2:=-1;
                            End;
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TTransfo.UpDateCon( Num : Integer);
Begin
If Con1=Num Then Con1:=-1;
If Con2=Num Then Con2:=-1;
If Con1>Num Then Dec(Con1);
If Con2>Num Then Dec(Con2);
End;

Procedure TTransfo.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     TransfoData : DlgTransfoRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'TransfoEdit'));
New(E, InitResource(D, id_Name, SizeOf(TransfoData.Name)));
New(E, InitResource(D, id_Amag, SizeOf(TransfoData.Amag)));
New(E, InitResource(D, id_Adelta, SizeOf(TransfoData.Adelta)));
New(E, InitResource(D, id_TZR, SizeOf(TransfoData.ZR)));
New(E, InitResource(D, id_TZX, SizeOf(TransfoData.ZX)));
New(E, InitResource(D, id_TSmax, SizeOf(TransfoData.Smax)));
New(S, InitResource(D, id_TCon1, SizeOf(TransfoData.Con1)));
New(S, InitResource(D, id_TCon2, SizeOf(TransfoData.Con2)));
StrCopy(TransfoData.Name, Name);
Str( Amag:7:5, TransfoData.Amag);
Str( Adelta:9:5, TransfoData.Adelta);
Str( ZR:7:5, TransfoData.ZR);
Str( ZX:7:5, TransfoData.ZX);
Str( Smax:7:5, TransfoData.Smax);
If Con1=-1 Then StrCopy( TransfoData.Con1, 'None')
          Else Begin
               StrCopy( TransfoData.Con1,
                PPowerComponent(NetWorkList^.At( Con1))^.Name );
             If StrComp(TransfoData.Con1,'')=0 Then StrCopy( TransfoData.Con1,
                                                 'No name entered');
               End;
If Con2=-1 Then StrCopy( TransfoData.Con2, 'None')
          Else Begin
               StrCopy( TransfoData.Con2,
                PPowerComponent(NetWorkList^.At( Con2))^.Name );
             If StrComp(TransfoData.Con2,'')=0 Then StrCopy( TransfoData.Con2,
                                                 'No name entered');
               End;


D^.TransferBuffer := @TransfoData;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,TransfoData.Name, 12);
                             Val( TransfoData.Amag, Amag, ValCode);
                             Val( TransfoData.Adelta, Adelta, ValCode);
                             Val( TransfoData.ZR, ZR, ValCode);
                             Val( TransfoData.ZX, ZX, ValCode);
                             Val( TransfoData.Smax, Smax, ValCode);
                             End;
End;

Procedure TTransfo.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con1:=-1;
Con2:=-1;
End;

{ TDrain procedures }
Constructor TDrain.Init( AType : PowSymbType);
begin
Inherited Init( AType);
PD:=0;
QD:=0;
Con:=-1;    { non connecte }
End;

Constructor TDrain.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( PD, SizeOf(PD));
S.Read( QD, SizeOf(QD));
S.Read( Con, SizeOf(Con));
End;

Procedure TDrain.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( PD, SizeOf(PD));
S.Write( QD, SizeOf(QD));
S.Write( Con, SizeOf(Con));
End;

Procedure TDrain.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                         Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
     OldPen, DashedPen : HPen;
Begin
inherited Paint( PaintDC, WSInfo, PaintInfo);
{ Paint a Cross across the generator if LossGen Fault }
if (WSInfo.Study=id_TransStab)
   then if
   (WSInfo.TSInfo.SwitchedLoad<>-1) and
   (WSInfo.TSInfo.SwitchedLoad=Con)
                       then
                       begin
                       DashedPen:=CreatePen( PS_SOLID, 2, $000000FF );
                       OldPen:=SelectObject( PaintDC, DashedPen);
                       { Paint with a Dashed Blue Pen }
                       MoveTo( PaintDC, X, Y+20);
                       LineTo( PaintDC, X+10, Y+20);
                       LineTo( PaintDC, X+10, Y+10);
                       LineTo( PaintDC, X+29, Y+10);
                       SelectObject( PaintDC, OldPen);
                       DeleteObject( DashedPen);
                       end
   else if
   (WSInfo.TSInfo.DroppedLoad<>-1) and
   (WSInfo.TSInfo.DroppedLoad=Con)
                       then
                       begin
                       DashedPen:=CreatePen( PS_SOLID, 2, $000000FF );
                       OldPen:=SelectObject( PaintDC, DashedPen);
                       { Paint with a Dashed Blue Pen }
                       MoveTo( PaintDC, X, Y+10);
                       LineTo( PaintDC, X+10, Y+10);
                       LineTo( PaintDC, X+10, Y+20);
                       LineTo( PaintDC, X+29, Y+20);
                       SelectObject( PaintDC, OldPen);
                       DeleteObject( DashedPen);
                       end;

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_DrainOn)<>id_DrainOn)
           or (L=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
Case Rotation of
          2 : OffsetRect( R1, 16-(R.right-R.left)div 2, R.top-R.bottom-1);
          3 : OffsetRect( R1, 33, 16-(R.bottom-R.top)div 2);
          0 : OffsetRect( R1, 16-(R.right-R.left)div 2, 33);
          1 : OffsetRect( R1, -R.right+R.left-1, 16-(R.bottom-R.top)div 2);
end;
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TDrain.UpDate( Decal : TPoint; UnDC : HDC;
                        WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
SetRect(R1, X, Y, X+32, Y+32);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_DrainOn)<>id_DrainOn)
          or (L=0)  then
                    begin
                    inherited UpDate( Decal, UnDC, WSInfo, R);
                    exit;
                    end;
{ partie speciale au nom : R1normal +R2 }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
Case Rotation of
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        3 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        1 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);
{ partie avec decalage}
CopyRect( R1, R2);
OffsetRect( R1, Decal.X, Decal.Y);
Case Rotation of
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        3 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        1 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TDrain.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L   : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32, Y+32);
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_DrainOn)<>id_DrainOn)
          or (L=0) then exit;
{ partie speciale au nom }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
InflateRect( R1, 2*(R2.right-R2.left), 2*(R2.bottom-R2.top));
UnionRect( R, R, R1);
End;

Procedure TDrain.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        MessageBox( GetFocus,
                        'A Load has to be connected with a bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;

Num:=NetWorkList^.IndexOf( @Self);
{ verifie s'il etait deja connecte avec d'autres }
If Con<>-1 Then NetWorkList^.FirstThat( @HasEqualPcbNum);

Con:=NetWorkList^.IndexOf( P);
{ verifie s'il y est deja }
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TDrain.UpDateCon( Num : Integer);
Begin
If Con=Num Then Con:=-1;
If Con>Num Then Dec(Con);
End;

Procedure TDrain.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     DrainData : DlgDrainRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'DrainEdit'));
New(E, InitResource(D, id_Name, SizeOf(DrainData.Name)));
New(E, InitResource(D, id_PD, SizeOf(DrainData.PD)));
New(E, InitResource(D, id_QD, SizeOf(DrainData.QD)));
New(S, InitResource(D, id_DCon, SizeOf(DrainData.Con)));
StrCopy(DrainData.Name, Name);
Str( PD:7:5, DrainData.PD);
Str( QD:7:5, DrainData.QD);
If Con=-1 Then StrCopy( DrainData.Con, 'None')
          Else Begin
               StrCopy( DrainData.Con,
                PPowerComponent(NetWorkList^.At( Con))^.Name );
                If  StrComp(DrainData.Con,'')=0 Then StrCopy( DrainData.Con,
                                                  'No name entered');
               End;


D^.TransferBuffer := @DrainData;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,DrainData.Name, 12);
                             Val( DrainData.PD, PD, ValCode);
                             Val( DrainData.QD, QD, ValCode);
                             End;
End;

Procedure TDrain.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con:=-1;
End;

{ TLine procedures }
Constructor TLine.Init( AType : PowSymbType);
begin
Inherited Init( AType);
LinePoints:=New( PCollection, Init(5,5));
ZR:=0;
ZX:=0;
B:=0;
G:=0;
Smax:=0; { Smax=illimitee }
Con1:=-1;    { non connecte }
Con2:=-1;    { non connecte }
End;

Constructor TLine.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( ZR, SizeOf(ZR));
S.Read( ZX, SizeOf(ZX));
S.Read( B, SizeOf(B));
S.Read( G, SizeOf(G));
S.Read( Smax, SizeOf(Smax));
S.Read( Con1, SizeOf(Con1));
S.Read( Con2, SizeOf(Con2));
LinePoints:=PCollection( S.Get);
End;

Procedure TLine.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( ZR, SizeOf(ZR));
S.Write( ZX, SizeOf(ZX));
S.Write( B, SizeOf(B));
S.Write( G, SizeOf(G));
S.Write( Smax, SizeOf(Smax));
S.Write( Con1, SizeOf(Con1));
S.Write( Con2, SizeOf(Con2));
S.Put( LinePoints);
End;

Procedure TLine.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                        Var PaintInfo : TPaintStruct);
Var  L, I  : Integer;
     R : TRect;
     OldPen, DashedPen : HPen;

  Procedure LineIt( P : PLPoint); Far;
  Begin
  LineTo ( PaintDC, X+P^.X, Y+P^.Y);
  End;
Begin
MoveTo ( PaintDC, X, Y);

  if  (WSInfo.Study=id_TransStab) and
      (WSInfo.TSInfo.OpenedLine<>-1) and
      (WSInfo.TSInfo.OpenedLine=WSInfo.NetWorkList^.IndexOf( @Self) )
                       then
                       begin
                       DashedPen:=CreatePen( PS_DASH, 1, $000000FF );
                       OldPen:=SelectObject( PaintDC, DashedPen);
                       { Paint with a Dashed Blue Pen }
                       LinePoints^.ForEach( @LineIt);
                       SelectObject( PaintDC, OldPen);
                       DeleteObject( DashedPen);
                       end
   else LinePoints^.ForEach( @LineIt); { en Noir }

{ le nom }
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_LineOn)<>id_LineOn)
    or (L=0) or (LinePoints^.Count=0) then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
I:=LinePoints^.Count div 2-1;
if I=-1 then OffSetRect( R,
                        PLPoint( LinePoints^.At(0))^.X div 2
                        +(R.left-R.right) div 2,
                        PLPoint( LinePoints^.At(0))^.Y div 2
                        +(R.top-R.bottom) div 2)
        else OffSetRect( R, (PLPoint( LinePoints^.At(I))^.X
                        +PLPoint( LinePoints^.At(I+1))^.X ) div 2
                        +(R.left-R.right) div 2,
                        (PLPoint( LinePoints^.At(I))^.Y
                        +PLPoint( LinePoints^.At(I+1))^.Y ) div 2
                        +(R.top-R.bottom) div 2);
DrawText( PaintDC, Name, L, R, DT_CENTER);
End;

Procedure TLine.PaintSelected( PaintDC : HDC; Var PaintInfo : TPaintStruct);
  Procedure SelectIt( P : PLPoint); Far;
  Begin
  Ellipse( PaintDC, X+P^.X-2, Y+P^.Y-2, X+P^.X+2, Y+P^.Y+2);
  End;
Begin
Ellipse( PaintDC, X-2,Y-2,X+2,Y+2);
LinePoints^.ForEach( @SelectIt);
End;

Function TLine.IsInIt( T : TPoint): Boolean;
Var R : TRect;

  Procedure AskIsInLine( P : PLPoint); Far;
  begin
  SetRect( R, X+P^.X-10, Y+P^.Y-10, X+P^.X+10, Y+P^.Y+10);
  If PtInRect( R, T) Then IsInIt:=True;
  end;

Begin
IsInIt:=False;
SetRect( R, X-10, Y-10, X+10, Y+10);
If PtInRect( R, T) Then IsInIt:=True;
LinePoints^.ForEach( @AskIsInLine);
End;
(*
Function TLine.IsInIt( T : TPoint): Boolean;
Var R : TRect;
    I : Integer;
    AX, AY, Car : Real;
    P1, P2     : PLPoint;
Begin
IsInIt:=False;
SetRect( R, X-5, Y-5, X+5, Y+5);
If PtInRect( R, T) Then IsInIt:=True;
{ Si juste un point => Exit}
if LinePoints^.Count=0 then exit;
P1:=LinePoints^.At(0);
AX:=P1^.X;
AY:=P1^.Y;
Car:=AX*AX+AY*AY;
if ( sqr( AX*T.Y-AY*T.X+AY*X-AX*Y )<=30*Car )
 {   and ( P1^.X*(T.X-X)+P1^.Y*(T.Y-Y)>=0)
    and ( P1^.X*(T.X-X-P1^.X)+P1^.Y*(T.Y-Y-P1^.Y)<=0)
 }                                       then IsInIt:=True;
for I:=0 to LinePoints^.Count-2 do
    begin
    P1:=LinePoints^.At(I);
    P2:=LinePoints^.At(I+1);
    AX:=P2^.X-P1^.X;
    AY:=P2^.Y-P1^.Y;
    Car:=AX*AX+AY*AY;
    if ( sqr( AX*T.Y-AY*T.X+AY*(X+P1^.X)-AX*(Y+P1^.Y) )<=30*Car )
{    and ( (P2^.X-P1^.X)*(T.X-X-P1^.X)+(P2^.Y-P1^.Y)*(T.Y-Y-P1^.Y)>=0 )
    and ( (P1^.X-P2^.X)*(T.X-X-P2^.X)+(P1^.Y-P2^.Y)*(T.Y-Y-P2^.Y)>=0 )
}                                        then IsInIt:=True;
    end;
End;
*)

Function TLine.AreYouIn( R : TRect): Boolean;
Var T : TPoint;

  Procedure AskAreInLine( P : PLPoint); Far;
  begin
  T.X:=X+P^.X;
  T.Y:=Y+P^.Y;
  If Not PtInRect( R, T) Then AreYouIn:=False;
  end;

Begin
T.X:=X;
T.Y:=Y;
AreYouIn:=True;
If Not PtInRect( R, T) Then AreYouIn:=False;
LinePoints^.ForEach( @AskAreInLine);
End;

Procedure TLine.UpDate( Decal : TPoint; UnDC : HDC; WSInfo : WorkSheetInfoRec;
                         Var R : TRect);
Var  R1, R2 : TRect;
     L, I   : Integer;

 Procedure UpDateMyR ( P : PLPoint); Far;
 begin
 SetRect( R1, X+P^.X-3, Y+P^.Y-3, X+P^.X+3, Y+P^.Y+3);
 UnionRect( R, R, R1);
 SetRect( R1, X+P^.X+Decal.X-3, Y+P^.Y+Decal.Y-3,
              X+P^.X+Decal.X+3, Y+P^.Y+Decal.Y+3);
 UnionRect( R, R, R1);
 end;

Begin
SetRect( R1, X-3, Y-3, X+3, Y+3);
UnionRect( R, R, R1);
SetRect( R1, X+Decal.X-3, Y+Decal.Y-3, X+Decal.X+3, Y+Decal.Y+3);
UnionRect( R, R, R1);
LinePoints^.ForEach( @UpDateMyR);
{ le nom }
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_LineOn)<>id_LineOn)
    or (L=0) or (LinePoints^.Count=0) then
                                      begin
                                      X:=X+Decal.X;
                                      Y:=Y+Decal.Y;
                                      exit;
                                      end;
{ partie speciale au nom : R1normal +R2 }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
I:=LinePoints^.Count div 2-1;
if I=-1 then OffSetRect( R1,
                         PLPoint( LinePoints^.At(0))^.X div 2
                         +(R2.left-R2.right) div 2,
                         PLPoint( LinePoints^.At(0))^.Y div 2
                         +(R2.top-R2.bottom) div 2)
        else OffSetRect( R1,
                        (PLPoint( LinePoints^.At(I))^.X
                        +PLPoint( LinePoints^.At(I+1))^.X ) div 2
                        +(R.left-R.right) div 2,
                        (PLPoint( LinePoints^.At(I))^.Y
                        +PLPoint( LinePoints^.At(I+1))^.Y ) div 2
                        +(R2.top-R2.bottom) div 2);
UnionRect( R, R, R1);
{ partie avec decalage}
CopyRect( R1, R2);
OffsetRect( R1, Decal.X, Decal.Y);
if I=-1 then OffSetRect( R1,
                         PLPoint( LinePoints^.At(0))^.X div 2
                         +(R2.left-R2.right) div 2,
                         PLPoint( LinePoints^.At(0))^.Y div 2
                         +(R2.top-R2.bottom) div 2)
        else OffSetRect( R1,
                        (PLPoint( LinePoints^.At(I))^.X
                        +PLPoint( LinePoints^.At(I+1))^.X ) div 2
                        +(R.left-R.right) div 2,
                        (PLPoint( LinePoints^.At(I))^.Y
                        +PLPoint( LinePoints^.At(I+1))^.Y ) div 2
                        +(R2.top-R2.bottom) div 2);
UnionRect( R, R, R1);
{ Update les coordonnees }
X:=X+Decal.X;
Y:=Y+Decal.Y;
End;

Procedure TLine.InvalidateLineRect( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                    Var R : TRect);
Var  R1, R2 : TRect;
     L, I   : Integer;
 Procedure InvLinePoints ( P : PLPoint); Far;
 begin
 SetRect( R1, X+P^.X-3, Y+P^.Y-3, X+P^.X+3, Y+P^.Y+3);
 UnionRect( R, R, R1);
 end;

Begin
SetRect( R1, X-3, Y-3, X+3, Y+3);
UnionRect( R, R, R1);
LinePoints^.ForEach( @InvLinePoints);
{ Invalider aussi la region du nom }
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_LineOn)<>id_LineOn)
    or (L=0) or (LinePoints^.Count=0) then exit;

SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
I:=LinePoints^.Count div 2-1;
if I=-1 then OffSetRect( R1,
                         PLPoint( LinePoints^.At(0))^.X div 2
                         +(R2.left-R2.right) div 2,
                         PLPoint( LinePoints^.At(0))^.Y div 2
                         +(R2.top-R2.bottom) div 2)
        else OffSetRect( R1,
                        (PLPoint( LinePoints^.At(I))^.X
                        +PLPoint( LinePoints^.At(I+1))^.X ) div 2
                        +(R.left-R.right) div 2,
                        (PLPoint( LinePoints^.At(I))^.Y
                        +PLPoint( LinePoints^.At(I+1))^.Y ) div 2
                        +(R2.top-R2.bottom) div 2);
UnionRect( R, R, R1);
End;

Procedure TLine.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec; Var R : TRect);
Begin
{ pas de rotation de ligne }
End;

Procedure TLine.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        MessageBox( GetFocus,
                        'A line has to be connected with a bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
Num:=NetWorkList^.IndexOf( @Self);

If (Con1<>-1) And (Con2=-1) Then
                            begin
                            Con2:=NetWorkList^.IndexOf( P);
                            { pas de connection avec le meme bus }
                            if Con2=Con1 then begin
                               Con2:=-1;
                               MessageBox( GetFocus,
                  'A line has to be connected with two different buses',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                               Exit;
                               end;
                            end
                       Else Begin
  { elemine toute connection anterieure : 0 ou 2 PBus^.Concoll^.->PCB }
                            NetWorkList^.FirstThat( @HasEqualPcbNum);
                            NetWorkList^.FirstThat( @HasEqualPcbNum);

                            Con1:=NetWorkList^.IndexOf( P);
                            Con2:=-1;
                            End;
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TLine.UpDateCon( Num : Integer);
Begin
If Con1=Num Then Con1:=-1;
If Con2=Num Then Con2:=-1;
If Con1>Num Then Dec(Con1);
If Con2>Num Then Dec(Con2);
End;

Procedure TLine.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     LineData : DlgLineRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'LineEdit'));
New(E, InitResource(D, id_Name, SizeOf(LineData.Name)));
New(E, InitResource(D, id_LZR, SizeOf(LineData.ZR)));
New(E, InitResource(D, id_LZX, SizeOf(LineData.ZX)));
New(E, InitResource(D, id_G, SizeOf(LineData.G)));
New(E, InitResource(D, id_B, SizeOf(LineData.B)));
New(E, InitResource(D, id_LSmax, SizeOf(LineData.Smax)));
New(E, InitResource(D, id_LCon1, SizeOf(LineData.Con1)));
New(S, InitResource(D, id_LCon2, SizeOf(LineData.Con2)));
StrCopy(LineData.Name, Name);
Str( ZR:7:5, LineData.ZR);
Str( ZX:7:5, LineData.ZX);
Str( G:7:5, LineData.G);
Str( B:7:5, LineData.B);
Str( Smax:7:5, LineData.Smax);
If Con1=-1 Then StrCopy( LineData.Con1, 'None')
          Else Begin
               StrCopy( LineData.Con1,
                PPowerComponent(NetWorkList^.At( Con1))^.Name );
             If StrComp(LineData.Con1,'')=0 Then StrCopy( LineData.Con1,
                                                 'No name entered');
               End;
If Con2=-1 Then StrCopy( LineData.Con2, 'None')
          Else Begin
               StrCopy( LineData.Con2,
                PPowerComponent(NetWorkList^.At( Con2))^.Name );
             If StrComp(LineData.Con2,'')=0 Then StrCopy( LineData.Con2,
                                                 'No name entered');
               End;


D^.TransferBuffer := @LineData;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,LineData.Name, 12);
                             Val( LineData.ZR, ZR, ValCode);
                             Val( LineData.ZX, ZX, ValCode);
                             Val( LineData.G, G, ValCode);
                             Val( LineData.B, B, ValCode);
                             Val( LineData.Smax, Smax, ValCode);
                             End;
End;

Procedure TLine.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con1:=-1;
Con2:=-1;
End;

Destructor TLine.Done;
Begin
  Dispose( LinePoints, Done);
  inherited Done;
End;

{ TCapa procedures }
Constructor TCapa.Init( AType : PowSymbType);
begin
Inherited Init( AType);
Bc:=0;
Con:=-1;    { non connecte }
End;

Constructor TCapa.Load ( Var S : TStream);
Begin
S.Read( HisType, SizeOf( HisType));
S.Read( X, SizeOf(X));
S.Read( Y, SizeOf(Y));
S.Read( Rotation, SizeOf(Rotation));
S.Read( Name, SizeOf(Name));
S.Read( Bc, SizeOf(Bc));
S.Read( Con, SizeOf(Con));
End;

Procedure TCapa.Store ( Var S : TStream);
Begin
S.Write( HisType, SizeOf( HisType));
S.Write( X, SizeOf(X));
S.Write( Y, SizeOf(Y));
S.Write( Rotation, SizeOf(Rotation));
S.Write( Name, SizeOf(Name));
S.Write( Bc, SizeOf(Bc));
S.Write( Con, SizeOf(Con));
End;

Procedure TCapa.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                        Var PaintInfo : TPaintStruct);
Var  L     : Integer;
     R, R1 : TRect;
Begin
inherited Paint( PaintDC, WSInfo, PaintInfo);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CapaOn)<>id_CapaOn)
          or (L=0)  then exit;
SetRect( R, X, Y, X, Y);
DrawText( PaintDC, Name, L, R, DT_CALCRECT);
CopyRect( R1, R);
Case Rotation of
          2 : OffsetRect( R1, 16-(R.right-R.left)div 2, R.top-R.bottom-1);
          3 : OffsetRect( R1, 33, 16-(R.bottom-R.top)div 2);
          0 : OffsetRect( R1, 16-(R.right-R.left)div 2, 33);
          1 : OffsetRect( R1, -R.right+R.left-1, 16-(R.bottom-R.top)div 2);
end;
DrawText( PaintDC, Name, L, R1, DT_CENTER);
End;

Procedure TCapa.UpDate( Decal : TPoint; UnDC : HDC;
                        WSInfo : WorkSheetInfoRec; Var R : TRect);
Var  R1, R2 : TRect;
     L     : Integer;
Begin
SetRect(R1, X, Y, X+32, Y+32);
UnionRect( R, R, R1);
SetRect(R1, X+Decal.X, Y+Decal.Y, X+Decal.X+32, Y+Decal.Y+32);
UnionRect( R, R, R1);

L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CapaOn)<>id_CapaOn)
          or (L=0)  then
                    begin
                    inherited UpDate( Decal, UnDC, WSInfo, R);
                    exit;
                    end;
{ partie speciale au nom : R1normal +R2 }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, L, R2, DT_CALCRECT);
{ partie sans decalage}
CopyRect( R1, R2);
Case Rotation of
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        3 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        1 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);
{ partie avec decalage}
CopyRect( R1, R2);
OffsetRect( R1, Decal.X, Decal.Y);
Case Rotation of
        2 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, R2.top-R2.bottom-1);
        3 : OffsetRect( R1, 33, 16-(R2.bottom-R2.top)div 2);
        0 : OffsetRect( R1, 16-(R2.right-R2.left)div 2, 33);
        1 : OffsetRect( R1, -R2.right+R2.left-1, 16-(R2.bottom-R2.top)div 2);
end;
UnionRect( R, R, R1);

inherited UpDate( Decal, UnDC, WSInfo, R);
End;

Procedure TCapa.Rotate( UnDC : HDC; WSInfo : WorkSheetInfoRec;
                                   Var R : TRect);
Var  R1, R2 : TRect;
     L   : Integer;
Begin
inherited Rotate( UnDC, WSInfo, R);
SetRect( R1, X,Y, X+32, Y+32);
UnionRect( R, R, R1);
L:=StrEnd(Name)-Name;
if ((WSInfo.WSOpt and id_CapaOn)<>id_CapaOn)
          or (L=0)  then exit;
{ partie speciale au nom }
SetRect(R2, X, Y, X, Y);
DrawText( UnDC, Name, StrEnd(Name)-Name, R2, DT_CALCRECT);
InflateRect( R1, 2*(R2.right-R2.left), 2*(R2.bottom-R2.top));
UnionRect( R, R, R1);
End;

Procedure TCapa.Connect( SelectedList, NetWorkList : PCollection);
Var  P   : PPowerComponent;
     PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
P:=SelectedList^.At(1);
If P^.HisType<>Bus Then begin
                        MessageBox( GetFocus,
                        'A Capa has to be connected with a bus',
                        'Connect Error', MB_Ok+MB_IconExclamation);
                        Exit;
                        end;
Num:=NetWorkList^.IndexOf( @Self);
{ verifie s'il etait deja connecte avec d'autres }
If Con<>-1 Then NetWorkList^.FirstThat( @HasEqualPcbNum);

Con:=NetWorkList^.IndexOf( P);
{ verifie s'il y est deja }
PBC:=New( PBusCon, Init( Num));
PBus(P)^.ConColl^.Insert(PBC);
End;

Procedure TCapa.UpDateCon( Num : Integer);
Begin
If Con=Num Then Con:=-1;
If Con>Num Then Dec(Con);
End;

Procedure TCapa.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgCapaRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'CapaEdit'));
New(E, InitResource(D, id_Name, SizeOf(Rec.Name)));
New(E, InitResource(D, 102, SizeOf(Rec.Bc)));
New(S, InitResource(D, 103, SizeOf(Rec.Con)));
StrCopy(Rec.Name, Name);
Str( Bc:7:5, Rec.Bc);
If Con=-1 Then StrCopy( Rec.Con, 'None')
          Else Begin
               StrCopy( Rec.Con,
                PPowerComponent(NetWorkList^.At( Con))^.Name );
               If StrComp(Rec.Con,'')=0 Then StrCopy( Rec.Con,
                                                 'No name entered');
               End;

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then
                             Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.Bc, Bc, ValCode);
                             End;
End;

Procedure TCapa.UnConnect( NetWorkList : PCollection);
Var  PBC : PBusCon;
     Num : Integer;

 Function HasEqualPcbNum( MyC : PPowerComponent): Boolean; Far;

   Function EqualNum( BusConElem : PBusCon): Boolean; Far;
   begin
   If BusConElem^.Con=Num Then EqualNum:=True
                          Else EqualNum:=False;
   end;
 Begin
 HasEqualPcbNum:=False;
 If MyC^.HisType<>Bus Then Exit;
 PBC:=PBus(MyC)^.ConColl^.FirstThat( @EqualNum);
 If PBC<> Nil Then Begin
                   HasEqualPcbNum:=True;
                   PBus(MyC)^.ConColl^.Free( PBC);
                   End;
 End;

Begin
Num:=NetWorkList^.IndexOf( @Self);
NetWorkList^.FirstThat( @HasEqualPcbNum);
Con:=-1;
End;


End.