{ This Unit contains the special ( suplement ) Power Component objects
  for transient stability studies
  for the power designer V1.20 program
   Links = Lines sans Power Data ( draw only )
   Resistance, SelfInd = dervied from Transfo
}
unit SpeComp;

{$R SPECOMP.RES }

interface
uses WinTypes, WinProcs,OWindows, ODialogs, Strings, Objects,
     PowComp;

const
{ SpeGeneratorEdit }
{ id_Name      = 101; deja declare }
  id_SpeH      = 102;
  id_SpeD      = 103;
  id_SpeR      = 104;
  id_SpeXdp    = 105;

Type
     DlgSpeGeneratorRec = Record
     Name , H, D, R, Xdp : Array[0..30] of Char;
     end;

     DlgResistanceRec = record
     Name, Zelem, Con1, Con2 : Array[0..30] of Char;
     end;

     DlgLinkRec = Record
     Ep1, Ep2, Ep3, Ep4,
     Black, Red, Green, Blue : Bool;
     end;

     PSpeGenerator = ^TSpeGenerator;
     TSpeGenerator = Object( TGenerator)
     H, D, R, Xdp  : Real;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     End;

     PSpeCompensator = ^TSpeCompensator;
     TSpeCompensator = Object( TCompensator)
     H, D, R, Xdp  : Real;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     End;

     PResistance = ^TResistance;
     TResistance = Object( TTransfo)
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     End;

     PSelfInd = ^TSelfInd;
     TSelfInd = Object( TTransfo)
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     End;

     PLink = ^TLink;
     TLink = Object( TLine)
     Epaisseur : Word;
     Couleur : TColorRef;
     Constructor Init( AType : PowSymbType);
     Constructor Load ( Var S : TStream);
     Procedure Store ( Var S : TStream); Virtual;
     Procedure Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                      Var PaintInfo : TPaintStruct); Virtual;
     Procedure Edit( PWork : PWindowsObject; NetWorkList : PCollection
                    ; Study : Word); Virtual;
     Procedure Connect( SelectedList, NetWorkList : PCollection);
              Virtual;
     Procedure UpDateCon( Num : Integer); Virtual;
     Procedure UnConnect( NetWorkList : PCollection); Virtual;
     End;


Const

 RSpeGenerator : TStreamRec = (
     ObjType : 160;
     VmtLink : Ofs( TypeOf(TSpeGenerator)^);
     Load : @TSpeGenerator.Load;
     Store : @TSpeGenerator.Store );

 RSpeCompensator : TStreamRec = (
     ObjType : 161;
     VmtLink : Ofs( TypeOf(TSpeCompensator)^);
     Load : @TSpeCompensator.Load;
     Store : @TSpeCompensator.Store );

 RResistance : TStreamRec = (
     ObjType : 162;
     VmtLink : Ofs( TypeOf(TResistance)^);
     Load : @TResistance.Load;
     Store : @TResistance.Store );

 RSelfInd : TStreamRec = (
     ObjType : 163;
     VmtLink : Ofs( TypeOf(TSelfInd)^);
     Load : @TSelfInd.Load;
     Store : @TSelfInd.Store );

 RLink : TStreamRec = (
     ObjType : 164;
     VmtLink : Ofs( TypeOf(TLink)^);
     Load : @TLink.Load;
     Store : @TLink.Store );

{   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  il ne faut pas oublier de les registrer
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
}

implementation

{ TSpeGenerator procedures }
Constructor TSpeGenerator.Init( AType : PowSymbType);
begin
Inherited Init( AType);
H:=0;
D:=0;
R:=0;
Xdp:=0;
End;

Constructor TSpeGenerator.Load ( Var S : TStream);
Begin
TGenerator.Load( S);
S.Read( H, SizeOf( H));
S.Read( D, SizeOf( D));
S.Read( R, SizeOf(R));
S.Read( Xdp, SizeOf(Xdp));
End;

Procedure TSpeGenerator.Store ( Var S : TStream);
Begin
TGenerator.Store( S);
S.Write( H, SizeOf( H));
S.Write( D, SizeOf( D));
S.Write( R, SizeOf(R));
S.Write( Xdp, SizeOf(Xdp));
End;

Procedure TSpeGenerator.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  DL : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgSpeGeneratorRec;
     ValCode : Integer;

Begin
{ Si etude de Load Flow appelle edit de papa }
if Study=1 then begin
                inherited Edit( PWork, NetWorkList, Study);
                exit;
                end;
DL:=New( PDialog, Init( PWork, 'SpeMachineEdit'));
New(E, InitResource(DL, id_Name, SizeOf(Rec.Name)));
New(E, InitResource(DL, id_SpeH, SizeOf(Rec.H)));
New(E, InitResource(DL, id_SpeD, SizeOf(Rec.D)));
New(E, InitResource(DL, id_SpeR, SizeOf(Rec.R)));
New(E, InitResource(DL, id_SpeXdp, SizeOf(Rec.Xdp)));
StrCopy(Rec.Name, Name);
Str( H:7:5, Rec.H);
Str( D:7:5, Rec.D);
Str( R:7:5, Rec.R);
Str( Xdp:7:5, Rec.Xdp);

DL^.TransferBuffer := @Rec;

If Application^.ExecDialog(DL)<>idCancel
                             Then Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.H, H, ValCode);
                             Val( Rec.D, D, ValCode);
                             Val( Rec.R, R, ValCode);
                             Val( Rec.Xdp, Xdp, ValCode);
                             End;
End;

{ TSpeCompensator procedures }
Constructor TSpeCompensator.Init( AType : PowSymbType);
begin
Inherited Init( AType);
H:=0;
D:=0;
R:=0;
Xdp:=0;
End;

Constructor TSpeCompensator.Load ( Var S : TStream);
Begin
Inherited Load( S);
S.Read( H, SizeOf( H));
S.Read( D, SizeOf( D));
S.Read( R, SizeOf(R));
S.Read( Xdp, SizeOf(Xdp));
End;

Procedure TSpeCompensator.Store ( Var S : TStream);
Begin
Inherited Store( S);
S.Write( H, SizeOf( H));
S.Write( D, SizeOf( D));
S.Write( R, SizeOf(R));
S.Write( Xdp, SizeOf(Xdp));
End;

Procedure TSpeCompensator.Edit( PWork : PWindowsObject;
                                NetWorkList : PCollection; Study : Word);
Var  DL : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgSpeGeneratorRec;
     ValCode : Integer;

Begin
{ Si etude de Load Flow appelle edit de papa }
if Study=1 then begin
                inherited Edit( PWork, NetWorkList, Study);
                exit;
                end;
DL:=New( PDialog, Init( PWork, 'SpeMachineEdit'));
New(E, InitResource(DL, id_Name, SizeOf(Rec.Name)));
New(E, InitResource(DL, id_SpeH, SizeOf(Rec.H)));
New(E, InitResource(DL, id_SpeD, SizeOf(Rec.D)));
New(E, InitResource(DL, id_SpeR, SizeOf(Rec.R)));
New(E, InitResource(DL, id_SpeXdp, SizeOf(Rec.Xdp)));
StrCopy(Rec.Name, Name);
Str( H:7:5, Rec.H);
Str( D:7:5, Rec.D);
Str( R:7:5, Rec.R);
Str( Xdp:7:5, Rec.Xdp);

DL^.TransferBuffer := @Rec;

If Application^.ExecDialog(DL)<>idCancel
                             Then Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.H, H, ValCode);
                             Val( Rec.D, D, ValCode);
                             Val( Rec.R, R, ValCode);
                             Val( Rec.Xdp, Xdp, ValCode);
                             End;
End;

{ TResistance procedures }
Constructor TResistance.Init( AType : PowSymbType);
begin
Inherited Init( AType);
End;

Constructor TResistance.Load ( Var S : TStream);
Begin
Inherited Load( S);
End;

Procedure TResistance.Store ( Var S : TStream);
Begin
Inherited Store( S);
End;

Procedure TResistance.Edit( PWork : PWindowsObject;
                          NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgResistanceRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'ResistanceEdit'));
New(E, InitResource(D, 101, SizeOf(Rec.Name)));
New(E, InitResource(D, 102, SizeOf(Rec.Zelem)));
New(S, InitResource(D, 103, SizeOf(Rec.Con1)));
New(S, InitResource(D, 104, SizeOf(Rec.Con2)));

StrCopy(Rec.Name, Name);
Str( ZR:7:5, Rec.ZElem);
If Con1=-1 Then StrCopy( Rec.Con1, 'None')
          Else Begin
               StrCopy( Rec.Con1,
                PPowerComponent(NetWorkList^.At( Con1))^.Name );
             If StrComp(Rec.Con1,'')=0 Then StrCopy( Rec.Con1,
                                                 'No name entered');
               End;
If Con2=-1 Then StrCopy( Rec.Con2, 'None')
          Else Begin
               StrCopy( Rec.Con2,
                PPowerComponent(NetWorkList^.At( Con2))^.Name );
             If StrComp(Rec.Con2,'')=0 Then StrCopy( Rec.Con2,
                                                 'No name entered');
               End;

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.ZElem, ZR, ValCode);
                             End;
End;

{ TSelfInd procedures }
Constructor TSelfInd.Init( AType : PowSymbType);
begin
Inherited Init( AType);
End;

Constructor TSelfInd.Load ( Var S : TStream);
Begin
Inherited Load( S);
End;

Procedure TSelfInd.Store ( Var S : TStream);
Begin
Inherited Store( S);
End;

Procedure TSelfInd.Edit( PWork : PWindowsObject;
                          NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     E : PEdit;
     S : PStatic;
     Rec : DlgResistanceRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'SelfIndEdit'));
New(E, InitResource(D, 101, SizeOf(Rec.Name)));
New(E, InitResource(D, 102, SizeOf(Rec.Zelem)));
New(S, InitResource(D, 103, SizeOf(Rec.Con1)));
New(S, InitResource(D, 104, SizeOf(Rec.Con2)));

StrCopy(Rec.Name, Name);
Str( ZX:7:5, Rec.ZElem);
If Con1=-1 Then StrCopy( Rec.Con1, 'None')
          Else Begin
               StrCopy( Rec.Con1,
                PPowerComponent(NetWorkList^.At( Con1))^.Name );
             If StrComp(Rec.Con1,'')=0 Then StrCopy( Rec.Con1,
                                                 'No name entered');
               End;
If Con2=-1 Then StrCopy( Rec.Con2, 'None')
          Else Begin
               StrCopy( Rec.Con2,
                PPowerComponent(NetWorkList^.At( Con2))^.Name );
             If StrComp(Rec.Con2,'')=0 Then StrCopy( Rec.Con2,
                                                 'No name entered');
               End;

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             StrLCopy(Name,Rec.Name, 12);
                             Val( Rec.ZElem, ZX, ValCode);
                             End;
End;

{ TLink procedures }
Constructor TLink.Init( AType : PowSymbType);
begin
Inherited Init( AType);
Epaisseur:=1;
Couleur:=$00000000; { Black }
End;

Constructor TLink.Load ( Var S : TStream);
Begin
Inherited Load( S);
S.Read( Epaisseur, SizeOf( Epaisseur));
S.Read( Couleur, SizeOf( Couleur));
End;

Procedure TLink.Store ( Var S : TStream);
Begin
Inherited Store( S);
S.Write( Epaisseur, SizeOf( Epaisseur));
S.Write( Couleur, SizeOf( Couleur));
End;

Procedure TLink.Paint( PaintDC : HDC; WSInfo : WorkSheetInfoRec;
                        Var PaintInfo : TPaintStruct);
Var  L, I  : Integer;
     R : TRect;
     OldPen, NewPen : HPen;

  Procedure LineIt( P : PLPoint); Far;
  Begin
  LineTo ( PaintDC, X+P^.X, Y+P^.Y);
  End;
Begin
MoveTo ( PaintDC, X, Y);
{ Paint with a Black Pen with the right thikness }
NewPen:=CreatePen( PS_SOLID, Epaisseur, Couleur);
OldPen:=SelectObject( PaintDC, NewPen);
LinePoints^.ForEach( @LineIt);
SelectObject( PaintDC, OldPen);
DeleteObject( NewPen);
End;

Procedure TLink.Edit( PWork : PWindowsObject;
                          NetWorkList : PCollection; Study : Word);
Var  D : PDialog;
     R : PRadioButton;
     Rec : DlgLinkRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( PWork, 'LinkEdit'));
New(R, InitResource(D, 101));
New(R, InitResource(D, 102));
New(R, InitResource(D, 103));
New(R, InitResource(D, 104));
New(R, InitResource(D, 105));
New(R, InitResource(D, 106));
New(R, InitResource(D, 107));
New(R, InitResource(D, 108));

If Epaisseur=1 Then Begin
               Rec.Ep1:=True;
               Rec.Ep2:=False;
               Rec.Ep3:=False;
               Rec.Ep4:=False;
               End;
If Epaisseur=2 Then Begin
               Rec.Ep1:=False;
               Rec.Ep2:=True;
               Rec.Ep3:=False;
               Rec.Ep4:=False;
               End;
If Epaisseur=3 Then Begin
               Rec.Ep1:=False;
               Rec.Ep2:=False;
               Rec.Ep3:=True;
               Rec.Ep4:=False;
               End;
If Epaisseur=4 Then Begin
               Rec.Ep1:=False;
               Rec.Ep2:=False;
               Rec.Ep3:=False;
               Rec.Ep4:=True;
               End;
If Couleur=$00000000 Then Begin
                     Rec.Black:=True;
                     Rec.Red  :=False;
                     Rec.Green:=False;
                     Rec.Blue :=False;
                     End;
If Couleur=$000000FF Then Begin
                     Rec.Black:=False;
                     Rec.Red  :=True;
                     Rec.Green:=False;
                     Rec.Blue :=False;
                     End;
If Couleur=$0000FF00 Then Begin
                     Rec.Black:=False;
                     Rec.Red  :=False;
                     Rec.Green:=True;
                     Rec.Blue :=False;
                     End;
If Couleur=$00FF0000 Then Begin
                     Rec.Black:=False;
                     Rec.Red  :=False;
                     Rec.Green:=False;
                     Rec.Blue :=True;
                     End;
D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             If Rec.Ep1  Then Epaisseur:=1;
                             If Rec.Ep2  Then Epaisseur:=2;
                             If Rec.Ep3  Then Epaisseur:=3;
                             If Rec.Ep4  Then Epaisseur:=4;
                             If Rec.Black=True Then Couleur:=$00000000;
                             If Rec.Red  =True Then Couleur:=$000000FF;
                             If Rec.Green=True Then Couleur:=$0000FF00;
                             If Rec.Blue =True Then Couleur:=$00FF0000;
                             End;
End;

Procedure TLink.Connect( SelectedList, NetWorkList : PCollection);
Begin
MessageBox( GetFocus,
'A link is a only drawing object and cannot be connected to a power component',
            'Connect Error', MB_Ok+MB_IconExclamation);
End;

Procedure TLink.UpDateCon( Num : Integer);
Begin
End;

Procedure TLink.UnConnect( NetWorkList : PCollection);
Begin
End;


End.