//---------------------------------------------------------------------------
#include <vcl.h>

//#include <stdio.h>
//#include <dir.h>
#include "transtab.h"

#ifndef __TSDERIVE_H
#include "tsderive.h"
#endif

#pragma hdrstop
USERES("transtab.res");
USEFORM("Progress.cpp", ProgressForm);
USEUNIT("Ts.cpp");
USEUNIT("Tsderive.cpp");
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
        try
        {
                 Application->Initialize();
                 Application->Run();
        if (ParamCount()==4)
          {
          AnsiString SS( LowerCase(ParamStr(1)));
          int TSint=SS.ToInt();
          AnsiString InN( LowerCase(ParamStr(2)));
          AnsiString OutN( LowerCase(ParamStr(3)));
          AnsiString GraphN( LowerCase(ParamStr(4)));
          CallTransStab( TSint, InN.c_str(), OutN.c_str(), GraphN.c_str() );
          }

        }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
        return 0;
}
//---------------------------------------------------------------------------



/*  Programme de stabilite transitoire
	 Pour Power Designer V1.40
	 Pour BC++ Builder 4 et sous Windows ( DLL functions )
*/


// Trans Stab function
int CallTransStab( int TSint, char * InN, char * OutN, char * GraphN)
{
/*
Application->MessageBox("Hi I am Called !!\n\nProgramed by Lotfi BAGHLI\n\n\nJune 1999",
				"About DLL Called", MB_OK | MB_ICONINFORMATION);
*/
TTS * TSProg;
  switch( TSint)
	{
	case id_Euler :	        TSProg=new TEuler( InN, OutN, GraphN ); break;
	case id_Trapeze :	TSProg=new TTrapeze( InN, OutN, GraphN ); break;
	case id_RK4 :		TSProg=new TRK4( InN, OutN, GraphN ); break;
	default :	return TSAllocError;
	}
if (TSProg==NULL) {
                Application->MessageBox( "Out of memory error",
					"Error in calling the Transient Stability Program",
				MB_OK+MB_ICONEXCLAMATION);
				exit(1);
				}
// TSType=TSint
TSProg->Lecture();
//	Application->MessageBox( "Lecture OK", "Transient Stability PROGRAM", MB_OK);
TSProg->Run();
//	Application->MessageBox( "Run OK", "Transient Stability PROGRAM", MB_OK);

int ReturnFlag=TSProg->IsItOK();
// cette ligne cause pb
//delete TSProg;

	char SS[MAXPATH];
	strcpy( SS, "notepad.exe ");
	strcat( SS, OutN);
	WinExec( SS, SW_SHOW);

	strcpy( SS, "graphd.exe ");
	strcat( SS, GraphN);
	WinExec( SS, SW_SHOW);

return ReturnFlag;
}

