{ This Unit contains the TDesigner MDIWindow object and its methods
  for the power.pas V1.30 program
 This Unit contains the TWorkSheet object and its methods
  for the power.pas V1.30 program
  LoadFlow and Transient Stability Studies ( for WINDOWS 3.x )
                         28 Aout 1994
                         rev 12 feb 1996        V1.30 DLLs for LF & TS
                         rev 21 jun 1999        V1.40 Exes for LF & TS
}
unit WSheet;

interface
Uses WinTypes, WinProcs, OWindows, ODialogs, Strings, Objects, WinDos,
     OStdDlgs, OPrinter, Win31, PowComp, SpeComp, Ruban, PowHelp,
     WinCrt;

Const
  { for TDesigner }
  cm_Open   = 102;

  cm_Content      = 201;
  cm_HelpKeyBoard = 202;
  cm_HelpHelp     = 203;
  cm_About        = 204;

  { for TWorkSheet }
  cm_Save   = 103;
  cm_SaveAs = 104;
  cm_Print  = 105;
  cm_Setup  = 106;

  cm_LoadFlowStudy  = 191;
  cm_TransStabStudy = 192;

  cm_MakeData = 151;
  cm_GaussSeidel = 152;
  cm_NewtonRaphson = 153;
  cm_NewtonRaphsonBackOff = 154;
  cm_FDL       = 155;
  cm_OutputData= 156;
  cm_Informations = 140;

  cm_TSP        = 171;
  cm_TSPT       = 179;
  cm_RK         = 180;
  cm_PlotResult = 172;
  cm_FaultBus   = 173;
  cm_OpenLine   = 174;
  cm_MonitorBus = 175;
  cm_SwitchLoad = 176;
  cm_DropLoad   = 177;
  cm_LossGen    = 178;
  cm_ClearAll   = 181;

  cm_OptWorkSheet=161;
  cm_OptFileNames=162;
  cm_OptLoadFlow =163;
  cm_OptTransStab=164;
  cm_OptTransStabOut=165;

  cm_Generator = 301;
  cm_Bus       = 302;
  cm_Line      = 303;
  cm_Transfo   = 304;
  cm_Drain     = 305;
  cm_Compensator=306;
  cm_Capa      = 307;
  cm_Resistance= 308;
  cm_SelfInd   = 309;
  cm_Link      = 310;

  cm_Rotate    = 401;
  cm_ModifyLine= 407;
  cm_Delete    = 402;
  cm_Connect   = 403;
  cm_Edit      = 404;
  cm_SelectArea= 408;
  cm_UnConnect = 405;
  cm_SelectAll = 406;
{
  Cut, Copy and Paste internes
}
{ OptFileNames }
  id_InName    = 101;
  id_OutName   = 102;

{ Load flow options }
  id_GS_IterMax= 101;
  id_GS_Tol    = 102;
  id_GS_AccelFact=103;
  id_NR_IterMax= 104;
  id_NR_Tol    = 105;

  id_YMatrix   = 106;
  id_KL_YL     = 107;
  id_Jacobien  = 108;
  id_SLineMax  = 109;
  id_Sg_Sd     = 110;
  id_LineTrans = 111;
  id_V         = 112;
  id_VAux      = 113;
  id_Arrilaga  = 114;

  id_YMatrixOut  =   1;
  id_KL_YLOut    =   2;
  id_JacobienOut =   4;
  id_SLineMaxOut =   8;
  id_Sg_SdOut    =  16;
  id_LineTransOut=  32;
  id_V_Out       =  64;
  id_VAux_Out    = 128;
  id_ArrilagaOut = 256;
{ TS Output Options }
  id_TSYMatrixOut =  1;
  id_TSMachine    =  2;
  id_TSVAuxOut    =  4;
  id_TSLFError    =  8;
  id_TSTrapeze    = 16;

{ WorkSheet options
  id_GeneratorOn   =   1;
  id_BusOn         =   2;
  id_LineOn        =   4;
  id_TransfoOn     =   8;
  id_DrainOn       =  16;
  id_CompensatorOn =  32;
  id_CapaOn        =  64;
  id_Moveable      = 128;
}

type
     WSOptRec= Record
     Generator, Bus, Line, Transfo, Drain, Compensator, Capa,
     Moveable   : BOOL;
     Width, Height   : Array[0..30] of Char;
     end;

     LFOptionsRec = Record
     GS_IterMax, GS_Tol, GS_AccelFact,
     NR_IterMax, NR_Tol               : Array[0..30] of Char;
     YMatrix, KL_YL, Jacobien, SLineMax, Sg_Sd, LineTrans,
     V, VAux, Arrilaga         : BOOL
     end;

     TSOutOptionsRec = Record
     YMatrix, Machine, VAux, LFError, Trapeze   : BOOL
     end;

     DlgFileNamesRec = Record
     InName, OutName : Array[0..fsPathName] of Char;
     end;

     DlgSTFileNamesRec = Record
     InName, OutName, ResultName : Array[0..fsPathName] of Char;
     end;

     TSOptionsRec  = Record
     eps, NIterMax, Tol,
     freq, dt, t2,
     FBt0, FBt1, Gf, Bf,
     OLt0, OLt1,
     SLt0, SLt1, SLPL, SLQL,
     DLt0, DLt1, DLPL, DLQL,
     LGt0, LGt1   : Array[0..30] of Char;
     FaultCode    : Array[0..400] of Char;
     end;

    PWorkSheet = ^TWorkSheet;
    TWorkSheet = object(TWindow)
    DragDC: HDC;
    FileName, InName, OutName,
    TSInName, TSOutName,TSResultName   : Array [0..fsPathName] of char;
    GS_IterMax, NR_IterMax : Integer;
    GS_Tol, GS_AccelFact, NR_Tol : Real;
    LFOpt, TSOpt   : Word;
    WSInfo  :  WorkSheetInfoRec; { Voir sa def dans WSHEET19.PAS }

    Hcroix, HSaveCursor : HCursor;
    LButtonDown, HasChanged, IsNewFile,
    FirstPlace, LineCreating, ModifyLine,
    ControlOn, SelectArea, Recup, VoltageKnown    : Boolean;
    CapturedPoint            : PLPoint;
    Prec, Actuel, Old, OldM : TPoint;
    Order, Rep              : Integer;
    Printer: PPrinter;
    NetWork, SelectedComponents,
    BusColl, MonitoredBuses        : PCollection;

    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    destructor Done; virtual;
    function CanClose: Boolean; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    procedure WMLButtonDown(var Msg: TMessage);
      virtual wm_First + wm_LButtonDown;
    procedure LButtonDownAct;
    procedure WMLButtonUp(var Msg: TMessage);
      virtual wm_First + wm_LButtonUp;
    procedure LButtonUpAct;
    procedure WMRButtonDown(var Msg: TMessage);
      virtual wm_First + wm_RButtonDown;
    procedure RButtonDownAct;
    procedure WMMouseMove(var Msg: TMessage);
      virtual wm_First + wm_MouseMove;
    Procedure DrawCapture;
    Procedure MoveComponent ( Decal : TPoint);
    Procedure ConvertRect( Var R : TRect);

{    procedure WMInitMenu( var Msg: TMessage);
      virtual wm_First + WM_INITMENU;
}    procedure WMActivate( var Msg: TMessage);
      virtual wm_First +wm_Activate;
    procedure SetNames(NewName: PChar);

    procedure FileSave(var Msg: TMessage);
      virtual cm_First + cm_Save;
    procedure FileSaveAs(var Msg: TMessage);
      virtual cm_First + cm_SaveAs;
    function LoadFile : Integer; { V1.19 only }
    procedure SaveFile;          { V1.19 only }
    procedure CMPrint(var Msg: TMessage);
      virtual cm_First + cm_Print;
    procedure CMSetup(var Msg: TMessage);
      virtual cm_First + cm_Setup;
    Procedure Paint( PaintDC : HDC; Var PaintInfo : TPaintStruct); virtual;

    Procedure NoMoreMemory;
    function IsItFixed : Boolean;
    Procedure CMCreGenerator(var Msg: TMessage);
      virtual cm_First + cm_Generator;
    Procedure CMCreCompensator(var Msg: TMessage);
      virtual cm_First + cm_Compensator;
    Procedure CMCreBus(var Msg: TMessage);
      virtual cm_First + cm_Bus;
    Procedure CMCreLine(var Msg: TMessage);
      virtual cm_First + cm_Line;
    Procedure CMCreTransfo(var Msg: TMessage);
      virtual cm_First + cm_Transfo;
    Procedure CMCreDrain(var Msg: TMessage);
      virtual cm_First + cm_Drain;
    Procedure CMCreCapa(var Msg: TMessage);
      virtual cm_First + cm_Capa;
    Procedure CMCreResistance(var Msg: TMessage);
      virtual cm_First + cm_Resistance;
    Procedure CMCreSelfInd(var Msg: TMessage);
      virtual cm_First + cm_SelfInd;
    Procedure CMCreLink(var Msg: TMessage);
      virtual cm_First + cm_Link;

    Procedure CreateComponent ( MyComponent : PPowerComponent);
    Procedure Rotate(var Msg: TMessage);
      virtual cm_First + cm_Rotate;

    Procedure CMModifyLine(var Msg: TMessage);
      virtual cm_First + cm_ModifyLine;
    Procedure WMKeyDown(var Msg: TMessage);
      virtual wm_First + WM_KEYDOWN;
    Procedure WMKeyUp(var Msg: TMessage);
      virtual wm_First + WM_KEYUp;
    Procedure InsertPoint;
    Procedure DeletePoint;

    Procedure Performdelete;
    Procedure Delete(var Msg: TMessage);
      virtual cm_First + cm_Delete;
    Procedure Connect(var Msg: TMessage);
      virtual cm_First + cm_Connect;
    Procedure Edit(var Msg: TMessage);
      virtual cm_First + cm_Edit;
    Procedure CMSelectArea(var Msg: TMessage);
      virtual cm_First + cm_SelectArea;
    Procedure UnConnect(var Msg: TMessage);
      virtual cm_First + cm_UnConnect;
    Procedure SelectAll(var Msg: TMessage);
      virtual cm_First + cm_SelectAll;

    procedure CMEditCut(var Msg: TMessage);
      virtual cm_First + cm_EditCut;
    procedure CMEditCopy(var Msg: TMessage);
      virtual cm_First + cm_EditCopy;
    procedure PerformEditCopy;
    procedure CMEditPaste(var Msg: TMessage);
      virtual cm_First + cm_EditPaste;

    Procedure MakeData(var Msg: TMessage);
      virtual cm_First + cm_MakeData;
{ Load Flow Simulation Calls }
    Function IsStudyLoadFlow : Boolean;
    Procedure GaussSeidelCall(var Msg: TMessage);
      virtual cm_First + cm_GaussSeidel;
    Procedure NewtonRaphsonCall(var Msg: TMessage);
      virtual cm_First + cm_NewtonRaphson;
    Procedure NRBackOffCall(var Msg: TMessage);
      virtual cm_First + cm_NewtonRaphsonBackOff;
    Procedure FDLCall(var Msg: TMessage);
      virtual cm_First + cm_FDL;
    Procedure LFOutPutData;
    Procedure TSOutPutData;
    Procedure OutPutDataCall(var Msg: TMessage);
      virtual cm_First + cm_OutputData;
    Procedure CMInfos(var Msg: TMessage);
      virtual cm_First + cm_Informations;

    Procedure CMLoadFlowStudy(var Msg: TMessage);
      virtual cm_First +  cm_LoadFlowStudy;
    Procedure CMTransStabStudy(var Msg: TMessage);
      virtual cm_First +  cm_TransStabStudy;

    Procedure WorkSheetOpt(var Msg: TMessage);
      virtual cm_First +  cm_OptWorkSheet;

    Procedure LFFileNames;
    Procedure STFileNames;
    Procedure OptFileNames(var Msg: TMessage);
      virtual cm_First +  cm_OptFileNames;

    Procedure LoadFlowOptions(var Msg: TMessage);
      virtual cm_First +  cm_OptLoadFlow;
    Procedure TransStabOptions(var Msg: TMessage);
      virtual cm_First + cm_OptTransStab;
    Procedure TransStabOutputOptions(var Msg: TMessage);
      virtual cm_First + cm_OptTransStabOut;
{ Transient Stability Simulation Calls }
      Function IsStudyTransStab : Boolean;
      Procedure CMFaultBus(var Msg: TMessage);
      virtual cm_First + cm_FaultBus;
      Procedure CMOpenLine(var Msg: TMessage);
      virtual cm_First + cm_OpenLine;
      Procedure CMSwitchLoad(var Msg: TMessage);
      virtual cm_First + cm_SwitchLoad;
      Procedure CMDropLoad(var Msg: TMessage);
      virtual cm_First + cm_DropLoad;
      Procedure CMLossGen(var Msg: TMessage);
      virtual cm_First + cm_LossGen;
      Procedure CMClearAll(var Msg: TMessage);
      virtual cm_First + cm_ClearAll;

      Procedure CMMonitorBus(var Msg: TMessage);
      virtual cm_First + cm_MonitorBus;
      Procedure CMTSP(var Msg: TMessage);
      virtual cm_First + cm_TSP;
      Procedure CMTSPT(var Msg: TMessage);
      virtual cm_First + cm_TSPT;
      Procedure CMRK(var Msg: TMessage);
      virtual cm_First + cm_RK;

    Procedure CMPlotResult(var Msg: TMessage);
      virtual cm_First + cm_PlotResult;
    End;

    PDesigner = ^TDesigner;
    TDesigner = object(TMDIWindow)
     StatusLine : PRibbonWindow;
     constructor Init(ATitle: PChar; AMenu: HMenu);
     procedure WMDestroy(var Msg: TMessage);
       virtual wm_First + wm_Destroy;
     destructor Done; virtual;
     procedure SetInfoFlag( PWS : PWorkSheet );
     procedure SetStudyFlag( PWS : PWorkSheet );
     procedure AdjustMenu( PWS : PWorkSheet );
     procedure ModifMenuToLoadFlow;
     procedure ModifMenuToTransStab;

     procedure SetUpWindow; virtual;
     procedure FileOpen(var Msg: TMessage);
       virtual cm_First + cm_Open;
     procedure CMHelpContent(var Msg: TMessage);
       virtual cm_First + cm_Content;
     procedure CMHelpKeyBoard(var Message: TMessage);
       virtual cm_First + cm_HelpKeyBoard;
     procedure CMHelpHelp(var Message: TMessage);
       virtual cm_First + cm_HelpHelp;
     procedure CMAbout(var Msg: TMessage);
       virtual cm_First + cm_About;
     function InitChild: PWindowsObject; virtual;
     procedure WMMenuSelect(var Msg: TMessage);
       virtual wm_First + wm_MenuSelect;
     procedure WMSize(var Msg: TMessage);
       virtual wm_First + wm_Size;
     procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    end;

implementation

{ TWorkSheet procedures }
Constructor TWorksheet.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  Inherited Init(AParent, ATitle);
  EnableAutoCreate;
  LButtonDown := False;
  HasChanged := False;
  IsNewFile := True;
  FirstPlace:=False;
  LineCreating:=False;
  ModifyLine:=False;
  ControlOn:=False;
  SelectArea:=False;
  Recup:=False;
  VoltageKnown:=False;
  CapturedPoint:=nil;
SetNames (ATitle);
  NetWork := New(PCollection, Init(50, 10));
  WSInfo.NetWorkList:=NetWork;
  SelectedComponents := New(PCollection, Init(5, 5));
  BusColl := New(PCollection, Init(20, 20));
  MonitoredBuses:= New(PCollection, Init(4, 0));
  Printer:=New( PPrinter, Init);
  Scroller := New( PScroller, Init(@Self, 10, 10, 100, 100));
  Order:=0;
  with Scroller^ do
  begin
    HasHScrollBar := True;
    HasVScrollBar := True;
  end;
HCroix:=LoadCursor(0,IDC_Cross);
GS_IterMax:=25;
GS_Tol:=0.005;
GS_AccelFact:=1.0;
NR_IterMax:=10;
NR_Tol:=0.01;
WSInfo.WSOpt:=id_BusOn+id_Moveable;
LFOpt:=id_YMatrixOut+id_Sg_SdOut+id_V_Out+id_ArrilagaOut;
TSOpt:=0;    { pas de sortie sur .TSO }
with WSInfo.TSInfo do
 begin
 Code:=0;  { no Fault }
 freq:=50;
 dt:=0.02; t2:=0.90;
 FBt0:=0.0; FBt1:=0.1;
 Gf:=1E20; Bf:=1E20;
 OLt0:=0.0; OLt1:=0.1;
 SLt0:=0.0; SLt1:=0.1;
 DLt0:=0.0; DLt1:=0.1;
 LGt0:=0.0; LGt1:=0.1;
 Tol:=0.001; eps:=0.001;
 FaultedBus:=-1;
 OpenedLine:=-1;
 SwitchedLoad:=-1; SLPL:=0.; SLQL:=0.;
 DroppedLoad:=-1;  DLPL:=0.; DLQL:=0.; { not specified }
 LossGen:=-1;
 NIterMax:=25;
 end;
WSInfo.Study:=id_LoadFlow;
End;

Destructor TWorksheet.Done;
begin
{ Dispose Dynamic Data }
  SelectedComponents^.DeleteAll;
  BusColl^.DeleteAll;
  Dispose( Printer, Done);
  Dispose( MonitoredBuses, Done);
  Dispose( NetWork, Done);
  inherited Done;
end;

function TWorksheet.CanClose: Boolean;
var   Reply: Integer;
      S : Array [0..255] Of Char;
      Name : PChar;

begin
  CanClose := True;
  if HasChanged then
  begin
    Name:=@FileName[0];
    WVSPrintF( S, 'Network :   %s   has changed', Name);
    Reply := MessageBox(HWindow, 'Do you want to save?',
      S, mb_YesNo or mb_IconQuestion);
    if Reply = id_Yes then CanClose := False;
  end;
end;

procedure TWorkSheet.GetWindowClass(var AWndClass: TWndClass);
begin
  inherited GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'WorkSheetIcon');
end;

{
procedure TWorkSheet.WMInitMenu( var Msg: TMessage);
Var  DelFlag, LineFlag, ConnectFlag,
     SelectFlag, RotateFlag, EditFlag : Integer;
begin
   MessageBox( HWindow, 'INIT MENU', 'TWorkSheet', MB_OK);
   if Msg.wParam<>2 then Exit;
   DelFlag:=MF_Enabled;
   ConnectFlag:=MF_Enabled;
   RotateFlag:=MF_Enabled;
   SelectFlag:=MF_Enabled;
   If SelectedComponents^.Count=1 then EditFlag:=MF_Enabled
                                  Else EditFlag:=MF_Grayed;
   If FirstPlace or LButtonDown Then begin
                                     DelFlag:=MF_Grayed;
                                     ConnectFlag:=MF_Grayed;
                                     SelectFlag:=MF_Grayed;
                                     end;
   If  (SelectedComponents^.Count=1) And
        (PPowerComponent(SelectedComponents^.At(0))^.HisType=Line)
                        Then begin
                             LineFlag:=MF_Enabled;
                             RotateFlag:=MF_Grayed;
                             end
                        Else LineFlag:=MF_Grayed;
   if (WSInfo.WSOpt and id_Moveable)<>id_Moveable then
                                           begin
                                           RotateFlag:=MF_Grayed;
                                           DelFlag:=MF_Grayed;
                                           LineFlag:=MF_Grayed;
                                           ConnectFlag:=MF_Grayed;
                                           end;
   EnableMenuItem( Msg.wParam, RotateFlag, cm_Rotate);
   EnableMenuItem( Msg.wParam, DelFlag, cm_Delete);
   EnableMenuItem( Msg.wParam, LineFlag, cm_ModifyLine);
   EnableMenuItem( Msg.wParam, SelectFlag, cm_SelectArea);
   EnableMenuItem( Msg.wParam, ConnectFlag, cm_Connect);
   EnableMenuItem( Msg.wParam, EditFlag, cm_Edit);
end;
}
procedure TWorkSheet.WMActivate( var Msg: TMessage);
begin
  inherited WMActivate( Msg);
if Msg.wParam=WA_INACTIVE
   then begin
        PDesigner( Parent)^.SetInfoFlag( nil);
        PDesigner( Parent)^.SetStudyFlag( nil);
        (* AdjustMenu*)
        PDesigner( Parent)^.AdjustMenu( nil);
        end
   else begin
        PDesigner( Parent)^.SetInfoFlag( @Self);
        PDesigner( Parent)^.SetStudyFlag( @Self);
        (* AdjustMenu *)
        PDesigner( Parent)^.AdjustMenu( @Self);
        end;
end;

procedure TWorkSheet.SetNames(NewName: PChar);
var
  Name: array[0..90] of Char;   { Title bar has 'WorkSheet -' }
begin

  { Create name for title bar }
  StrCopy(Name, 'WorkSheet');
  if StrComp(NewName, '') <> 0 then
  begin
    StrCat(Name, ' - ');
    StrCat(Name, NewName);
  end;

  { Set title bar }
  SetCaption(Name);

  { Set file name }
  StrCopy(FileName, NewName);
  { Set InName and OutName }
  StrLCopy( InName, FileName, StrEnd(FileName)-FileName-3);
  Strcat( InName, 'LFI');
  StrLCopy( OutName, FileName, StrEnd(FileName)-FileName-3);
  Strcat( OutName, 'LFO');
  { Set TSInName and TSOutName }
  StrLCopy( TSInName, FileName, StrEnd(FileName)-FileName-3);
  Strcat( TSInName, 'TSI');
  StrLCopy( TSOutName, FileName, StrEnd(FileName)-FileName-3);
  Strcat( TSOutName, 'TSO');
  StrLCopy( TSResultName, FileName, StrEnd(FileName)-FileName-3);
  Strcat( TSResultName, 'TSG');
{ Change la statusLine }
PDesigner( Parent)^.SetInfoFlag( @Self);
PDesigner( Parent)^.SetStudyFlag( @Self);
end;

Procedure TWorkSheet.Paint( PaintDC : HDC; Var PaintInfo : TPaintStruct);

  Procedure  PaintIt ( MyC : PPowerComponent); Far;
  Begin
  MyC^.Paint( PaintDC, WSInfo, PaintInfo);
  End;

  Procedure  PaintSelected ( MyC : PPowerComponent); Far;
  Begin
  MyC^.PaintSelected( PaintDC, PaintInfo);
  End;

Begin
NetWork^.ForEach( @PaintIt);
SelectedComponents^.ForEach( @PaintSelected);
End;


Procedure TWorkSheet.WMLButtonDown(var Msg: TMessage);
Begin
If (Msg.wParam and MK_Control)=MK_Control Then ControlOn:=True
                                          else ControlOn:=False;
LButtonDownAct;
End;

{ performs action for LButton Down or for space }
Procedure TWorkSheet.LButtonDownAct;
Var  T : TPoint;
     P : PLPoint;
     DragComponent : PPowerComponent;

 Function Exist( MyC : PPowerComponent) : Boolean; Far;
 begin
 IF MyC=DragComponent Then Exist:=True
                      Else Exist:=False;
 end;

 { Recherche du component pointe par le curseur}
 Function IsPointed( MyC : PPowerComponent) : Boolean; Far;
 begin
 IF MyC^.IsInIt( T) And (NetWork^.IndexOf(MyC)>Order) Then
                                            Begin
                                            IsPointed:=True;
                                            Order:=NetWork^.IndexOf(MyC)
                                            end
                                            Else IsPointed:=False;
 end;

{ Procedure pricipale }
Begin
GetCursorPos( T);
ScreenToClient( HWindow, T);
T.X:=T.X+Scroller^.XPos*Scroller^.XUnit;
T.Y:=T.Y+Scroller^.YPos*Scroller^.YUnit;

IF FirstPlace and LineCreating Then
                               begin
                               FirstPlace:=False;
                               Prec.X:=PLine(SelectedComponents^.At(0))^.X;
                               Prec.Y:=PLine(SelectedComponents^.At(0))^.Y;
                               Exit;
                               End;
IF LineCreating And Not(LButtonDown) Then
                Begin
                LButtonDown:=True;
                P:=New( PLPoint, Init( Actuel.X-PLine(SelectedComponents^.At(0))^.X,
                                       Actuel.Y-PLine(SelectedComponents^.At(0))^.Y) );
                if P=nil then NoMoreMemory
                   else
                   begin
                   PLine(SelectedComponents^.At(0))^.LinePoints^.Insert(P);
                   Prec:=Actuel;
                   end;
                Exit;
                End;
If FirstPlace Then begin
                   FirstPlace:=False;
                   ReleaseDC ( HWindow, DragDC);
                   ReleaseCapture;
                   { Des-Affiche Captured }
                   PDesigner( Parent)^.SetInfoFlag( @Self);
                   InvalidateRect ( HWindow, Nil, True);
{                   UpDateWindow( HWindow);}
                   Exit;
                   end;

IF ModifyLine And Not(LButtonDown) Then
                Begin
                LButtonDown:=True;
                if CapturedPoint=nil then
                     begin
                T.X:=PLine(SelectedComponents^.At(0))^.X;
                T.Y:=PLine(SelectedComponents^.At(0))^.Y;
                     end
                else begin
                T.X:=CapturedPoint^.X+PLine(SelectedComponents^.At(0))^.X;
                T.Y:=CapturedPoint^.Y+PLine(SelectedComponents^.At(0))^.Y;
                      end;
                T.X:=T.X-Scroller^.XPos*Scroller^.XUnit;
                T.Y:=T.Y-Scroller^.YPos*Scroller^.YUnit;
                ClientToScreen( HWindow, T);
                SetCursorPos( T.X, T.Y);
                HSaveCursor:=SetCursor( HCroix);
                Exit;
                End;
{IF ModifyLine And LButtonDown Then Exit;  evite Pbs }
IF SelectArea And Not(LButtonDown) Then
                Begin
                LButtonDown:=True;
                Prec:=T;
                Actuel:=T;
                Exit;
                End;
{ last action }
If Not ControlOn Then SelectedComponents^.DeleteAll;
  If Not(LButtonDown) Then
             begin
             LButtonDown:=True;
             If ( Old.X<>T.X) or ( OLd.Y<>T.Y) Then
                               begin
                               Old:=T;
                               Order:=-1;
                               end;
             DragComponent:=NetWork^.FirstThat( @IsPointed);
             IF DragComponent=Nil Then Begin
                                       If SelectedComponents^.Count=0 Then
                                                        LButtonDown:=False;
                                       Order:=-1;

                                       InvalidateRect ( HWindow, Nil, True);
                               {        UpDateWindow( HWindow);}
                                       Exit;
                                       End;
             If SelectedComponents^.FirstThat( @Exist)<>Nil
                Then SelectedComponents^.Delete( DragComponent)
                Else SelectedComponents^.Insert( DragComponent);

             InvalidateRect ( HWindow, Nil, True);
{             UpDateWindow( HWindow);}
             SetCapture( HWindow);
             DragDC:=GetDC( HWindow);
             HasChanged:=True;
             PDesigner( Parent)^.SetInfoFlag( @Self); {Affiche Captured}
             End;
End;

Procedure TWorkSheet.WMLButtonUp(var Msg: TMessage);
Begin
LButtonUpAct;
End;

Procedure TWorkSheet.LButtonUpAct;
Var R, R1 : TRect;
    T : TPoint;

  procedure CallAreYouIn( P : PPowerComponent); Far;
     { Verifie s'il n'a pas deja ete selectionne }
     function Exist( MyC : PPowerComponent) : Boolean; Far;
     begin
     IF MyC=P Then Exist:=True
              Else Exist:=False;
     end;
  Begin
  if P^.AreYouIn( R) then
                    begin
                    If SelectedComponents^.FirstThat( @Exist)=Nil
                       Then SelectedComponents^.Insert( P);
                    end;
                     { Else PSelectedComponents^.Delete( P) }
     { Permet d'ajouter seulement }
  End;

Begin
If LButtonDown And Not LineCreating
               And Not ModifyLine
               And Not SelectArea Then
                    begin
                    InvalidateRect ( HWindow, Nil, True);
{                    UpDateWindow( HWindow);}
                    ReleaseDC( HWindow, DragDC);
                    ReleaseCapture;
                    LButtonDown:=False;
                    { Des-Affiche Captured }
                    PDesigner( Parent)^.SetInfoFlag( @Self);
                    end;
If LButtonDown And ModifyLine Then
                    begin
                    SetCursor( HSaveCursor);
                    InvalidateRect ( HWindow, Nil, True);
{                    UpDateWindow( HWindow);}
                    DrawCapture;
                    end;
if SelectArea And LButtonDown Then
              Begin
              GetCursorPos( T);
              ScreenToClient( HWindow, T);
              T.X:=T.X+Scroller^.XPos*Scroller^.XUnit;
              T.Y:=T.Y+Scroller^.YPos*Scroller^.YUnit;
              SetRect( R, Prec.X-1, Prec.Y-1, Prec.X+1, Prec.Y+1);
              SetRect( R1, Actuel.X-1, Actuel.Y-1, Actuel.X+1, Actuel.Y+1);
              UnionRect ( R, R, R1);
              NetWork^.ForEach( @CallAreYouIn);
              ConvertRect ( R);
              InvalidateRect( HWindow, @R, True);
              UpdateWindow( HWindow);
              End;
If LButtonDown Then LButtonDown:=False;
End;

Procedure TWorkSheet.WMRButtonDown(var Msg: TMessage);
Begin
RButtonDownAct;
End;

Procedure TWorkSheet.RButtonDownAct;
Var  HFloatMenu : HMenu;
     T          : TPoint;
     R          : TRect;
     DelFlag, LineFlag, ConnectFlag,
     SelectFlag, RotateFlag, EditFlag : Integer;
Begin
If LineCreating Then begin
                    LineCreating:=False;
                    SetCursor( HSaveCursor);
                    InvalidateRect ( HWindow, Nil, True);
{                    UpDateWindow( HWindow);}
                    ReleaseDC( HWindow, DragDC);
                    ReleaseCapture;
                    { Des-Affiche Captured }
                    PDesigner( Parent)^.SetInfoFlag( @Self);
                    Exit;
                    End;
If ModifyLine Then  begin
                    ModifyLine:=False;
                    if LButtonDown then SetCursor( HSaveCursor);
             { retrouve le RECT a redessiner }
                    SetRectEmpty( R);
 PLine( SelectedComponents^.At(0))^.InvalidateLineRect( DragDC, WSInfo, R);
                    InflateRect( R, 10, 10);
                    ConvertRect( R);
                    InvalidateRect ( HWindow, @R, True);
                    UpDateWindow( HWindow);
                    ReleaseDC( HWindow, DragDC);
                    ReleaseCapture;
                    { Des-Affiche Captured }
                    PDesigner( Parent)^.SetInfoFlag( @Self);
                    Exit;
                    End;
if SelectArea Then  Begin
                    SelectArea:=False;
                    SetCursor( HSaveCursor);
                    ReleaseDC( HWindow, DragDC);
                    ReleaseCapture;
                    { Des-Affiche Captured }
                    PDesigner( Parent)^.SetInfoFlag( @Self);
                    Exit;
                    End;
If SelectedComponents^.Count>0 then
   Begin
   GetCursorPos( T);
   DelFlag:=MF_Enabled;
   ConnectFlag:=MF_Enabled;
   RotateFlag:=MF_Enabled;
   SelectFlag:=MF_Enabled;
   If SelectedComponents^.Count=1 then EditFlag:=MF_Enabled
                                  Else EditFlag:=MF_Grayed;
   If FirstPlace or LButtonDown Then begin
                                     DelFlag:=MF_Grayed;
                                     ConnectFlag:=MF_Grayed;
                                     SelectFlag:=MF_Grayed;
                                     end;
   If  (SelectedComponents^.Count=1) And
       ( (PPowerComponent(SelectedComponents^.At(0))^.HisType=Line)
         or(PPowerComponent(SelectedComponents^.At(0))^.HisType=Link))
                        Then begin
                             LineFlag:=MF_Enabled;
                             RotateFlag:=MF_Grayed;
                             end
                        Else LineFlag:=MF_Grayed;
   if (WSInfo.WSOpt and id_Moveable)<>id_Moveable then
                                           begin
                                           RotateFlag:=MF_Grayed;
                                           DelFlag:=MF_Grayed;
                                           LineFlag:=MF_Grayed;
                                           ConnectFlag:=MF_Grayed;
                                           end;
   HFloatMenu:=CreatePoPupMenu;
   AppendMenu( HFloatMenu, RotateFlag, cm_Rotate, '&Rotate');
   AppendMenu( HFloatMenu, DelFlag, cm_Delete, '&Delete');
   AppendMenu( HFloatMenu, LineFlag, cm_ModifyLine, '&Modify Line');
   AppendMenu( HFloatMenu, SelectFlag, cm_SelectArea, 'Select &Area');
   AppendMenu( HFloatMenu, ConnectFlag, cm_Connect, '&Connect');
   AppendMenu( HFloatMenu, EditFlag, cm_Edit, '&Edit');

   TrackPoPupMenu( HFloatMenu, TPM_LeftAlign + TPM_RightButton, T.X, T.Y,
                            0, HWindow, nil);
   DestroyMenu( HFloatMenu);
   End;
End;

Procedure TWorkSheet.WMMouseMove(var Msg: TMessage);
Var  T, Decal : TPoint;
     R, R1 : TRect;
     PL : PLine;
     { for ModifyLine }
     SelectedLine : PLine;
     ActualPoint, PI : PLPoint;
     DA          : Real;
     i           : Integer;

  Procedure LookForNearest( P : PLPoint); Far;
  Var DP : Real;
  begin
  DP:=abs( sqr( P^.X+SelectedLine^.X-T.X)+ sqr( P^.Y+SelectedLine^.Y-T.Y));
  if DP<DA then begin
                DA:=DP;
                ActualPoint:=P;
                end;
  end;
Begin
T.X:=Msg.LParamLo;
T.Y:=Msg.LParamHi;
{ Debut Modifications,
  scrolle la WorkSheet si pres du bord
  et empeche de sortir du WorkSheet }
GetClientRect(HWindow, R);
if T.X<=R.left then SendMessage( HWindow, WM_HScroll, SB_LINEUP, 0);
if T.X>=R.right then SendMessage( HWindow, WM_HScroll, SB_LINEDOWN, 0);
if T.Y<=R.top then SendMessage( HWindow, WM_VScroll, SB_LINEUP, 0);
if T.Y>=R.bottom then SendMessage( HWindow, WM_VScroll, SB_LINEDOWN, 0);
T.X:=T.X+Scroller^.XPos*Scroller^.XUnit;
T.Y:=T.Y+Scroller^.YPos*Scroller^.YUnit;
if T.X<=0 then exit;
if T.X>R.right+Scroller^.XRange*Scroller^.XUnit then exit;
if T.Y<=0 then exit;
if T.Y>R.bottom+Scroller^.YRange*Scroller^.YUnit then exit;
{ End Modif }

If FirstPlace And LineCreating Then
   Begin
   PL:=SelectedComponents^.At(0);
   SetRect(R, PL^.X-3, PL^.Y-3,
              PL^.X+3, PL^.Y+3);
   PL^.X:=T.X;
   PL^.Y:=T.Y;
   SetRect( R1, T.X-3, T.Y-3, T.X+3, T.Y+3);
   UnionRect ( R, R, R1);
   ConvertRect ( R);
   InvalidateRect( HWindow, @R, True);
   UpdateWindow( HWindow);
   Exit;
   End;
If LineCreating Then
   Begin
        If Actuel.X<=Prec.X Then begin
                      R.Left:=Actuel.X;
                      R.Right:=Prec.X;
                      end
                 Else begin
                      R.Left:=Prec.X;
                      R.Right:=Actuel.X;
                      end;
        If Actuel.Y<=Prec.Y Then begin
                      R.Top:=Actuel.Y;
                      R.Bottom:=Prec.Y;
                      end
                 Else begin
                      R.Top:=Prec.Y;
                      R.Bottom:=Actuel.Y;
                      end;
        ConvertRect ( R);
        InflateRect( R, 10, 10);
        InvalidateRect( HWindow, @R, True);
        UpdateWindow( HWindow);
        Actuel.X:=T.X;
        Actuel.Y:=T.Y;
        MoveTo ( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                         Prec.Y-Scroller^.YPos*Scroller^.YUnit);
        LineTo ( DragDC, Actuel.X-Scroller^.XPos*Scroller^.XUnit,
                         Actuel.Y-Scroller^.YPos*Scroller^.YUnit);
   Exit;
   End;
if ModifyLine and Not( LButtonDown) then
              Begin
              SelectedLine:=SelectedComponents^.At(0);
              ActualPoint:=nil;
              DA:=abs( sqr( SelectedLine^.X-T.X)+ sqr( SelectedLine^.Y-T.Y));
              SelectedLine^.LinePoints^.ForEach( @LookForNearest);
              if CapturedPoint<>ActualPoint then
                    begin
                    CapturedPoint:=ActualPoint;
                    SetRectEmpty( R);
                    SelectedLine^.InvalidateLineRect( DragDC, WSInfo, R);
                    InflateRect( R, 10, 10);
                    ConvertRect( R);
                    InvalidateRect( HWindow, @R, True);
                    UpdateWindow( HWindow);
                    DrawCapture;
                    end;
              Exit;
              End;
if ModifyLine and LButtonDown then
              Begin
              SelectedLine:=SelectedComponents^.At(0);
              SetRectEmpty( R);
              SelectedLine^.InvalidateLineRect( DragDC, WSInfo, R);
              if CapturedPoint=nil then
                               begin
                               for i:=0 to SelectedLine^.LinePoints^.Count-1
                                 do begin
                                    PI:=SelectedLine^.LinePoints^.At( i);
                                    PI^.X:=PI^.X+SelectedLine^.X-T.X;
                                    PI^.Y:=PI^.Y+SelectedLine^.Y-T.Y;
                                    end;
                               SelectedLine^.X:=T.X;
                               SelectedLine^.Y:=T.Y;
                               end
                          else begin
                               CapturedPoint^.X:=T.X-SelectedLine^.X;
                               CapturedPoint^.Y:=T.Y-SelectedLine^.Y;
                               end;
              SelectedLine^.InvalidateLineRect( DragDC, WSInfo, R);
              ConvertRect( R);
              InflateRect( R, 10, 10);
              InvalidateRect( HWindow, @R, True);
              UpdateWindow( HWindow);
              Exit;
              End;
if SelectArea And LButtonDown Then
              Begin
              GetClientRect( HWindow, R);

              if (T.X<>Actuel.X) or (T.Y<>Actuel.Y) then
                  begin
                  MoveTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Actuel.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Actuel.X-Scroller^.XPos*Scroller^.XUnit,
                                  Actuel.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Actuel.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  Actuel:=T;
                  MoveTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Actuel.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Actuel.X-Scroller^.XPos*Scroller^.XUnit,
                                  Actuel.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Actuel.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  LineTo( DragDC, Prec.X-Scroller^.XPos*Scroller^.XUnit,
                                  Prec.Y-Scroller^.YPos*Scroller^.YUnit);
                  end;
              Exit;
              End;
{ last action }
Decal.X:=T.X-OldM.X;
Decal.Y:=T.Y-OldM.Y;
If FirstPlace Or LButtonDown Then MoveComponent( Decal);
OldM:=T;
End;

Procedure TWorksheet.DrawCapture;
Var SL : PLine;
Begin
SL:=SelectedComponents^.At(0);
if CapturedPoint=nil then
Ellipse( DragDC,SL^.X-5-Scroller^.XPos*Scroller^.XUnit,
                SL^.Y-5-Scroller^.YPos*Scroller^.YUnit,
                SL^.X+5-Scroller^.XPos*Scroller^.XUnit,
                SL^.Y+5-Scroller^.YPos*Scroller^.YUnit)
                     else
Ellipse( DragDC,SL^.X+CapturedPoint^.X-5-Scroller^.XPos*Scroller^.XUnit,
                SL^.Y+CapturedPoint^.Y-5-Scroller^.YPos*Scroller^.YUnit,
                SL^.X+CapturedPoint^.X+5-Scroller^.XPos*Scroller^.XUnit,
                SL^.Y+CapturedPoint^.Y+5-Scroller^.YPos*Scroller^.YUnit)
End;

Procedure TWorksheet.MoveComponent( Decal : TPoint);
Var  R : TRect;
     UnDC : HDC;
 Procedure CallUpDate( MyC : PPowerComponent); Far;
 begin
 MyC^.UpDate( Decal, UnDC, WSInfo, R);
 end;

Begin
if (WSInfo.WSOpt and id_Moveable)=0 then exit;
SetRectEmpty(R);
UnDC:=GetDC( HWindow);
SelectedComponents^.ForEach( @CallUpDate);
ReleaseDC(  HWindow,UnDC);
ConvertRect( R);
InvalidateRect( HWindow, @R, True);
UpdateWindow( HWindow);
{le desssin se fait par Paint car Inserted in NetWork}
End;

Procedure TWorksheet.ConvertRect( Var R : TRect);
Begin
R.Left:=R.Left-Scroller^.Xpos*Scroller^.XUnit;
R.Right:=R.Right-Scroller^.Xpos*Scroller^.XUnit;
R.Top:=R.Top-Scroller^.Ypos*Scroller^.YUnit;
R.Bottom:=R.Bottom-Scroller^.Ypos*Scroller^.YUnit;
End;

procedure TWorksheet.FileSave(var Msg: TMessage);
begin
  if IsNewFile then FileSaveAs(Msg) else SaveFile;
end;

procedure TWorksheet.FileSaveAs(var Msg: TMessage);
begin
  if IsNewFile then StrCopy(FileName, '*.SCH');
  if Application^.ExecDialog(New(PFileDialog,
    Init(@Self, MakeIntResource(sd_FileSave), FileName))) = id_Ok then
                                                                  SaveFile;
end;

function TWorksheet.LoadFile : Integer;
var
  TempColl: PCollection;
  TheFile: TDosStream;
  Ph     : Array[0..10] of char;
  IX, IY : LongInt;
begin
  TheFile.Init(FileName, stOpen);
  TheFile.Read( Ph, SizeOf( Ph));
  if (strcomp( Ph,'POWER V119')<>0)then
                                   begin
                                   Loadfile:=1;
                                   Exit;
                                   end;
  { WorkSheet Size }
  TheFile.Read( IX, SizeOf( IX));
  TheFile.Read( IY, SizeOf( IY));
  TheFile.Read(GS_IterMax, SizeOf(GS_IterMax));
  TheFile.Read(GS_Tol, SizeOf(GS_Tol));
  TheFile.Read(GS_AccelFact, SizeOf(GS_AccelFact));
  TheFile.Read(NR_IterMax, SizeOf(NR_IterMax));
  TheFile.Read(NR_Tol, SizeOf(NR_Tol));
  TheFile.Read(WSInfo.WSOpt, SizeOf(WSInfo.WSOpt));
  TheFile.Read(LFOpt, SizeOf(LFOpt));
  TheFile.Read(TSOpt, SizeOf(TSOpt));
  TheFile.Read(WSInfo.TSInfo, SizeOf(WSInfo.TSInfo));
 { la liste temporaire de tous elements du NetWork }
  TempColl := PCollection(TheFile.Get);
 { la liste des bus a surveiller }
  MonitoredBuses:= PCollection(TheFile.Get);
  TheFile.Done;
  if TempColl <> nil then
  begin
{ a cause de la nouvelle methode de dessin
  il faut vider la selection }
    SelectedComponents^.DeleteAll;
    Dispose(NetWork, Done);
    NetWork:= TempColl;
    { Remet a jour la NetWorkList aussi }
    WSInfo.NetWorkList:=NetWork;
    InvalidateRect(HWindow, nil, True);
    SetNames (FileName);
    Loadfile:=0;
  end;
  Scroller^.SetRange( IX, IY);
  HasChanged := False;
  IsNewFile := False;
end;

procedure TWorksheet.SaveFile;
var
  TheFile : TDosStream;
  Ph      : Array[0..10] of char;
begin
  strcopy( Ph,'POWER V119');
  TheFile.Init(FileName, stCreate);

  TheFile.Write( Ph, SizeOf( Ph));
  { WorkSheet Size }
  TheFile.Write( Scroller^.XRange, SizeOf( Scroller^.XRange));
  TheFile.Write( Scroller^.YRange, SizeOf( Scroller^.YRange));
  TheFile.Write(GS_IterMax, SizeOf(GS_IterMax));
  TheFile.Write(GS_Tol, SizeOf(GS_Tol));
  TheFile.Write(GS_AccelFact, SizeOf(GS_AccelFact));
  TheFile.Write(NR_IterMax, SizeOf(NR_IterMax));
  TheFile.Write(NR_Tol, SizeOf(NR_Tol));
  TheFile.Write(WSInfo.WSOpt, SizeOf(WSInfo.WSOpt));
  TheFile.Write(LFOpt, SizeOf(LFOpt));
  TheFile.Write(TSOpt, SizeOf(TSOpt));
  TheFile.Write( WSInfo.TSInfo, SizeOf( WSInfo.TSInfo));
 { la liste de tous elements du NetWork }
  TheFile.Put(NetWork);
 { la liste des bus a surveiller }
  TheFile.Put(MonitoredBuses);
  TheFile.Done;
  IsNewFile := False;
  HasChanged := False;
  SetNames (FileName);
end;

procedure TWorksheet.CMPrint(var Msg: TMessage);
var P : PPrintOut;
    S : Array [0..200] of char;
    Ans : Integer;
begin
{  if IsNewFile then StrCopy(FileName, 'Untitled'); }
  P := New(PWindowPrintout, Init(FileName, @Self));
{  P^.Banding:=True;
WriteLn( 'driver version : ', GetDeviceCaps( Printer^.GetDC, DriverVersion));
WriteLn( 'driver : ', Printer^.Driver);
if GetDeviceCaps( Printer^.GetDC, Technology)=DT_PLOTTER then
                  WriteLn( 'DT_PLOTTER');
if GetDeviceCaps( Printer^.GetDC, Technology)=DT_RASPRINTER then
                  WriteLn( 'DT_RASPRINTER');
if GetDeviceCaps( Printer^.GetDC, Rastercaps)=RC_BANDING
                  then  WriteLn( 'RC_BANDING')
                  else  WriteLn( 'No RC_BANDING');
if GetDeviceCaps( Printer^.GetDC, Rastercaps)=RC_BitBLT
                  then  WriteLn( 'RC_BitBLT')
                  else  WriteLn( 'No RC_BitBLT');
}
if GetDeviceCaps( Printer^.GetDC, Rastercaps)=RC_BitBLT
                  then Printer^.Print(@Self, P)
                  else
                  begin
   StrCopy( S,'You can''t print the power component bitmaps'#13#10);
   StrCat( S, 'on a plotter or on a text printer.'#13#10#13#10);
   StrCat( S, 'More informations in Help : How to Print.'#13#10#13#10);
   StrCat( S, 'If you stil want to print only lines and names,'#13#10);
   StrCat( S, 'press - Yes');
   MessageBeep( MB_ICONEXCLAMATION);
   Ans:=MessageBox( HWindow, S,'Print Error',
                MB_YesNo+MB_DEFBUTTON2+MB_ICONEXCLAMATION);
   if Ans=ID_YES then Printer^.Print(@Self, P);
                  end;
Dispose(P, Done);
end;

procedure TWorksheet.CMSetup(var Msg: TMessage);
begin
  Printer^.Setup(@Self);
end;

Procedure TWorksheet.NoMoreMemory;
Var  S : Array [0..80] of char;
Begin
MessageBeep( MB_ICONHAND);
StrCopy( S,'No more dynamic memory on the Heap'#13#10);
StrCat( S, 'Refer to the help.');
MessageBox( HWindow, S,'Heap Overflow Error',
            MB_OK+MB_ICONHAND);
End;

function TWorksheet.IsItFixed : Boolean;
Var  S : Array [0..160] of char;
Begin
if (WSInfo.WSOpt and id_Moveable)=0 then
       begin
       IsItFixed:=True;
       MessageBeep( MB_ICONInformation);
       StrCopy( S,'The actual mode is Fixed Components'#13#10);
       StrCat( S, 'you must set the Components to be Moveable'#13#10);
       StrCat( S, 'in Options | WorkSheet');
       MessageBox( HWindow, S,'Operation Failed', MB_OK+MB_ICONInformation);
       end
  else IsItFixed:=False;
End;

Procedure TWorksheet.CMCreGenerator(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
{ new special comeponent for transient stability studies }
MyComponent:=New(PSpeGenerator, Init( Generator));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreCompensator(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
{ new special comeponent for transient stability studies }
MyComponent:=New(PSpeCompensator, Init( Compensator));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreBus(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PBus, Init( Bus));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreLine(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
if IsItFixed then exit;
MyComponent:=New(PLine, Init( Line));
if MyComponent=nil then NoMoreMemory
                   else begin
                        LineCreating:=True;
                        HSaveCursor:=SetCursor( HCroix);
                        CreateComponent ( MyComponent);
                        end;
end;

Procedure TWorksheet.CMCreTransfo(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PTransfo, Init( Transfo));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreDrain(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PDrain, Init( Drain));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreCapa(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PCapa, Init( Capa));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreResistance(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PResistance, Init( Resistance));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreSelfInd(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
MyComponent:=New(PSelfInd, Init( SelfInd));
if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);
end;

Procedure TWorksheet.CMCreLink(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
if IsItFixed then exit;
MyComponent:=New(PLink, Init( Link));
if MyComponent=nil then NoMoreMemory
                   else begin
                        LineCreating:=True;
                        HSaveCursor:=SetCursor( HCroix);
                        CreateComponent ( MyComponent);
                        end;
end;

Procedure TWorksheet.CreateComponent ( MyComponent : PPowerComponent);
Var T : TPoint;
Begin
if IsItFixed then            begin
                             Dispose( MyComponent, Done);
                             exit;
                             end;
NetWork^.Insert( MyComponent);
SelectedComponents^.DeleteAll;
FirstPlace:=True;
SetCapture( Hwindow);
DragDC:=GetDC( HWindow);
PDesigner( Parent)^.SetInfoFlag( @Self); { Affiche Captured }
HasChanged:=True;
GetCursorPos( T);
ScreenToClient( HWindow, T);
T.X:=T.X+Scroller^.XPos*Scroller^.XUnit;
T.Y:=T.Y+Scroller^.YPos*Scroller^.YUnit;
OldM:=T;
With MyComponent^ do
     If HisType=Line Then begin
                          X:=T.X;
                          Y:=T.Y;
                          end
                     Else begin
                          X:=T.X-16;
                          Y:=T.Y-16;
                          end;
SelectedComponents^.Insert(MyComponent);
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow);}
End;

Procedure TWorksheet.Rotate(var Msg: TMessage);
Var  R : TRect;
     UnDC : HDC;

 Procedure CallRotate( MyC : PPowerComponent); Far;
 begin
 MyC^.Rotate( UnDC, WSInfo, R);
 end;

Begin
if IsItFixed then exit;
IF SelectedComponents^.Count=0 Then Exit;
SetRectEmpty( R);
UnDC:=GetDC( HWindow);
SelectedComponents^.ForEach( @CallRotate);
ReleaseDC( HWindow, UnDC);
ConvertRect( R);
InvalidateRect( HWindow, @R, True);
UpdateWindow( HWindow);
End;

Procedure TWorksheet.CMModifyLine(var Msg: TMessage);
Begin
if IsItFixed then exit;
if SelectedComponents^.Count=0 then Exit;
if (SelectedComponents^.Count<>1)
   or ( (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Line)
        and (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Link))
         then begin
         MessageBox( HWindow,'You have to select one line to modify',
                        'Modify Line Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
SetCapture( Hwindow);
DragDC:=GetDC( HWindow);
ModifyLine:=True;
HasChanged:=True;
CapturedPoint:=nil;
DrawCapture;
PDesigner( Parent)^.SetInfoFlag( @Self); { Affiche Captured }
End;

Procedure TWorksheet.WMKeyDown(var Msg: TMessage);
Var T : TPoint;
    R : TRect;
    P : PLPoint;
Begin
if (Msg.wParam=VK_Left) or (Msg.wParam=VK_Right) or
   (Msg.wParam=VK_Up)   or (Msg.wParam=VK_Down) then
       with Msg Do
       begin
       GetCursorPos( T);
       ScreenToClient( HWindow, T);
       Inc(Rep);
       Case wParam of
            VK_Left  : T.X:=T.X-Rep;
            VK_Right : T.X:=T.X+Rep;
            VK_Up    : T.Y:=T.Y-Rep;
            VK_Down  : T.Y:=T.Y+Rep;
            end;
       GetClientRect( HWindow, R);
       { Compare limites Fenetre }
       { -----++++-----}
       ClientToScreen( HWindow, T);
       SetCursorPos( T.X, T.Y);
       end;
{ Select Component with space }
If Msg.wParam=VK_RETURN Then
        begin
        if LineCreating And not FirstPlace then
                        begin
                        if Rep<>1 then Exit;
                        Rep:=2;
                P:=New( PLPoint, Init( Actuel.X-PLine(SelectedComponents^.At(0))^.X,
                                       Actuel.Y-PLine(SelectedComponents^.At(0))^.Y) );
                PLine(SelectedComponents^.At(0))^.LinePoints^.Insert(P);
                Prec.X:=Actuel.X;
                Prec.Y:=Actuel.Y;
                        Exit
                        end;
        if LButtonDown then LButtonUpAct
                       else
                       begin
                       ControlOn:=True;
                       LButtonDownAct;
                       end;
        end;
if Msg.wParam=VK_Space then
        begin
        if LineCreating And not FirstPlace then
                        begin
                        if Rep<>1 then Exit;
                        Rep:=2;
                P:=New( PLPoint, Init( Actuel.X-PLine(SelectedComponents^.At(0))^.X,
                                       Actuel.Y-PLine(SelectedComponents^.At(0))^.Y) );
                PLine(SelectedComponents^.At(0))^.LinePoints^.Insert(P);
                Prec.X:=Actuel.X;
                Prec.Y:=Actuel.Y;
                        Exit
                        end;
        if LButtonDown then LButtonUpAct
                       else
                       begin
                       ControlOn:=False;
                       LButtonDownAct;
                       end;
        end;
if Msg.wParam=VK_Escape then
                        begin
                        if LButtonDown then LButtonUpAct;
                        RButtonDownAct;
                        end;

Case Msg.wParam of
     VK_Home  : SendMessage( HWindow, WM_HScroll, SB_PAGEUP, 0);
     VK_End   : SendMessage( HWindow, WM_HScroll, SB_PAGEDOWN, 0);
     VK_Prior : SendMessage( HWindow, WM_VScroll, SB_PAGEUP, 0);
     VK_Next  : SendMessage( HWindow, WM_VScroll, SB_PAGEDOWN, 0);
     end;

IF SelectedComponents^.Count=0 Then Exit;

if Not(ModifyLine) then if Msg.wParam=VK_DELETE then Performdelete
                                                else
                   else
                   begin
                   if Msg.wParam=VK_INSERT then InsertPoint;
                   if Msg.wParam=VK_DELETE then deletePoint;
                   end;
End;

Procedure TWorksheet.WMKeyUp(var Msg: TMessage);
Begin
Rep:=1;
End;

Procedure TWorksheet.InsertPoint;
Var SelectedLine : PLine;
    P            : PLPoint;
    X, Y , i     : Integer;
Begin
if Not(ModifyLine) then exit;
SelectedLine:=SelectedComponents^.At(0);
i:=0;
if CapturedPoint=nil then
                     if SelectedLine^.LinePoints^.Count=0 then
                                                          Begin
                            { il ne reste que le point de la ligne }
                                                          X:=20;
                                                          Y:=20;
                                                          end
                                                          else
                                                          begin
                     X:=PLPoint(SelectedLine^.LinePoints^.At(0))^.X div 2;
                     Y:=PLPoint(SelectedLine^.LinePoints^.At(0))^.Y div 2;
                                                          end
            else     begin
                     i:=SelectedLine^.LinePoints^.IndexOf( CapturedPoint);
                     if i=0 then
                            begin
                      X:=PLPoint(SelectedLine^.LinePoints^.At(0))^.X div 2;
                      Y:=PLPoint(SelectedLine^.LinePoints^.At(0))^.Y div 2;
                            end
                        else begin
                        X:=(PLPoint(SelectedLine^.LinePoints^.At( i-1))^.X
                        +PLPoint(SelectedLine^.LinePoints^.At( i))^.X) div 2;
                        Y:=(PLPoint(SelectedLine^.LinePoints^.At( i-1))^.Y
                        +PLPoint(SelectedLine^.LinePoints^.At( i))^.Y) div 2;
                             end;
                     end;
P:=New( PLPoint, Init( X, Y) );
SelectedLine^.LinePoints^.AtInsert( i, P);
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow); }
DrawCapture;
End;

Procedure TWorksheet.DeletePoint;
Var SelectedLine : PLine;
    P, PI        : PLPoint;
    i            : Integer;
Begin
if Not(ModifyLine) then exit;
SelectedLine:=SelectedComponents^.At(0);
if CapturedPoint=nil then
                     begin
                     if SelectedLine^.LinePoints^.Count=0 then exit;
                     P:=SelectedLine^.LinePoints^.At(0);
                     for i:=1 to SelectedLine^.LinePoints^.Count-1
                      do begin
                         PI:=SelectedLine^.LinePoints^.At( i);
                         PI^.X:=PI^.X-P^.X;
                         PI^.Y:=PI^.Y-P^.Y;
                         end;
                     SelectedLine^.X:=SelectedLine^.X+P^.X;
                     SelectedLine^.Y:=SelectedLine^.Y+P^.Y;
                     CapturedPoint:=nil;
                     SelectedLine^.LinePoints^.Free( P);
                     end
              else   begin
                     P:=CapturedPoint;
                     CapturedPoint:=nil;
                     SelectedLine^.LinePoints^.Free( P);
                     end;
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow);}
DrawCapture;
End;

Procedure TWorksheet.Delete(var Msg: TMessage);
Begin
{ Call Delete routine }
Performdelete;
End;

{ peut etre applee par TWorkSheet.WMKeyDown or TWorkSheet.Delete }
Procedure TWorksheet.Performdelete;

 Procedure Del( MyC : PPowerComponent); Far;
 Var DelNum, I, K : Integer;
     PBC     : PBusCon;
        Procedure CallUpDateCon ( P : PPowerComponent); Far;
        begin
        P^.UpDateCon( DelNum);
        end;

 begin
 DelNum:=NetWork^.IndexOf( MyC);
 NetWork^.ForEach ( @CallUpDateCon);
 (* we must also update the FaultedBus *)
 If WSInfo.TSInfo.FaultedBus=DelNum Then WSInfo.TSInfo.FaultedBus:=-1;
 If WSInfo.TSInfo.FaultedBus>DelNum Then Dec( WSInfo.TSInfo.FaultedBus);
 (* ... the OpenedLine *)
 If WSInfo.TSInfo.OpenedLine=DelNum Then WSInfo.TSInfo.OpenedLine:=-1;
 If WSInfo.TSInfo.OpenedLine>DelNum Then Dec( WSInfo.TSInfo.OpenedLine);
 (* ... the SwitchedLoad *)
 If WSInfo.TSInfo.SwitchedLoad=DelNum Then WSInfo.TSInfo.SwitchedLoad:=-1;
 If WSInfo.TSInfo.SwitchedLoad>DelNum Then Dec( WSInfo.TSInfo.SwitchedLoad);
 (* ... the DroppedLoad *)
 If WSInfo.TSInfo.DroppedLoad=DelNum Then WSInfo.TSInfo.DroppedLoad:=-1;
 If WSInfo.TSInfo.DroppedLoad>DelNum Then Dec( WSInfo.TSInfo.DroppedLoad);

 (* ... and the MonitoredBuses *)
 if MonitoredBuses^.Count<>0 then
      begin
      PBC:=nil;
      for I:=0 to MonitoredBuses^.Count-1 do
              begin
              K:=PBusCon(MonitoredBuses^.At(I))^.Con;
              { Marque ceux qu'il faut eleminer }
              If K=DelNum Then begin
                               PBC:=MonitoredBuses^.At(I);
                               PBC^.Con:=-1;
                               end;
              If K>DelNum Then Dec( PBusCon(MonitoredBuses^.At(I))^.Con);
              end;
              { efface le PBusCon marque, un seul a la fois !
                on ne peut pas effacer avec une boucle->Run Time Error 213 }
      if PBC<>nil then MonitoredBuses^.Free( PBC);
      end;
 { Now we can deleate it }
 NetWork^.Delete( MyC);
 end;

Begin
if IsItFixed then exit;
IF SelectedComponents^.Count=0 Then Exit;
if FirstPlace or LineCreating then exit;
If MessageBox(HWindow, 'Are you sure ?',
      'Delete selected components', mb_YesNo or MB_DEFBUTTON2
                                     or mb_IconQuestion)
    = id_No Then Exit;
SelectedComponents^.ForEach( @Del);
SelectedComponents^.FreeAll;
{ Reafficher }
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow);}
End;

Procedure TWorksheet.Connect(var Msg: TMessage);
Var Phrase : array[0..160] of char;
Begin
if IsItFixed then exit;
If SelectedComponents^.Count=2 Then
   PPowerComponent(SelectedComponents^.At(0))^.Connect( SelectedComponents, NetWork)
                               Else
    begin
StrCopy( Phrase, 'You have to select two component to connect'+#13#10+#13#10);
StrCat( Phrase,'Hint : Hold down the CTRL KEY to select multiple components');
MessageBox( HWindow, @Phrase, 'Connect Error', MB_Ok+MB_IconExclamation);
    end;
End;

Procedure TWorksheet.Edit(var Msg: TMessage);
Begin
If SelectedComponents^.Count<>1 Then Begin
                MessageBox( HWindow,'You Must Select one component to edit',
                'Edit Error',MB_OK+MB_IconExclamation);
                Exit;
                End;
PPowerComponent(SelectedComponents^.At(0))^.Edit( @Self, NetWork,
                                                  WSInfo.Study);
{ Reafficher pour avoir les nouveaux noms }
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow); car ralentit }
End;

Procedure TWorksheet.CMSelectArea;
Begin
SetCapture( HWindow);
DragDC:=GetDC( HWindow);
SelectArea:=True;
HSaveCursor:=SetCursor( HCroix);
SetRop2( DragDC, R2_NOT);
PDesigner( Parent)^.SetInfoFlag( @Self); { Affiche Captured }
End;

Procedure TWorksheet.UnConnect(var Msg: TMessage);

  Procedure CallUnConnect ( MyC : PPowerComponent); Far;
  begin
  MyC^.UnConnect( NetWork);
  end;

Begin
if IsItFixed then exit;
If SelectedComponents^.Count=0 Then Begin
                MessageBox( HWindow,'There is no component to unconnect',
                'UnConnect Error',MB_OK+MB_IconExclamation);
                Exit;
                End;
If MessageBox(HWindow, 'Are you sure ?',
      'Unconnect selected components', mb_YesNo or MB_DEFBUTTON2
                                     or mb_IconQuestion)
    = id_No Then Exit;
SelectedComponents^.ForEach( @CallUnConnect);
End;

Procedure TWorksheet.SelectAll(var Msg: TMessage);

  Procedure SelectIt ( MyC : PPowerComponent); Far;
  begin
  SelectedComponents^.Insert( MyC);
  end;

Begin
SelectedComponents^.DeleteAll;
NetWork^.ForEach( @SelectIt);
{ Reafficher }
InvalidateRect( HWindow, Nil, True);
{UpDateWindow( HWindow);}
End;

{ ClipBoard operatrions }
Procedure TWorksheet.CMEditCut(var Msg: TMessage);
Begin
if IsItFixed then exit;
MessageBox( HWindow, 'Cut Selected Components',
            'ClipBoard', MB_Ok+MB_IconExclamation);
PerformEditCopy;
Performdelete;
End;

Procedure TWorksheet.CMEditCopy(var Msg: TMessage);
Begin
if IsItFixed then exit;
MessageBox( HWindow, 'Copy Selected Components',
            'ClipBoard', MB_Ok+MB_IconExclamation);
PerformEditCopy;
End;

Procedure TWorksheet.PerformEditCopy;
Var TempColl, SubTColl : PCollection;
    I, J, K, L : Integer;
    TheFile    : TDosStream;
    OldC, NewC, AC : PPowerComponent;

   function ExistInSelect( MyC : PPowerComponent): Boolean; Far;
   begin
   ExistInSelect:=False;
   if K=NetWork^.IndexOf( MyC) then ExistInSelect:=True;
   end;

   procedure LookBusCon( PBC : PBusCon); Far;
      { ne marche pas si externe }
      function ExistInSel( MyC : PPowerComponent): Boolean; Far;
      begin
      ExistInSel:=False;
      if K=NetWork^.IndexOf( MyC) then ExistInSel:=True;
      end;
   begin
   K:=PBC^.Con;
   AC:=SelectedComponents^.FirstThat( @ExistInSel);
   if AC=nil then j:=-1
             else j:=SelectedComponents^.IndexOf( AC);
   L:=PBus(OldC)^.ConColl^.IndexOf( PBC);
   PBusCon( PBus( NewC)^.ConColl^.At( L))^.Con:=j;
   if j=-1 then SubTColl^.Insert( PBus( NewC)^.ConColl^.At( L));
   end;

   procedure DeleteInBusColl ( PBC : PBusCon); Far;
   begin
   PBus( NewC)^.ConColl^.Delete( PBC);
   end;

Begin
TempColl:=new( PCollection, init( SelectedComponents^.Count,0));
{ Duplique la SelectedComponents }
TheFile.Init( 'PowerD.CBD', stCreate);
TheFile.Put( SelectedComponents);
TheFile.Done;
{ dans TempColl }
TheFile.Init( 'PowerD.CBD', stOpen);
TempColl:=PCollection( TheFile.Get );
TheFile.Done;
if TempColl=nil then exit; { Pb while dup }
{ on parcourt les selected }
for I:=0 to SelectedComponents^.Count-1 do
    begin
    OldC:=SelectedComponents^.At( I);
    NewC:=TempColl^.At( I);
    Case OldC^.HisType of
      Generator : begin
                  K:=PGenerator(OldC)^.Con;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PGenerator( NewC)^.Con:=j;
                  end;
      Compensator:begin
                  K:=PCompensator(OldC)^.Con;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PCompensator(NewC)^.Con:=j;
                  end;
      Drain    :  begin
                  K:=PDrain(OldC)^.Con;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PDrain(NewC)^.Con:=j;
                  end;
      Capa     :  begin
                  K:=PCapa(OldC)^.Con;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PCapa(NewC)^.Con:=j;
                  end;
      Bus      : begin
                  SubTColl:=new( PCollection,
                                   init( PBus( NewC)^.ConColl^.Count,0));
                  PBus(OldC)^.ConColl^.ForEach( @LookBusCon);
                  { Eliminer les BusCon qui ont con=-1
                  donc ceux qui sont dans SubTColl }
                  SubTColl^.ForEach( @DeleteInBusColl);
                  Dispose( SubTColl, Done);
                  end;
      Line     : begin
                  K:=PLine(OldC)^.Con1;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PLine(NewC)^.Con1:=j;
                  K:=PLine(OldC)^.Con2;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PLine(NewC)^.Con2:=j;
                  end;
      { Link  pas besoin }
      Transfo  : begin
                  K:=PTransfo(OldC)^.Con1;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PTransfo(NewC)^.Con1:=j;
                  K:=PTransfo(OldC)^.Con2;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PTransfo(NewC)^.Con2:=j;
                  end;
      Resistance: begin
                  K:=PResistance(OldC)^.Con1;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PResistance(NewC)^.Con1:=j;
                  K:=PResistance(OldC)^.Con2;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PResistance(NewC)^.Con2:=j;
                  end;
      SelfInd  : begin
                  K:=PSelfInd(OldC)^.Con1;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PSelfInd(NewC)^.Con1:=j;
                  K:=PSelfInd(OldC)^.Con2;
                  AC:=SelectedComponents^.FirstThat( @ExistInSelect);
                  if AC=nil then j:=-1
                            else j:=SelectedComponents^.IndexOf( AC);
                  PSelfInd(NewC)^.Con2:=j;
                  end;
      end;
    end;
{ Enregistre la TempColl retouchee }
TheFile.Init( 'PowerD.CBD', stCreate);
TheFile.Put( TempColl);
TheFile.Done;
{ Libere les espaces dupliquees }
Dispose( TempColl, Done);
End;

Procedure TWorksheet.CMEditPaste(var Msg: TMessage);
Var TempColl   : PCollection;
    I, NC : Integer;
    TheFile    : TDosStream;
    OldC : PPowerComponent;
    Decal : TPoint;

   procedure UpDateBusCon( PB : PBusCon); Far;
   begin
   If PB^.Con=-1 Then MessageBox( HWindow, 'Connection not free',
                         'Bus Connection Pb',MB_OK+MB_IconExclamation)
                 else PB^.Con:=PB^.Con+NC;
   end;

Begin
if IsItFixed then exit;
MessageBox( HWindow, 'Paste to Selected Components',
            'ClipBoard', MB_Ok+MB_IconExclamation);
{ dans TempColl }
TempColl:=new( PCollection, init( 5,5));
TheFile.Init( 'PowerD.CBD', stOpen);
TempColl:=PCollection( TheFile.Get );
TheFile.Done;
if TempColl=nil then exit; { Pb while Loading }
SelectedComponents^.DeleteAll;
NC:=NetWork^.Count;
{ on parcourt les retrived }
for I:=0 to TempColl^.Count-1 do
    begin
    OldC:=TempColl^.At( I);
    NetWork^.Insert( OldC);
    SelectedComponents^.Insert( OldC);

    Case OldC^.HisType of
      Generator : if PGenerator( OldC)^.Con<>-1 then
                    PGenerator( OldC)^.Con:=PGenerator( OldC)^.Con+NC;
      Compensator: if PCompensator( OldC)^.Con<>-1 then
                    PCompensator( OldC)^.Con:=PCompensator( OldC)^.Con+NC;
      Drain    :  if PDrain(OldC)^.Con<>-1 then
                    PDrain(OldC)^.Con:=PDrain(OldC)^.Con+NC;
      Capa     :  if PCapa(OldC)^.Con<>-1 then
                    PCapa(OldC)^.Con:=PCapa(OldC)^.Con+NC;
      Bus      :  PBus(OldC)^.ConColl^.ForEach( @UpDateBusCon);
      Line     : begin
                 if PLine(OldC)^.Con1<>-1 then
                    PLine(OldC)^.Con1:=PLine(OldC)^.Con1+NC;
                 if PLine(OldC)^.Con2<>-1 then
                    PLine(OldC)^.Con2:=PLine(OldC)^.Con2+NC;
                  end;
      { Link   non connecte }
      Transfo  : begin
                 if PTransfo(OldC)^.Con1<>-1 then
                    PTransfo(OldC)^.Con1:=PTransfo(OldC)^.Con1+NC;
                 if PTransfo(OldC)^.Con2<>-1 then
                    PTransfo(OldC)^.Con2:=PTransfo(OldC)^.Con2+NC;
                  end;
      Resistance: begin
                 if PResistance(OldC)^.Con1<>-1 then
                    PResistance(OldC)^.Con1:=PResistance(OldC)^.Con1+NC;
                 if PResistance(OldC)^.Con2<>-1 then
                    PResistance(OldC)^.Con2:=PResistance(OldC)^.Con2+NC;
                  end;
      SelfInd  : begin
                 if PSelfInd(OldC)^.Con1<>-1 then
                    PSelfInd(OldC)^.Con1:=PSelfInd(OldC)^.Con1+NC;
                 if PSelfInd(OldC)^.Con2<>-1 then
                    PSelfInd(OldC)^.Con2:=PSelfInd(OldC)^.Con2+NC;
                  end;
      end;

    end;
{ Libere la collection en gardant les elements.
  ces derniers appartiennent a NetWork }
TempColl^.DeleteAll;
Decal.X:=40;
Decal.Y:=40;
MoveComponent( Decal);
{ Reafficher }
InvalidateRect( HWindow, Nil, True);
End;

Procedure TWorksheet.MakeData(var Msg: TMessage);
Var  SlackExist     : Boolean;
     I, N, Npv, Npq,
     Error, K       : Integer;
     InFile         : Text;
     Name           : Array [0..fsPathName] of char;
     SS             : Array [0..300] of char;
     PB1, PB2       : PBus;
     PL             : PLine;


  Procedure UpDateBus ( MyC : PPowerComponent); Far;
  Var GenExist, CompensatorExist : Boolean;
      PB : PBus;

     Procedure UpDatePower( PBC : PBusCon); Far;
     Var  P : PPowerComponent;
     begin
     P:=NetWork^.At( PBC^.Con);
     If P^.HisType=Generator Then Begin
                                  PB^.Pg:=PB^.Pg+PGenerator(P)^.Pg;
                                  PB^.Qgmin:=PB^.Qgmin+PGenerator(P)^.Qgmin;
                                  PB^.Qgmax:=PB^.Qgmax+PGenerator(P)^.Qgmax;
                   { verifie si tous les Generators sont au meme Vsch }
                   if (GenExist or CompensatorExist)
                      and (PB^.Vsch<>PGenerator(P)^.Vsch) then
                                                 begin
                                                 MessageBox( HWindow,
                              'There are different Vsch at the same bus',
                              'Error in data', MB_Ok or MB_IconExclamation);
                                                 Error:=3;
                                                 end;
                                  { continue }
                                  PB^.Vsch:=PGenerator(P)^.Vsch;
                                  GenExist:=True;
                                  End;
     If P^.HisType=Compensator Then
                        Begin
                        PB^.Qgmin:=PB^.Qgmin+PCompensator(P)^.Qgmin;
                        PB^.Qgmax:=PB^.Qgmax+PCompensator(P)^.Qgmax;
                   { verifie si tous les Generators sont au meme Vsch }
                   if (GenExist or CompensatorExist)
                      and (PB^.Vsch<>PCompensator(P)^.Vsch) then
                                                 MessageBox( HWindow,
                              'There are different Vsch at the same bus',
                              'Error in data', MB_Ok or MB_IconExclamation);
                        { continue }
                        PB^.Vsch:=PCompensator(P)^.Vsch;
                        CompensatorExist:=True;
                        End;
     If P^.HisType=Drain Then Begin
                              PB^.PL:=PB^.PL+PDrain(P)^.PD;
                              PB^.QL:=PB^.QL+PDrain(P)^.QD;
                              End;

     end;

  begin
  Error:=0;
  if MyC^.HisType<>Bus Then Exit;
  PB:=PBus(MyC);
  if StrEnd(PB^.Name)-PB^.Name=0Then
                              Begin MessageBox( HWindow,
                              'Buses are not all named',
                              'Error in data', MB_Ok or MB_IconExclamation);
                              Error:=1;
                              Exit;
                              end;
  if PB^.BusType=2 then begin
                        If Not(SlackExist) Then begin
                                                SlackExist:=True;
                                                BusColl^.Insert( PB);
                                                end
                                           Else
                                           begin
                                           MessageBox( HWindow,
                              'There is more than one slack bus specified',
                              'Error in data', MB_Ok or MB_IconExclamation);
                                           Error:=2;
                                           end;
                        Exit;
                        end;
  { si PB^.Status=1  ==> ne touche pas aux donnees du Bus }
  if PB^.Status<>0 then exit;
  PB^.Pg:=0;
  if WSInfo.Study=id_LoadFlow then PB^.Qg:=0;
  PB^.PL:=0;
  PB^.QL:=0;
  PB^.Qgmin:=0;
  PB^.Qgmax:=0;
  GenExist:=False;
  CompensatorExist:=False;
  PB^.ConColl^.ForEach( @UpDatePower);
  If GenExist or CompensatorExist Then PB^.BusType:=1  { PV }
              Else PB^.BusType:=0; { PQ }
{  ------------- !! problem : a compensator bus is a PV bus ?
                 yes of course !  with Pg=0 that's the difference
}
  end;

  Procedure LookForPVBuses ( MyC : PPowerComponent); Far;
  Var PB : PBus;
  begin
  if MyC^.HisType<>Bus Then Exit;
  PB:=PBus(MyC);
  if PB^.BusType<>1 then Exit;  { ie PV only }
  BusColl^.Insert( PB);
  Inc (Npv);
  end;

  Procedure LookForPQBuses ( MyC : PPowerComponent); Far;
  Var PB : PBus;
  begin
  if MyC^.HisType<>Bus Then Exit;
  PB:=PBus(MyC);
  if PB^.BusType<>0 then Exit;  { ie PQ only }
  BusColl^.Insert( PB);
  Inc (Npq);
  end;

  Procedure PutLineDatas ( MyC : PPowerComponent); Far;
  Var PB : PLine;
      PR : PResistance;
      PS : PSelfInd;
      S : Array[0..80] of char;
  begin
  Case MyC^.HisType of
  { for the Line }
        Line : Begin
  PB:=PLine(MyC);
  if StrEnd(PB^.Name)-PB^.Name=0 Then
                 begin
                 Error:=5;
                 MessageBox( HWindow, 'Lines are not all named',
                             'Warning in data', MB_Ok or MB_IconExclamation);
                 end;
  if (PB^.Con1=-1) or (PB^.Con2=-1) then
                 begin
                 Error:=4;
                 StrCopy( S,'Line : ');
                 StrCat( S, PB^.Name);
                 StrCat( S, #13#10'is not connected ');
                 MessageBox( HWindow, S,
                             'Error in data', MB_Ok or MB_IconExclamation);
                 Exit;
                 end;
  PB1:=NetWork^.At(PB^.Con1);
  PB2:=NetWork^.At(PB^.Con2);
  WriteLn( InFile, '3  ',PB1^.Name:12,'  ',PB2^.Name:12,'  ',
            PB^.ZR:7:5,'  ', PB^.ZX:7:5,'  ',
            PB^.G:7:5,'  ',PB^.B:7:5,'  ', PB^.Smax:7:5);
                  End;
  { for the Resistance }
        Resistance : Begin
  PR:=PResistance(MyC);
  if StrEnd(PR^.Name)-PR^.Name=0 Then
                 begin
                 Error:=5;
                 MessageBox( HWindow, 'Resistances are not all named',
                             'Warning in data', MB_Ok or MB_IconExclamation);
                 end;
  if (PR^.Con1=-1) or (PR^.Con2=-1) then
                 begin
                 Error:=4;
                 StrCopy( S,'Resistance : ');
                 StrCat( S, PR^.Name);
                 StrCat( S, #13#10'is not connected ');
                 MessageBox( HWindow, S,
                             'Error in data', MB_Ok or MB_IconExclamation);
                 Exit;
                 end;
  PB1:=NetWork^.At(PR^.Con1);
  PB2:=NetWork^.At(PR^.Con2);
  WriteLn( InFile, '3  ',PB1^.Name:12,'  ',PB2^.Name:12,'  ',
            PR^.ZR:7:5,'  ', PR^.ZX:7:5,'  ',
            PR^.ZX:7:5,'  ',PR^.ZX:7:5,'  ', PR^.Smax:7:5);
            { i.e. zero }
                  End;
  { for the Self }
        SelfInd : Begin
  PS:=PSelfInd(MyC);
  if StrEnd(PS^.Name)-PS^.Name=0 Then
                 begin
                 Error:=5;
                 MessageBox( HWindow, 'Self inductances are not all named',
                             'Warning in data', MB_Ok or MB_IconExclamation);
                 end;
  if (PS^.Con1=-1) or (PS^.Con2=-1) then
                 begin
                 Error:=4;
                 StrCopy( S,'Self inductance : ');
                 StrCat( S, PS^.Name);
                 StrCat( S, #13#10'is not connected ');
                 MessageBox( HWindow, S,
                             'Error in data', MB_Ok or MB_IconExclamation);
                 Exit;
                 end;
  PB1:=NetWork^.At(PS^.Con1);
  PB2:=NetWork^.At(PS^.Con2);
  WriteLn( InFile, '3  ',PB1^.Name:12,'  ',PB2^.Name:12,'  ',
            PS^.ZR:7:5,'  ', PS^.ZX:7:5,'  ',
            PS^.ZR:7:5,'  ',PS^.ZR:7:5,'  ', PS^.Smax:7:5);
            { i.e. zero }
                  End;
         else    Exit
         end; { du case }
  end;

  Procedure PutTransfoDatas ( MyC : PPowerComponent); Far;
  Var PB : PTransfo;
      S : Array[0..80] of char;
  begin
  if MyC^.HisType<>Transfo Then Exit;
  PB:=PTransfo(MyC);
  if StrEnd(PB^.Name)-PB^.Name=0 Then
                 begin
                 Error:=5;
                 MessageBox( HWindow, 'Transfos are not all named',
                             'Warning in data', MB_Ok or MB_IconExclamation);
                 end;
  if (PB^.Con1=-1) or (PB^.Con2=-1) then
                 begin
                 Error:=4;
                 StrCopy( S,'Transfo : ');
                 StrCat( S, PB^.Name);
                 StrCat( S, #13#10'is not connected ');
                 MessageBox( HWindow, S,
                             'Error in data', MB_Ok or MB_IconExclamation);
                 Exit;
                 end;
  PB1:=NetWork^.At(PB^.Con1);
  PB2:=NetWork^.At(PB^.Con2);
  WriteLn( InFile, '4  ',PB1^.Name:12,'  ',PB2^.Name:12,'  ',
           PB^.ZR:7:5,'  ',PB^.ZX:7:5,'  ',
           PB^.Amag:7:5,'  ', PB^.Adelta:6:2,'  ', PB^.Smax:7:5);
  end;

  Procedure PutCapaDatas ( MyC : PPowerComponent); Far;
  Var PB : PCapa;
      S : Array[0..80] of char;
  begin
  if MyC^.HisType<>Capa Then Exit;
  PB:=PCapa(MyC);
  if StrEnd(PB^.Name)-PB^.Name=0 Then
                 begin
                 Error:=5;
                 MessageBox( HWindow, 'Capacitors are not all named',
                             'Warning in data', MB_Ok or MB_IconExclamation);
                 end;
  if PB^.Con=-1  then
                 begin
                 Error:=4;
                 StrCopy( S,'Capacitor : ');
                 StrCat( S, PB^.Name);
                 StrCat( S, #13#10'is not connected ');
                 MessageBox( HWindow, S,
                             'Error in data', MB_Ok or MB_IconExclamation);
                 Exit;
                 end;
  PB1:=NetWork^.At(PB^.Con);
  WriteLn( InFile, '5  ',PB1^.Name:12,'  ',
           PB^.Bc:7:5);
  end;

  Procedure PutMachinesDatas( MyC : PPowerComponent); Far;
  Var Con : Integer;
      PB  : PBus;
      PG  : PSpeGenerator;
      PC  : PSpeCompensator;
      S : Array[0..80] of char;
  begin
  if ( MyC^.HisType<>Generator) And ( MyC^.HisType<>Compensator) Then Exit;
  Case MyC^.HisType of
    Generator   : begin
                  PG:=PSpeGenerator( MyC);
                  Con:=PG^.Con;
                  PB:=PBus( NetWork^.At( Con));
                  WriteLn( InFile, '16 ',PB^.Name:12,'  ',
                           PG^.H:8:5,'  ',PG^.D:8:5,'  ',
                           PG^.R:7:5,'  ',PG^.Xdp:7:5 );
                  if PG^.H=0 then
                             begin
                             Error:=6; { not taken into account }
                             StrCopy( S,'Generator : ');
                             StrCat( S, PG^.Name);
                             StrCat( S, #13#10'has H=0 ');
                             MessageBox( HWindow, S,
                              'Error in data', MB_Ok or MB_IconExclamation);
                             Exit;
                             end;
                  end;
    Compensator : begin
                  PC:=PSpeCompensator( MyC);
                  Con:=PC^.Con;
                  PB:=PBus( NetWork^.At( Con));
                  WriteLn( InFile, '16  ',PB^.Name:12,'  ',
                           PC^.H:8:5,'  ',PC^.D:8:5,'  ',
                           PC^.R:7:5,'  ',PC^.Xdp:7:5 );
                  if PC^.H=0 then
                             begin
                             Error:=6;
                             StrCopy( S,'Compensator ');
                             StrCat( S, PC^.Name);
                             StrCat( S, #13#10'has H=0 ');
                             MessageBox( HWindow, S,
                              'Error in data', MB_Ok or MB_IconExclamation);
                             Exit;
                             end;
                  end;
    end;
  end;

{ Corp de MakeData }
Begin
BusColl^.DeleteAll;
SlackExist:=False;
Npv:=0;
Npq:=0;
NetWork^.ForEach( @UpDateBus);
if Error<>0 Then Exit;
If Not(SlackExist) Then begin MessageBox( HWindow,
                        'There is no slack bus specified', 'Error in data',
                        MB_Ok or MB_IconExclamation);
                        Exit;
                        end;
NetWork^.ForEach( @LookForPVBuses);
NetWork^.ForEach( @LookForPQBuses);
N:=Npv+Npq;
case WSInfo.Study of
 id_LoadFlow :  begin
                Assign( InFile, InName);
                {$I-}
                ReWrite(InFile);
                {$I+}
                If IOResult<>0 Then begin
                    MessageBox (HWindow, InName
                    ,'Openning File Error',mb_Ok+mb_ICONExclamation);
                    Exit;
                    end;
                end;
 id_TransStab : begin        { le nom du fichier differe }
                Assign( InFile, TSInName);
                {$I-}
                ReWrite(InFile);
                {$I+}
                If IOResult<>0 Then begin
                    MessageBox (HWindow, TSInName
                    ,'Openning File Error',mb_Ok+mb_ICONExclamation);
                    Exit;
                    end;
                end;
 end;

WriteLn( InFile, N+1,' ',Npv);
if WSInfo.Study=id_LoadFlow then
                     begin
                     WriteLn( InFile, GS_IterMax,' ', GS_Tol);
                     WriteLn( InFile, NR_IterMax,' ', NR_Tol);
                     end;
{
for Newton-Raphson and Gauss-Seidel specefic NIterMax & Tol
et pas de puissance de base
}
case WSInfo.Study of
 id_LoadFlow :  WriteLn( InFile,
'8 ---------------  Input file for the load flow program  ---------------');
 id_TransStab : WriteLn( InFile,
'8 ----------  Input file for the Transient Stability program  ----------');

 end;
WriteLn( InFile, '8 --- Number of total Buses = ',N+1,'  PV Buses = ',Npv);
WriteLn( InFile, '8');
if WSInfo.Study=id_LoadFlow then
                     begin
                     WriteLn( InFile,
                     '8 --- for GS : Nb IterationsMax = ',GS_IterMax,
                     '  Tolerance = ',GS_Tol);
                     WriteLn( InFile,
                     '8 --- for NR : Nb IterationsMax = ',NR_IterMax,
                     '  Tolerance = ',NR_Tol);
                     end;
WriteLn( InFile, '8 ');
{ Card 1 : Buses }
WriteLn( InFile,
'8 ---------------------------  Bus Data  -------------------------------');
WriteLn( InFile,
         '8  BUS           Pg       Qg       Pl       Ql       Vb');
for I:=0 to N do
  begin
  PB1:=BusColl^.At(I);
  WriteLn( InFile, '1  ', PB1^.Name:12,'  ',PB1^.Pg:7:5,'  ',
          PB1^.Qg:7:5,'  ', PB1^.PL:7:5,'  ',PB1^.QL:7:5,'  ',PB1^.Vsch:7:5);
  end;
{ Card 2 : Active Buses }
if WSInfo.Study=id_LoadFlow then
                     begin
                     WriteLn( InFile,
'8 ------------------------ Active Bus Limits ---------------------------');
                     WriteLn( InFile, '8  BUS           Qgmin    Qgmax');
                     for I:=1 to Npv do
                         begin
                         PB1:=BusColl^.At(I);
                         WriteLn( InFile, '2  ',PB1^.Name:12,'  ',
                                  PB1^.Qgmin:7:5,'  ',PB1^.Qgmax:7:5);
                         end;
                     end;

{ Card 3 : Lines }
WriteLn( InFile,
'8 ----------------------------  Line Data  -----------------------------');
WriteLn( InFile,
  '8  BUS           BUS           Rs       Xs       Gs       Bs       Smax');
NetWork^.ForEach( @PutLineDatas);

{ Card 4 : Transfos }
WriteLn( InFile,
'8 ------------------------  Transformer Data  --------------------------');
WriteLn( InFile,
'8  BUS           BUS           Rs       Xs       Amag     A(deg)  Smax');
NetWork^.ForEach( @PutTransfoDatas);

{ Card 5 : Capas }
WriteLn( InFile,
'8 -------------------------  Capacitor Data  ---------------------------');
WriteLn( InFile,
         '8  BUS           Bc');
NetWork^.ForEach( @PutCapaDatas);

{ Card 9 : Acceleration Factor GS }
WriteLn( InFile,
'8 -----------------------  Acceleration Factor GS  ---------------------');
WriteLn( InFile, '9  ', GS_AccelFact);

{ Card 10 : LoadFlow Output Options }
if WSInfo.Study=id_LoadFlow then
                begin
                WriteLn( InFile,
'8 ----------------------  Load Flow Output Options  --------------------');
                WriteLn( InFile, '10 ', LFOpt);
                end;

{ Now Only TransStab }
if WSInfo.Study=id_TransStab then
   begin
   if VoltageKnown=False then
        begin
        StrCopy( SS,'Load Flow simulation hasen''t been done yet.');
        StrCat ( SS,#13#10'You should call Load Flow and OutputData');
        StrCat ( SS,#13#10'to update initial conditions ( Vmag, delta, Qg... )');
        StrCat ( SS,#13#10'for Transient Stability simulation otherwise');
        StrCat( SS,
        #13#10'Transient Stability simulation wouldn''t be done correctly');
        MessageBox( HWindow, SS, 'Warning', MB_OK+MB_ICONEXCLAMATION );
        end;
   { remet a zero le code de l'etude }
   WSInfo.TSInfo.Code:=0;

{ Card 11 : Bus voltage from Load Flow study }
   WriteLn( InFile,
'8 ----------------  Bus voltage from Load Flow study  ------------------');
   WriteLn( InFile, '8  Bus           mag      arg(deg)');
   for I:=0 to BusColl^.Count-1 do
       begin
       PB1:=BusColl^.At(I);
       WriteLn( InFile, '11 ', PB1^.Name:12,'  ',PB1^.V:7:5,'  ',
                                                 PB1^.Angle:7:5);
       end;

{ Card 16 : Machines Characteristics H, R, Xdp }
   WriteLn( InFile,
'8 ----------------------  Machine Characteristics  --------------------');
   WriteLn( InFile, '8  Bus            H         D        R        Xdp');
   NetWork^.ForEach( @PutMachinesDatas);

{ Card 17 : Monitored Buses }
   WriteLn( InFile,
'8 --------------------------  Monitored Buses  -------------------------');
   WriteLn( InFile, '8  Bus');
   if MonitoredBuses^.Count<>0 then
      for I:=0 to MonitoredBuses^.Count-1 do
              begin
              K:=PBusCon(MonitoredBuses^.At(I))^.Con;
              WriteLn( InFile, '17 ', PBus( NetWork^.At( K ) )^.Name:12);
              end
      else              begin
                        MessageBox( HWindow,
                        'There are no monitored buses specified',
                        'Error in data',
                        MB_Ok or MB_IconExclamation);
                        end;

{ Card 18 : Faulty Bus }
   if WSInfo.TSInfo.FaultedBus<>-1 then
                        begin
                        WSInfo.TSInfo.Code:=WSInfo.TSInfo.Code or id_FaultedBus;
   WriteLn( InFile,
'8 --------------------------  3 Phase Faulty Bus  ----------------------');
   WriteLn( InFile,'8  Bus           Start   End     Gf        Bf');
   WriteLn( InFile, '18 ',
            PBus( NetWork^.At( WSInfo.TSInfo.FaultedBus))^.Name:12,'  ',
            WSInfo.TSInfo.FBt0:6:4,'  ', WSInfo.TSInfo.FBt1:6:4,'  ',
            WSInfo.TSInfo.Gf:8,'  ', WSInfo.TSInfo.Bf:8 );
                        end;

{ Card 19 : Fault Parameters }
   if WSInfo.TSInfo.OpenedLine<>-1 then
      begin
           WSInfo.TSInfo.Code:=WSInfo.TSInfo.Code or id_OpenedLine;
           PL:=PLine( NetWork^.At(WSInfo.TSInfo.OpenedLine));
   WriteLn( InFile,
'8 -----------------------------  Opened Line  --------------------------');
   WriteLn( InFile,'8  BUS           BUS           Start   End');
   WriteLn( InFile, '19 ', PBus( NetWork^.At(PL^.Con1))^.Name:12,'  ',
            PBus( NetWork^.At(PL^.Con2))^.Name:12,'  ',
            WSInfo.TSInfo.OLt0:6:4,'  ', WSInfo.TSInfo.OLt1:6:4 );
   WriteLn( InFile,
   '8  BUS           BUS           Rs       Xs       Gs       Bs');
   WriteLn( InFile, '25 ', PBus( NetWork^.At(PL^.Con1))^.Name:12,'  ',
            PBus( NetWork^.At(PL^.Con2))^.Name:12,'  ',
            PL^.ZR:7:5,'  ', PL^.ZX:7:5,'  ',
            PL^.G:7:5,'  ', PL^.B:7:5);
           end;

{ Card 20 : SwitchedLoad }
   if WSInfo.TSInfo.SwitchedLoad<>-1 then
           begin
           WSInfo.TSInfo.Code:=WSInfo.TSInfo.Code or id_SwitchedLoad;
   WriteLn( InFile,
'8 -------------------------  Increased Bus Load  -----------------------');
   WriteLn( InFile,'8  Bus           Start   End     Pl       Ql       ');
   WriteLn( InFile, '20 ',
            PBus( NetWork^.At( WSInfo.TSInfo.SwitchedLoad))^.Name:12,'  ',
            WSInfo.TSInfo.SLt0:6:4,'  ', WSInfo.TSInfo.SLt1:6:4,'  ',
            WSInfo.TSInfo.SLPL:7:5,'  ',WSInfo.TSInfo.SLQL:7:5 );
           end;

{ Card 21 : DroppedLoad }
   if WSInfo.TSInfo.DroppedLoad<>-1 then
           begin
           WSInfo.TSInfo.Code:=WSInfo.TSInfo.Code or id_DroppedLoad;
   WriteLn( InFile,
'8 --------------------------  Dropped Bus Load  ------------------------');
   WriteLn( InFile,'8  Bus           Start   End     Pl       Ql       ');
   WriteLn( InFile, '21 ',
            PBus( NetWork^.At( WSInfo.TSInfo.DroppedLoad))^.Name:12,'  ',
            WSInfo.TSInfo.DLt0:6:4,'  ', WSInfo.TSInfo.DLt1:6:4,'  ',
            WSInfo.TSInfo.DLPL:7:5,'  ',WSInfo.TSInfo.DLQL:7:5 );
           end;

{ Card 24 : LossGen }
   if WSInfo.TSInfo.LossGen<>-1 then
           begin
           if BusColl^.IndexOf(
                            PBus( NetWork^.At( WSInfo.TSInfo.LossGen)))>Npv
                                 then
                                 begin
                                 MessageBox( HWindow,
                    'The Bus which will lose his Generator is not a PV Bus',
                    'Error in data',
                                 MB_Ok or MB_IconExclamation);
                                 end;
           WSInfo.TSInfo.Code:=WSInfo.TSInfo.Code or id_LossGen;
   WriteLn( InFile,
'8 -------------------------  Lost Bus Generator  -----------------------');
   WriteLn( InFile,'8  Bus           Start   End');
   WriteLn( InFile, '24 ',
            PBus( NetWork^.At( WSInfo.TSInfo.LossGen))^.Name:12,'  ',
            WSInfo.TSInfo.LGt0:6:4,'  ', WSInfo.TSInfo.LGt1:6:4);
           end;

{ Card 22 : Simulation Parameters }
   WriteLn( InFile,
'8 ------------------------  Simulation Parameters  ---------------------');
   WriteLn( InFile,
'8  dt      End     Nimax Tol       eps       Fault freq');
   WriteLn( InFile, '22 ',
    WSInfo.TSInfo.dt:6:4,'  ', WSInfo.TSInfo.t2:6:4,'  ',
    WSInfo.TSInfo.NIterMax:4,'  ',WSInfo.TSInfo.Tol:8,'  ',
    WSInfo.TSInfo.eps:8,'  ',
    WSInfo.TSInfo.Code:4,'  ',WSInfo.TSInfo.freq:6:2 );
    if WSInfo.TSInfo.dt< 0.0001 then
                        begin
                        MessageBox( HWindow,
                          'The time step ( dt ) is too small',
                          'Error in data',
                        MB_Ok or MB_IconExclamation);
                        end;

{ Card 23 : TransStab Output Options }
    WriteLn( InFile,
'8 ----------------  Transient Stability Output Options  ----------------');
    WriteLn( InFile, '23 ', TSOpt);

   end;{end for Trans Stab study }
{end for every study }
WriteLn( InFile,
  '8 ------------------------  END OF INPUT FILE  ------------------------');
{$I-}
Close(InFile);
{$I+}
If IOResult<>0 Then
          begin
          case WSInfo.Study of
               id_LoadFlow  : StrCopy( SS, InName);
               id_TransStab : StrCopy( SS, TSInName);
             end;
          MessageBox (HWindow, SS
                     ,'Closing File Error',mb_Ok+mb_ICONExclamation);
          Exit;
          end;
strcopy( Name, 'NOTEPAD.EXE ');
case WSInfo.Study of
 id_LoadFlow :  strcat( Name, InName);
 id_TransStab : strcat( Name, TSInName);
 end;
WinExec( Name, SW_SHOW);
End;

Function TWorksheet.IsStudyLoadFlow : Boolean;
Begin
if WSInfo.Study<>id_LoadFlow then
             begin
             MessageBox( HWindow,
             'You must first change the study to Load Flow',
             'Load Flow Simulation',MB_OK+MB_IconINFORMATION);
             IsStudyLoadFlow:=False;
             end
             else IsStudyLoadFlow:=True;
End;

Procedure TWorksheet.GaussSeidelCall;
Var  Name : Array [0..200] of char;
Begin
if not IsStudyLoadFlow then exit;
  strcopy( Name, 'LoadFlow.exe 0 ');
  strcat( Name, InName);
  strcat( Name, ' ');
  strcat( Name, OutName);
  WinExec( Name, SW_SHOW);
{CallLoadFlow( 0, InName, OutName);}
Recup:=True;
End;

Procedure TWorksheet.NewtonRaphsonCall;
Var  Name : Array [0..200] of char;
Begin
if not IsStudyLoadFlow then exit;
  strcopy( Name, 'LoadFlow.exe 1 ');
  strcat( Name, InName);
  strcat( Name, ' ');
  strcat( Name, OutName);
  WinExec( Name, SW_SHOW);
{CallLoadFlow( 1, InName, OutName);}
Recup:=True;
End;

Procedure TWorksheet.NRBackOffCall;
Var  Name : Array [0..200] of char;
Begin
if not IsStudyLoadFlow then exit;
  strcopy( Name, 'LoadFlow.exe 2 ');
  strcat( Name, InName);
  strcat( Name, ' ');
  strcat( Name, OutName);
  WinExec( Name, SW_SHOW);
{CallLoadFlow( 2, InName, OutName);}
Recup:=True;
End;

Procedure TWorksheet.FDLCall;
Var  Name : Array [0..200] of char;
Begin
if not IsStudyLoadFlow then exit;
  strcopy( Name, 'LoadFlow.exe 3 ');
  strcat( Name, InName);
  strcat( Name, ' ');
  strcat( Name, OutName);
  WinExec( Name, SW_SHOW);
{CallLoadFlow( 3, InName, OutName);}
Recup:=True;
End;

Procedure TWorksheet.OutPutDataCall(var Msg: TMessage);
Begin
case WSInfo.Study of
  id_LoadFlow  : LFOutPutData;
  id_TransStab : TSOutPutData;
 end;
End;

Procedure TWorksheet.LFOutPutData;
Var  Name : Array [0..fsPathName] of char;
     F : Text;
     N, Npv, I, K        : Integer;
     Vmag, Delta, Pg, Qg : Real;

  procedure NoteIt;
  Begin
  { fichier de sortie de nom -> Var OutName}
  strcopy( Name, 'NOTEPAD.EXE ');
  strcat( Name, OutName);
  WinExec( Name, SW_SHOW);
  End;

  function FileDelete(Nom: PChar): Integer; assembler;
  asm
        PUSH    DS
        LDS     DX,Nom
        MOV     AH,41H
        INT     21H
        JC      @@1
        XOR     AX,AX
  @@1:  NEG     AX
        POP     DS
  end;


Begin
{ Recupere si il ya eu simulation, le OutName.$$$ }
if Recup=False then begin
                    NoteIt;
                    Exit;
                    end;
Recup:=False; { interdit une autre recuperation tant que non new simulation}
{ Recupere si il existe et si il est conforme le OutName.$$$ }
StrLCopy( Name, OutName, StrEnd(OutName)-OutName-3);
Strcat( Name, '$$$');
Assign( F, Name);
{$I-}
Reset(F);
{$I+}
if IOResult<>0 then
               begin
               StrCopy( Name,'Can''t update datas on WorkSheet'#13#10);
               Strcat( Name, 'Error opening feedback file');
               MessageBox( HWindow, Name,'DATA ERROR',
                           MB_OK+MB_ICONEXCLAMATION );
               MessageBeep( MB_ICONHAND);
               NoteIt;
               Exit;
               end;
Readln( F , N, Npv);
if N<>BusColl^.Count-1 then
               begin
               StrCopy( Name,'Can''t update datas on WorkSheet'#13#10);
               Strcat( Name, 'Datas don''t match');
               MessageBox( HWindow, Name,'DATA ERROR',
                           MB_OK+MB_ICONEXCLAMATION );
               MessageBeep( MB_ICONHAND);
               Close(F);
               NoteIt;
               Exit;
               end;
for I:=0 to N do
    begin
    Readln( F , Vmag, Delta);
    PBus(BusColl^.At(I))^.V:=Vmag;
    PBus(BusColl^.At(I))^.Angle:=Delta;
    end;
Readln( F , Pg, Qg);
PBus(BusColl^.At(0))^.Pg:=Pg;
PBus(BusColl^.At(0))^.Qg:=Qg;

for I:=1 to Npv do
    begin
    Readln( F , Qg);
    PBus(BusColl^.At(I))^.Qg:=Qg;
    end;
VoltageKnown:=True; { You can call MakeData for TransStab
                      coz Voltage has been UpDated }
Close(F);
NoteIt;
{ Delete the file Name }
StrLCopy( Name, OutName, StrEnd(OutName)-OutName-3);
Strcat( Name, '$$$');
FileDelete( Name);
End;

Procedure TWorksheet.TSOutPutData;
Var  Name : Array [0..fsPathName] of char;
Begin
strcopy( Name, 'NOTEPAD.EXE ');
strcat( Name, TSOutName);
WinExec( Name, SW_SHOW);
End;

Procedure TWorksheet.CMInfos(var Msg: TMessage);
Var N, NGen, NComp, NLine, NTransfo, NLoad, NCapa,
    NResistance, NSelfInd : Integer;
    S : Array[0..400] of Char;
    S1 : Array[0..100] of Char;

  procedure CountComponents( MyC : PPowerComponent); Far;
  begin
  if MyC^.HisType=Generator then inc( NGen);
  if MyC^.HisType=Compensator then inc( NComp);
  if MyC^.HisType=Bus then inc( N);
  if MyC^.HisType=Line then inc( NLine);
  if MyC^.HisType=Transfo then inc( NTransfo);
  if MyC^.HisType=drain then inc( NLoad);
  if MyC^.HisType=Capa then inc( NCapa);
  if MyC^.HisType=Resistance then inc( NResistance);
  if MyC^.HisType=SelfInd then inc( NSelfInd);
  end;
Begin
N:=0;
NGen:=0;
NComp:=0;
NLine:=0;
NTransfo:=0;
NLoad:=0;
NCapa:=0;
NResistance:=0;
NSelfInd:=0;
NetWork^.ForEach( @CountComponents);
StrCopy( S, 'Number of'#13#10#13#10);
WVSPrintF( S1, ' Buses : %d'#13#10, N);
StrCat( S, S1);
WVSPrintF( S1, ' Generators : %d'#13#10, NGen);
StrCat( S, S1);
WVSPrintF( S1, ' Compensators : %d'#13#10, NComp);
StrCat( S, S1);
WVSPrintF( S1, ' Lines : %d'#13#10, NLine);
StrCat( S, S1);
WVSPrintF( S1, ' Transformators : %d'#13#10, NTransfo);
StrCat( S, S1);
WVSPrintF( S1, ' Loads : %d'#13#10, NLoad);
StrCat( S, S1);
WVSPrintF( S1, ' Capacitors : %d'#13#10, NCapa);
StrCat( S, S1);
WVSPrintF( S1, ' Resistances : %d'#13#10, NResistance);
StrCat( S, S1);
WVSPrintF( S1, ' Self Inductances : %d'#13#10, NSelfInd);
StrCat( S, S1);
MessageBox( HWindow, S, 'General Informations',
            MB_OK+MB_IconInformation);
End;

Procedure TWorksheet.CMLoadFlowStudy(var Msg: TMessage);
Begin
WSInfo.Study:=id_LoadFlow;
{ pour que les defauts disparaissent }
InvalidateRect ( HWindow, Nil, True);
{Call the SpeedBar, Affiche Study et change le menu }
PDesigner( Parent)^.SetStudyFlag( @Self);
PDesigner( Parent)^.AdjustMenu( @Self);
End;

Procedure TWorksheet.CMTransStabStudy(var Msg: TMessage);
Begin
WSInfo.Study:=id_TransStab;
{ pour que les defauts apparaissent }
InvalidateRect ( HWindow, Nil, True);
{Call the SpeedBar, Affiche Study et change le menu }
PDesigner( Parent)^.SetStudyFlag( @Self);
PDesigner( Parent)^.AdjustMenu( @Self);
End;

{ ne jamais donner a une methode et a une ressource le meme id !
  et surtout ne pas utiliser des BWCC si on ne les inclus pas dans Units }
Procedure TWorksheet.WorkSheetOpt(var Msg: TMessage);
Var Rec : WSOptRec;
    D : PDialog;
    C : PCheckBox;
    E : PEdit;
    IX, IY, IW, IH, ValCode : Integer;
Begin
D:=New( PDialog, Init( @self, 'WorkSheetOptions'));
New(C, InitResource(D, 101));
New(C, InitResource(D, 102));
New(C, InitResource(D, 103));
New(C, InitResource(D, 104));
New(C, InitResource(D, 105));
New(C, InitResource(D, 106));
New(C, InitResource(D, 107));
New(C, InitResource(D, 108));
New(E, InitResource(D, 109, SizeOf( Rec.width)));
New(E, InitResource(D, 110, SizeOf( Rec.Height)));

with WSInfo do
  begin
  Rec.Generator:=(WSOpt and id_GeneratorOn)=id_GeneratorOn;
  Rec.Bus:=(WSOpt and id_BusOn)=id_BusOn;
  Rec.Line:=(WSOpt and id_LineOn)=id_LineOn;
  Rec.Transfo:=(WSOpt and id_TransfoOn)=id_TransfoOn;
  Rec.Drain:=(WSOpt and id_DrainOn)=id_DrainOn;
  Rec.Compensator:=(WSOpt and id_CompensatorOn)=id_CompensatorOn;
  Rec.Capa:=(WSOpt and id_CapaOn)=id_CapaOn;
  Rec.Moveable:=(WSOpt and id_Moveable)=id_Moveable;
  end;
Str( Scroller^.XRange*Scroller^.XUnit, Rec.Width);
Str( Scroller^.YRange*Scroller^.YUnit, Rec.Height);

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
          Then
          begin
{ attention a 256, Pb elemine car word }
          with WSInfo do
            begin
          if Rec.Generator then WSOpt:=WSOpt or id_GeneratorOn
                           else WSOpt:=WSOpt and not id_GeneratorOn;
          if Rec.Bus then WSOpt:=WSOpt or id_BusOn
                     else WSOpt:=WSOpt and not id_BusOn;
          if Rec.Line then WSOpt:=WSOpt or id_LineOn
                      else WSOpt:=WSOpt and not id_LineOn;
          if Rec.Transfo then WSOpt:=WSOpt or id_TransfoOn
                         else WSOpt:=WSOpt and not id_TransfoOn;
          if Rec.Drain then WSOpt:=WSOpt or id_DrainOn
                       else WSOpt:=WSOpt and not id_DrainOn;
          if Rec.Compensator then WSOpt:=WSOpt or id_CompensatorOn
                             else WSOpt:=WSOpt and not id_CompensatorOn;
          if Rec.Capa then WSOpt:=WSOpt or id_CapaOn
                      else WSOpt:=WSOpt and not id_CapaOn;
          if Rec.Moveable then begin
                               WSOpt:=WSOpt or id_Moveable;
                               PDesigner( Parent)^.SetInfoFlag( @Self);
                               end
                          else begin
                               WSOpt:=WSOpt and not id_Moveable;
                               PDesigner( Parent)^.SetInfoFlag( @Self);
                               end;
             end;
          IX:=Scroller^.XRange;
          IY:=Scroller^.YRange;
          Val(Rec.Width, IW, ValCode);
          if ValCode=0 then { conversion ok }
                       begin
                       if (IW>999) and (IW<30001) then
                                        IX:=IW div Scroller^.XUnit;
                       end;
          Val(Rec.Height, IH, ValCode);
          if ValCode=0 then { conversion ok }
                       begin
                       if (IH>999) and (IH<30001) then
                                        IY:=IH div Scroller^.YUnit;
                       end;
          { met a jour }
          Scroller^.SetRange( IX, IY);
          HasChanged:=True;
          { Reafficher }
          InvalidateRect( HWindow, Nil, True);
{          UpDateWindow( HWindow);}
          end;
End;

Procedure TWorksheet.LFFileNames;
Var Rec : DlgFileNamesRec;
    D : PDialog;
    E : PEdit;
Begin
D:=New( PDialog, Init( @self, 'OptFileNames'));
New(E, InitResource(D, id_InName, SizeOf( Rec.InName)));
New(E, InitResource(D, id_OutName, SizeOf( Rec.OutName)));
StrCopy(Rec.InName, InName);
StrCopy(Rec.OutName, OutName);
D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then
                             begin
                             StrCopy(InName, Rec.InName);
                             StrCopy(OutName, Rec.OutName);
                             HasChanged:=True;
                             end;
End;
Procedure TWorksheet.STFileNames;
Var Rec : DlgSTFileNamesRec;
    D : PDialog;
    E : PEdit;
Begin
D:=New( PDialog, Init( @self, 'OptTSFileNames'));
New(E, InitResource(D, id_InName, SizeOf( Rec.InName)));
New(E, InitResource(D, id_OutName, SizeOf( Rec.OutName)));
New(E, InitResource(D, 103, SizeOf( Rec.ResultName)));
StrCopy(Rec.InName, TSInName);
StrCopy(Rec.OutName, TSOutName);
StrCopy(Rec.ResultName, TSResultName);

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then
                             begin
                             StrCopy(TSInName, Rec.InName);
                             StrCopy(TSOutName, Rec.OutName);
                             StrCopy(TSResultName, Rec.ResultName);
                             HasChanged:=True;
                             end;
End;

Procedure TWorksheet.OptFileNames(var Msg: TMessage);
Begin
case WSInfo.Study of
  id_LoadFlow  : LFFileNames;
  id_TransStab : STFileNames;
 end;
End;

Procedure TWorksheet.LoadFlowOptions(var Msg: TMessage);
Var Rec : LFOptionsRec;
    D : PDialog;
    E : PEdit;
    C : PCheckBox;
    ValCode : Integer;

Begin
D:=New( PDialog, Init( @self, 'LoadFlowOptions'));
New(E, InitResource(D, id_GS_IterMax, SizeOf( Rec.GS_IterMax)));
New(E, InitResource(D, id_GS_Tol, SizeOf( Rec.GS_Tol)));
New(E, InitResource(D, id_GS_AccelFact, SizeOf( Rec.GS_AccelFact)));
New(E, InitResource(D, id_NR_IterMax, SizeOf( Rec.NR_IterMax)));
New(E, InitResource(D, id_NR_Tol, SizeOf( Rec.NR_Tol)));

New(C, InitResource(D, id_YMatrix));
New(C, InitResource(D, id_KL_YL));
New(C, InitResource(D, id_Jacobien));
New(C, InitResource(D, id_SLineMax));
New(C, InitResource(D, id_Sg_Sd));
New(C, InitResource(D, id_LineTrans));
New(C, InitResource(D, id_V));
New(C, InitResource(D, id_VAux));
New(C, InitResource(D, id_Arrilaga));

Str( GS_IterMax, Rec.GS_IterMax);
Str( GS_Tol, Rec.GS_Tol);
Str( GS_AccelFact, Rec.GS_AccelFact);
Str( NR_IterMax, Rec.NR_IterMax);
Str( NR_Tol, Rec.NR_Tol);

Rec.YMatrix:=(LFOpt and id_YMatrixOut)=id_YMatrixOut;
Rec.KL_YL:=(LFOpt and id_KL_YLOut)=id_KL_YLOut;
Rec.Jacobien:=(LFOpt and id_JacobienOut)=id_JacobienOut;
Rec.SLineMax:=(LFOpt and id_SLineMaxOut)=id_SLineMaxOut;
Rec.Sg_Sd:=(LFOpt and id_Sg_SdOut)=id_Sg_SdOut;
Rec.LineTrans:=(LFOpt and id_LineTransOut)=id_LineTransOut;
Rec.V:=(LFOpt and id_V_Out)=id_V_Out;
Rec.VAux:=(LFOpt and id_VAux_Out)=id_VAux_Out;
Rec.Arrilaga:=(LFOpt and id_ArrilagaOut)=id_ArrilagaOut;

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then
           begin
           Val(Rec.GS_IterMax, GS_IterMax, ValCode);
           Val(Rec.GS_Tol, GS_Tol, ValCode);
           Val(Rec.GS_AccelFact, GS_AccelFact, ValCode);
           Val(Rec.NR_IterMax, NR_IterMax, ValCode);
           Val(Rec.NR_Tol, NR_Tol, ValCode);
           if Rec.YMatrix then LFOpt:=LFOpt or id_YMatrixOut
                          else LFOpt:=LFOpt and not id_YMatrixOut;
           if Rec.KL_YL then LFOpt:=LFOpt or id_KL_YLOut
                          else LFOpt:=LFOpt and not id_KL_YLOut;
           if Rec.Jacobien then LFOpt:=LFOpt or id_JacobienOut
                          else LFOpt:=LFOpt and not id_JacobienOut;
           if Rec.SLineMax then LFOpt:=LFOpt or id_SLineMaxOut
                          else LFOpt:=LFOpt and not id_SLineMaxOut;
           if Rec.Sg_Sd then LFOpt:=LFOpt or id_Sg_SdOut
                          else LFOpt:=LFOpt and not id_Sg_SdOut;
           if Rec.LineTrans then LFOpt:=LFOpt or id_LineTransOut
                          else LFOpt:=LFOpt and not id_LineTransOut;
           if Rec.V then LFOpt:=LFOpt or id_V_Out
                          else LFOpt:=LFOpt and not id_V_Out;
           if Rec.VAux then LFOpt:=LFOpt or id_VAux_Out
                          else LFOpt:=LFOpt and not id_VAux_Out;
           if Rec.Arrilaga then LFOpt:=LFOpt or id_ArrilagaOut
                          else LFOpt:=LFOpt and not id_ArrilagaOut;
           HasChanged:=True;
           end;
End;

Procedure TWorksheet.TransStabOptions(var Msg: TMessage);
Var  D : PDialog;
     E : PEdit;
     SS: PStatic;
     I,Num : Integer;
     S1 : Array [0..40] Of Char;
     Rec : TSOptionsRec;
     ValCode : Integer;

Begin
D:=New( PDialog, Init( @self, 'TransStabOptions'));
New(E, InitResource(D, 101, SizeOf(Rec.eps)));
New(E, InitResource(D, 102, SizeOf(Rec.NIterMax)));
New(E, InitResource(D, 103, SizeOf(Rec.Tol)));
New(E, InitResource(D, 118, SizeOf(Rec.freq)));
New(E, InitResource(D, 104, SizeOf(Rec.dt)));
New(E, InitResource(D, 105, SizeOf(Rec.t2)));
New(E, InitResource(D, 106, SizeOf(Rec.FBt0)));
New(E, InitResource(D, 107, SizeOf(Rec.FBt1)));
New(E, InitResource(D, 121, SizeOf(Rec.Gf)));
New(E, InitResource(D, 122, SizeOf(Rec.Bf)));
New(E, InitResource(D, 108, SizeOf(Rec.OLt0)));
New(E, InitResource(D, 109, SizeOf(Rec.OLt1)));
New(E, InitResource(D, 110, SizeOf(Rec.SLt0)));
New(E, InitResource(D, 111, SizeOf(Rec.SLt1)));
New(E, InitResource(D, 114, SizeOf(Rec.SLPL)));
New(E, InitResource(D, 115, SizeOf(Rec.SLQL)));
New(E, InitResource(D, 112, SizeOf(Rec.DLt0)));
New(E, InitResource(D, 113, SizeOf(Rec.DLt1)));
New(E, InitResource(D, 116, SizeOf(Rec.DLPL)));
New(E, InitResource(D, 117, SizeOf(Rec.DLQL)));
New(E, InitResource(D, 119, SizeOf(Rec.LGt0)));
New(E, InitResource(D, 120, SizeOf(Rec.LGt1)));
New(SS, InitResource(D, 100, SizeOf(Rec.FaultCode)));
with WSInfo.TSInfo do
  begin
  Str( eps, Rec.eps);
  Str( NIterMax, Rec.NIterMax);
  Str( Tol, Rec.Tol);
  Str( freq:5:2, Rec.freq);
  Str( dt:6:4, Rec.dt);
  Str( t2:6:4, Rec.t2);
  Str( FBt0:6:4, Rec.FBt0);
  Str( FBt1:6:4, Rec.FBt1);
  Str( Gf:8, Rec.Gf);
  Str( Bf:8, Rec.Bf);
  Str( OLt0:6:4, Rec.OLt0);
  Str( OLt1:6:4, Rec.OLt1);
  Str( SLt0:6:4, Rec.SLt0);
  Str( SLt1:6:4, Rec.SLt1);
  Str( SLPL:7:5, Rec.SLPL);
  Str( SLQL:7:5, Rec.SLQL);
  Str( DLt0:6:4, Rec.DLt0);
  Str( DLt1:6:4, Rec.DLt1);
  Str( DLPL:7:5, Rec.DLPL);
  Str( DLQL:7:5, Rec.DLQL);
  Str( LGt0:6:4, Rec.LGt0);
  Str( LGt1:6:4, Rec.LGt1);

  StrCopy( Rec.FaultCode, '');
  if FaultedBus<>-1 then
                     begin
                     StrCat( Rec.FaultCode, '3 P Faulty Bus : ');
                     StrCat( Rec.FaultCode,
                             PBus( NetWork^.At( FaultedBus) )^.Name);
                     StrCat( Rec.FaultCode, #13#10);
                     end;
  if OpenedLine<>-1 then
                     begin
                     StrCat( Rec.FaultCode, 'Opened Line : ');
                     StrCat( Rec.FaultCode,
                             PBus( NetWork^.At( OpenedLine) )^.Name);
                     StrCat( Rec.FaultCode, #13#10);
                     end;
  if SwitchedLoad<>-1 then
                     begin
                     StrCat( Rec.FaultCode, 'UpLoaded Bus : ');
                     StrCat( Rec.FaultCode,
                           PBus( NetWork^.At( SwitchedLoad) )^.Name);
                     StrCat( Rec.FaultCode, #13#10);
                     end;
  if DroppedLoad<>-1 then
                     begin
                     StrCat( Rec.FaultCode, 'Dropped Bus Load : ');
                     StrCat( Rec.FaultCode,
                           PBus( NetWork^.At( DroppedLoad) )^.Name);
                     StrCat( Rec.FaultCode, #13#10);
                     end;
  if LossGen<>-1 then
                     begin
                     StrCat( Rec.FaultCode, 'Loss of Bus Gen : ');
                     StrCat( Rec.FaultCode,
                           PBus( NetWork^.At( LossGen) )^.Name);
                     StrCat( Rec.FaultCode, #13#10);
                     end;
  StrCat( Rec.FaultCode, #13#10'Monitored Buses :'#13#10);
  If MonitoredBuses^.Count=0 Then StrCat( Rec.FaultCode, #13#10'No One'#13#10)
                    Else
                    For I:=0 to MonitoredBuses^.Count-1 do
                        Begin
                        Num:=PBusCon(MonitoredBuses^.At(I))^.Con;
                        StrCopy( S1, PBus( NetWork^.At( Num))^.Name );
                        If StrComp(S1, '')=0 Then
                                        StrCopy( S1,'No name entered');
                        StrCat( Rec.FaultCode, '      ');
                        StrCat( Rec.FaultCode, S1);
                        StrCat( Rec.FaultCode, #13#10);
                        End;
D^.TransferBuffer := @Rec;

If Application^.ExecDialog(D)<>idCancel
                             Then Begin
                             Val( Rec.eps, eps, ValCode);
                             Val( Rec.NIterMax, NIterMax, ValCode);
                             Val( Rec.Tol, Tol, ValCode);
                             Val( Rec.freq, freq, ValCode);
                             Val( Rec.dt, dt, ValCode);
                             Val( Rec.t2, t2, ValCode);
                             Val( Rec.FBt0, FBt0, ValCode);
                             Val( Rec.FBt1, FBt1, ValCode);
                             Val( Rec.Gf, Gf, ValCode);
                             Val( Rec.Bf, Bf, ValCode);
                             Val( Rec.OLt0, OLt0, ValCode);
                             Val( Rec.OLt1, OLt1, ValCode);
                             Val( Rec.SLt0, SLt0, ValCode);
                             Val( Rec.SLt1, SLt1, ValCode);
                             Val( Rec.SLPL, SLPL, ValCode);
                             Val( Rec.SLQL, SLQL, ValCode);
                             Val( Rec.DLt0, DLt0, ValCode);
                             Val( Rec.DLt1, DLt1, ValCode);
                             Val( Rec.DLPL, DLPL, ValCode);
                             Val( Rec.DLQL, DLQL, ValCode);
                             Val( Rec.LGt0, LGt0, ValCode);
                             Val( Rec.LGt1, LGt1, ValCode);
                             HasChanged:=True;
                             End;
  end; { de with  WSInfo.TSInfo }
End;

Procedure TWorksheet.TransStabOutputOptions(var Msg: TMessage);
Var Rec : TSOutOptionsRec;
    D : PDialog;
    E : PEdit;
    C : PCheckBox;
    ValCode : Integer;

Begin
D:=New( PDialog, Init( @self, 'TSOutOptions'));

New(C, InitResource(D, 100));
New(C, InitResource(D, 101));
New(C, InitResource(D, 102));
New(C, InitResource(D, 103));
New(C, InitResource(D, 104));

Rec.YMatrix:=(TSOpt and id_TSYMatrixOut)=id_TSYMatrixOut;
Rec.Machine:=(TSOpt and id_TSMachine)=id_TSMachine;
Rec.VAux:=(TSOpt and id_TSVAuxOut)=id_TSVAuxOut;
Rec.LFError:=(TSOpt and id_TSLFError)=id_TSLFError;
Rec.Trapeze:=(TSOpt and id_TSTrapeze)=id_TSTrapeze;

D^.TransferBuffer := @Rec;
If Application^.ExecDialog(D)<>idCancel
                             Then
           begin
           if Rec.YMatrix then TSOpt:=TSOpt or id_TSYMatrixOut
                          else TSOpt:=TSOpt and not id_TSYMatrixOut;
           if Rec.Machine then TSOpt:=TSOpt or id_TSMachine
                          else TSOpt:=TSOpt and not id_TSMachine;
           if Rec.VAux then TSOpt:=TSOpt or id_TSVAuxOut
                          else TSOpt:=TSOpt and not id_TSVAuxOut;
           if Rec.LFError then TSOpt:=TSOpt or id_TSLFError
                          else TSOpt:=TSOpt and not id_TSLFError;
           if Rec.Trapeze then TSOpt:=TSOpt or id_TSTrapeze
                          else TSOpt:=TSOpt and not id_TSTrapeze;
           HasChanged:=True;
           end;
End;
{
Procedure TWorksheet.TestOverflow(var Msg: TMessage);
Var  MyComponent : PPowerComponent;
Begin
     I : Integer;
     S, SI : Array [0..80] of char;}
{ Testing Heap Overflow
I:=0;
repeat
  MyComponent:=New(PBus, Init( Bus));
  if MyComponent=nil then NoMoreMemory
                   else CreateComponent ( MyComponent);

  ReleaseDC( HWindow, DragDC);
  ReleaseCapture;
  LButtonDown:=False;
  inc(I);
if I/1000=I div 1000 then begin
StrCopy( S,'Number of Buses accepted until now'#13#10);
Str( I, SI);
StrCat( S, SI);
MessageBox( HWindow, S,'No Heap Overflow',
            MB_OK+MB_ICONHAND);
end;
until MyComponent=nil;
MessageBeep( MB_ICONHAND);
StrCopy( S,'Number of Buses accepted'#13#10);
Str( I, SI);
StrCat( S, SI);
MessageBox( HWindow, S,'Heap Overflow Error',
            MB_OK+MB_ICONHAND);
End;
}

Function TWorksheet.IsStudyTransStab : Boolean;
Begin
if WSInfo.Study<>id_TransStab then
            begin
            MessageBox( HWindow,
            'You must first change the study to Transient Stability',
            'Transient Stability Simulation',MB_OK+MB_IconINFORMATION);
            IsStudyTransStab:=False;
            end
            else IsStudyTransStab:=True;
End;

Procedure TWorksheet.CMFaultBus(var Msg: TMessage);
Var PB : PBus;
    Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0) and ( WSInfo.TSInfo.FaultedBus<>-1)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10'the old faulty bus : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.FaultedBus) )^.Name);
   StrCat( S, ' ?');
   Ans:=MessageBox( HWindow, S,'Clear Faulty Bus',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.FaultedBus:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   Exit;
   end;

if (SelectedComponents^.Count<>1)
   or (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Bus) then
                                  begin
                                  MessageBox( HWindow,
                        'You have to select one bus to set it as faulty',
                        'Faulty Bus Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
PB:=PBus(SelectedComponents^.At(0));
if WSInfo.TSInfo.FaultedBus<>-1 then
   begin   { un FautedBus existait deja }
   StrCopy( S,'Do you realy want to replace'#13#10'the old faulty bus : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.FaultedBus) )^.Name);
   StrCat( S, #13#10'by the new faulty bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, ' ?');
   end
   else
   begin
   StrCopy( S,'Do you realy want to let'#13#10'the bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, #13#10'be the new faulty bus ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify Faulty Bus',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then begin
                   WSInfo.TSInfo.FaultedBus:=NetWork^.IndexOf( PB);
                   InvalidateRect ( HWindow, Nil, True);
                   end;
End;

Procedure TWorksheet.CMOpenLine(var Msg: TMessage);
Var PL : PLine;
    Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0) and ( WSInfo.TSInfo.OpenedLine<>-1)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10'the old opened line : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.OpenedLine) )^.Name);
   StrCat( S, ' ?');
   Ans:=MessageBox( HWindow, S,'Clear Opened Line',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.OpenedLine:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   Exit;
   end;

if (SelectedComponents^.Count<>1)
   or (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Line) then
                                  begin
                                  MessageBox( HWindow,
                        'You have to select one line to set it opened',
                        'Opened Line Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
PL:=PLine(SelectedComponents^.At(0));
if WSInfo.TSInfo.OpenedLine<>-1 then
   begin   { un OpenedLine existait deja }
   StrCopy( S,'Do you realy want to replace'#13#10'the old opened line : ');
   StrCat( S, PLine( NetWork^.At( WSInfo.TSInfo.OpenedLine) )^.Name);
   StrCat( S, #13#10'by the new opened line : ');
   StrCat( S, PL^.Name);
   StrCat( S, ' ?');
   end
   else
   begin
   StrCopy( S,'Do you realy want to let'#13#10'the line : ');
   StrCat( S, PL^.Name);
   StrCat( S, #13#10'be the new opened line ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify Opened Line',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then begin
                   WSInfo.TSInfo.OpenedLine:=NetWork^.IndexOf( PL);
                   InvalidateRect ( HWindow, Nil, True);
                   end;
End;

Procedure TWorksheet.CMSwitchLoad(var Msg: TMessage);
Var PB : PBus;
    Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0) and ( WSInfo.TSInfo.SwitchedLoad<>-1)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10);
   StrCat( S, 'the old uploaded bus : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.SwitchedLoad) )^.Name);
   StrCat( S, ' ?');
   Ans:=MessageBox( HWindow, S,'Clear UpLoaded Bus',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.SwitchedLoad:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   Exit;
   end;

if (SelectedComponents^.Count<>1)
   or (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Bus) then
                                  begin
                                  MessageBox( HWindow,
                       'You have to select one bus to increase its load',
                       'UpLoaded Bus Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
PB:=PBus(SelectedComponents^.At(0));
if WSInfo.TSInfo.SwitchedLoad<>-1 then
   begin   { un SwitchedLoad existait deja }
   StrCopy( S,'Do you realy want to replace'#13#10);
   StrCat( S, 'the old uploaded bus : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.SwitchedLoad) )^.Name);
   StrCat( S, #13#10'by the new uploaded bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, ' ?');
   end
   else
   begin
   StrCopy( S,'Do you realy want to let'#13#10'the bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, #13#10'be the new uploaded bus ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify UpLoaded Bus',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then begin
                   WSInfo.TSInfo.SwitchedLoad:=NetWork^.IndexOf( PB);
                   InvalidateRect ( HWindow, Nil, True);
                   end;
End;

Procedure TWorksheet.CMDropLoad(var Msg: TMessage);
Var PB : PBus;
    Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0) and ( WSInfo.TSInfo.DroppedLoad<>-1)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10);
   StrCat( S, 'the old dropped bus load : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.DroppedLoad) )^.Name);
   StrCat( S, ' ?');
   Ans:=MessageBox( HWindow, S,'Clear Dropped Bus Load',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.DroppedLoad:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   Exit;
   end;

if (SelectedComponents^.Count<>1)
   or (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Bus) then
                                  begin
                                  MessageBox( HWindow,
                       'You have to select one bus to drop its load',
                       'Dropped Bus Load Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
PB:=PBus(SelectedComponents^.At(0));
if WSInfo.TSInfo.DroppedLoad<>-1 then
   begin   { un DroppedLoad existait deja }
   StrCopy( S,'Do you realy want to replace'#13#10);
   StrCat( S, 'the old dropped bus load : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.DroppedLoad) )^.Name);
   StrCat( S, #13#10'by the new dropped bus load : ');
   StrCat( S, PB^.Name);
   StrCat( S, ' ?');
   end
   else
   begin
   StrCopy( S,'Do you realy want to let'#13#10'the bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, #13#10'be the new dropped bus load ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify Dropped Bus Load',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then begin
                   WSInfo.TSInfo.DroppedLoad:=NetWork^.IndexOf( PB);
                   InvalidateRect ( HWindow, Nil, True);
                   end;
End;

Procedure TWorksheet.CMLossGen(var Msg: TMessage);
Var PB : PBus;
    Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0) and ( WSInfo.TSInfo.LossGen<>-1)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10);
   StrCat( S, 'the old lost bus generator : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.LossGen) )^.Name);
   StrCat( S, ' ?');
   Ans:=MessageBox( HWindow, S,'Clear Lost Bus Generator',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.LossGen:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   Exit;
   end;

if (SelectedComponents^.Count<>1)
   or (PPowerComponent(SelectedComponents^.At(0))^.HisType<>Bus) then
                                  begin
                                  MessageBox( HWindow,
                 'You have to select one bus which will lose its generator',
                 'Lost Bus Generator Error', MB_Ok+MB_IconExclamation);
                                  Exit;
                                  end;
PB:=PBus(SelectedComponents^.At(0));
if WSInfo.TSInfo.LossGen<>-1 then
   begin   { un DroppedLoad existait deja }
   StrCopy( S,'Do you realy want to replace'#13#10);
   StrCat( S, 'the old lost bus generator : ');
   StrCat( S, PBus( NetWork^.At( WSInfo.TSInfo.LossGen) )^.Name);
   StrCat( S, #13#10'by the new bus which will lose its generator : ');
   StrCat( S, PB^.Name);
   StrCat( S, ' ?');
   end
   else
   begin
   StrCopy( S,'Do you realy want to let'#13#10'the bus : ');
   StrCat( S, PB^.Name);
   StrCat( S, #13#10'be the new bus which will lose its generator ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify Lost Bus Generator',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then begin
                   WSInfo.TSInfo.LossGen:=NetWork^.IndexOf( PB);
                   InvalidateRect ( HWindow, Nil, True);
                   end;
End;

Procedure TWorksheet.CMClearAll(var Msg: TMessage);
Var Ans : Integer;
    S : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
if ( SelectedComponents^.Count=0)
   then
   begin
   StrCopy( S,'Do you realy want to clear'#13#10);
   StrCat( S, 'all the faults');
   Ans:=MessageBox( HWindow, S,'Clear All Faults',
            MB_YesNo+MB_ICONQuestion);
   if Ans=id_yes then begin
                      WSInfo.TSInfo.FaultedBus:=-1;
                      WSInfo.TSInfo.OpenedLine:=-1;
                      WSInfo.TSInfo.SwitchedLoad:=-1;
                      WSInfo.TSInfo.DroppedLoad:=-1;
                      WSInfo.TSInfo.LossGen:=-1;
                      InvalidateRect ( HWindow, Nil, True);
                      end;
   end
   else
   MessageBox( HWindow,
     'You have to select no component while clearing all the faults',
     'Clear All Faults Error', MB_Ok+MB_IconExclamation);
End;

Procedure TWorksheet.CMMonitorBus(var Msg: TMessage);
Var P : PPowerComponent;
    PB : PBus;
    NbS, Ans, I, K : Integer;
    PBC : PBusCon;
    S : Array [0..200] of char;

    Function IsNotBus( MyC : PPowerComponent) : Boolean; Far;
    begin
    if MyC^.HisType<>Bus then IsNotBus:=True
                         else IsNotBus:=False;
    end;

Begin
if not IsStudyTransStab then exit;
NbS:=SelectedComponents^.Count;
if ( NbS=0) or ( NbS>4)
   then
   begin
   MessageBox( HWindow,
   'You have to select up to 4 buses to monitor',
   'Monitored Buses Error', MB_Ok+MB_IconExclamation);
   Exit;
   end;
{ check if all are buses }
P:=SelectedComponents^.FirstThat( @IsNotBus);
if P<>nil then
          begin
          MessageBox( HWindow,
          'Only Buses ( machines ) can be monitored',
          'Monitored Buses Error', MB_Ok+MB_IconExclamation);
          Exit;
          end;
if MonitoredBuses^.Count<>0 then
   begin   { des MonitoredBuses existaient deja }
   StrCopy( S,'Do you realy want to replace the monitored buses : ');
   for I:=0 to MonitoredBuses^.Count-1 do
              begin
              K:=PBusCon(MonitoredBuses^.At(I))^.Con;
              StrCat( S, #13#10);
              StrCat( S, PBus( NetWork^.At( K ) )^.Name);
              end;
   StrCat( S, #13#10'by the new monitored buses : ');
   for I:=0 to NBS-1 do
              begin
              StrCat( S, #13#10);
              StrCat( S, PBus( SelectedComponents^.At( I))^.Name);
              end;
   end
   else
   begin
   StrCopy( S,'Do you realy want to let the monitored buses : ');
   for I:=0 to SelectedComponents^.Count-1 do
              begin
              StrCat( S, #13#10);
              StrCat( S, PBus( SelectedComponents^.At( I))^.Name);
              end;
   StrCat( S, #13#10'be the new monitored buses ?');
   end;
Ans:=MessageBox( HWindow, S,'Specify monitored buses',
            MB_YesNo+MB_ICONQuestion);
if Ans=id_yes then
              begin
              MonitoredBuses^.FreeAll;
              for I:=0 to NBS-1 do
                  begin
                  PB:=PBus(SelectedComponents^.At( I));
                  K:=NetWork^.IndexOf( PB);
                  PBC:=new( PBusCon, Init( K));
                  MonitoredBuses^.Insert( PBC);
                  end;
              end;
End;

Procedure TWorksheet.CMTSP(var Msg: TMessage);
Var  Name : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
{ le Modified Euler Corrector }
  strcopy( Name, 'Transtab.exe 0 ');
  strcat( Name, TSInName);
  strcat( Name, ' ');
  strcat( Name, TSOutName);
  strcat( Name, ' ');
  strcat( Name, TSResultName);
  WinExec( Name, SW_SHOW);
{CallTransStab( 0, TSInName, TSOutName, TSResultName);}
{   Recup:=True;   pas de recuperation indirecte pour le TransStab }
End;

Procedure TWorksheet.CMTSPT(var Msg: TMessage);
Var  Name : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
{ le Trapeze Corrector }
  strcopy( Name, 'Transtab.exe 1 ');
  strcat( Name, TSInName);
  strcat( Name, ' ');
  strcat( Name, TSOutName);
  strcat( Name, ' ');
  strcat( Name, TSResultName);
  WinExec( Name, SW_SHOW);
{CallTransStab( 1, TSInName, TSOutName, TSResultName);}
End;

Procedure TWorksheet.CMRK(var Msg: TMessage);
Var  Name : Array [0..200] of char;
Begin
if not IsStudyTransStab then exit;
{ le Runge Kutta }
  strcopy( Name, 'Transtab.exe 2 ');
  strcat( Name, TSInName);
  strcat( Name, ' ');
  strcat( Name, TSOutName);
  strcat( Name, ' ');
  strcat( Name, TSResultName);
  WinExec( Name, SW_SHOW);
{CallTransStab( 2, TSInName, TSOutName, TSResultName);}
End;

Procedure TWorksheet.CMPlotResult(var Msg: TMessage);
Var  Name : Array [0..fsPathName] of char;
Begin
if not IsStudyTransStab then exit;
{ Montre le fichier .TSG
strcopy( Name, 'NOTEPAD.EXE ');
strcat( Name, TSResultName);
WinExec( Name, SW_SHOW);
}
{ Appelle Le Prog -> GraphD.exe OutName.TSG }
strcopy( Name, 'GRAPHD.EXE ');
strcat( Name, ' ');
strcat( Name, TSResultName);
WinExec( Name, SW_SHOW);
End;

{ old TDesigner Unit }
Procedure StreamRegistration;
Begin
RegisterType( RCollection);
RegisterType( RLPoint);
RegisterType( RPowerComponent);
RegisterType( RGenerator);
RegisterType( RBus);
RegisterType( RTransfo);
RegisterType( RDrain);
RegisterType( RLine);
RegisterType( RBusCon);
RegisterType( RCompensator);
RegisterType( RCapa);
{ special Transient Stability Studies }
RegisterType( RSpeGenerator);
RegisterType( RSpeCompensator);
RegisterType( RResistance);
RegisterType( RSelfInd);
RegisterType( RLink);
End;

{ TDesigner procedures }
constructor TDesigner.Init(ATitle: PChar; AMenu: HMenu);
Var T : TPoint;begin
  inherited Init(ATitle, AMenu);
  With Attr do
       Begin
       X:=10;
       Y:=10;
       W:=600;
       H:=400;
       End;
  ChildMenuPos := 6;
  StatusLine:=new( PRibbonWindow, Init( @self));
  StreamRegistration;
if GetSystemMetrics( SM_MousePresent)=0 then
                         ShowCursor( True);
end;

procedure TDesigner.SetInfoFlag( PWS : PWorkSheet );
Var  I : Integer;
begin
if PWS=nil then I:=0
           else begin
                if (PWS^.WSInfo.WSOpt and id_Moveable)=id_Moveable then I:=1
                                                                  else I:=2;
                if PWS^.LineCreating or PWS^.ModifyLine
                                     or PWS^.SelectArea then I:=3;
                if ( PWS^.FirstPlace and not PWS^.LineCreating)
                                     or PWS^.LButtonDown then I:=4;
                { si c'est fixee et LButtonDown }
                if ((PWS^.WSInfo.WSOpt and id_Moveable)<>id_Moveable)
                                       and PWS^.LButtonDown then I:=5;
                end;
StatusLine^.SetMoveableFlag( I);
end;

procedure TDesigner.SetStudyFlag( PWS : PWorkSheet );
begin
if PWS=nil then StatusLine^.SetStudyFlag( 0)
           else StatusLine^.SetStudyFlag( PWS^.WSInfo.Study);
end;

procedure TDesigner.AdjustMenu( PWS : PWorkSheet );
Var  I : Integer;
begin
{ Must see if all child are Iconized to change the menu
 to NoChildMenu }
if PWS=nil then begin
                { ++++_____+++++}
                end
           else begin
                if PWS^.WSInfo.Study=id_LoadFlow then ModifMenuToLoadFlow;
                if PWS^.WSInfo.Study=id_TransStab then ModifMenuToTransStab;
                end;
end;

procedure TDesigner.ModifMenuToLoadFlow;
Var HMyMenu : HMenu;
begin
HMyMenu:=GetMenu( HWindow);
CheckMenuItem( HMyMenu, cm_LoadFlowStudy, MF_BYCOMMAND+MF_Checked);
CheckMenuItem( HMyMenu, cm_TransStabStudy,MF_BYCOMMAND+MF_UnChecked);
end;

procedure TDesigner.ModifMenuToTransStab;
Var HMyMenu : HMenu;
begin
HMyMenu:=GetMenu( HWindow);
{ Modifie pour TransStab }
CheckMenuItem( HMyMenu, cm_LoadFlowStudy, MF_BYCOMMAND+MF_UnChecked);
CheckMenuItem( HMyMenu, cm_TransStabStudy,MF_BYCOMMAND+MF_Checked);
end;

Procedure TDesigner.SetUpWindow;
Var PChild : PWindowsObject;
    Name : Array[0..fsPathName] of Char;
begin
inherited SetUpWindow;
{ si pas de souris affiche quand meme the cursor }

{ ShowWindow( HWindow, SW_SHOWMAXIMIZED); }
{ cree une fenetre fille au demarrage }
  PChild:=CreateChild;
  If ParamCount=1 then Begin
                       StrPCopy( Name, ParamStr(1));
                       PWorkSheet(PChild)^.SetNames( Name);
                       PWorkSheet(PChild)^.LoadFile;
                       End;
end;

procedure TDesigner.FileOpen(var Msg: TMessage);
Var PChild : PWindowsObject;
    Name : Array[0..fsPathName] of Char;

  Function IsFreeForOverLoading( P : PWindowsObject): Boolean; Far;
  begin
  { on doit verifier que ce n'est pas la StatusLine }
  if not P^.IsFlagSet( wb_MDIChild) then
                                 begin
                                 IsFreeForOverLoading:=False;
                                 exit;
                                 end;
  if PWorkSheet( P)^.IsNewFile and not PWorkSheet( P)^.HasChanged
                               then IsFreeForOverLoading:=True
                               else IsFreeForOverLoading:=False;
  end;

begin
if Application^.ExecDialog(New(PFileDialog,
        Init(@Self, MakeIntResource(sd_FileOpen),
                    StrCopy( Name,'*.SCH')))) <> id_Ok then Exit;
{ Recherche d'un PChild Libre }
PChild:=FirstThat( @IsFreeForOverLoading);
{ Cree un nouveau child et y sort le NetWork }
if PChild=nil then
              begin
              PChild:=CreateChild;
              PWorkSheet(PChild)^.SetNames( Name);
              if PWorkSheet(PChild)^.LoadFile<>0 then
                                    begin
                                    MessageBox( HWindow,'Bad file format',
                                    'Load Error', MB_Ok+MB_IconStop);
                                    PWorkSheet(PChild)^.Done;
                                    end
              end
        Else  begin
              PWorkSheet(PChild)^.SetNames( Name);
              if PWorkSheet(PChild)^.LoadFile<>0 then
                                    begin
                                    MessageBox( HWindow,'Bad file format',
                                    'Load Error', MB_Ok+MB_IconStop);
                                    PWorkSheet(PChild)^.
                                               SetNames( 'Untitled.Sch');
                                    end
              end
end;

procedure TDesigner.CMHelpContent;
begin
  DoHelp(help_Index, 0);
end;

procedure TDesigner.CMHelpKeyBoard(var Message: TMessage);
begin
  DoHelp( Help_Key, LongInt(PChar('keys')));
end;

procedure TDesigner.CMHelpHelp(var Message: TMessage);
begin
  DoHelp( HELP_HELPONHELP, 0);
{  |__ Call the Help on Help of windows
 WinHelp(HWindow, 'WINHELP.HLP', Help_Index, 0); }
end;

Procedure TDesigner.CMAbout (Var Msg: TMessage);
begin
{  Application^.ExecDialog(New(PDialog, Init(@Self, 'AboutBox'))); }
  Application^.ExecDialog(New(PAboutBox,
    Init(@Self, 'About Power Designer', 'ImageHT')));
end;

function TDesigner.InitChild: PWindowsObject;
begin
  InitChild := New(PWorkSheet, Init(@Self, 'untitled.sch'));
end;

procedure TDesigner.WMMenuSelect;
var
  HelpText: array[0..80] of char;
  I, StrIdx: word;
const
  Popuphandles: array[0..7] of word = (0,0,0,0,0,0,0,0);
begin
 if PopupHandles[0] = 0 then
   for i := 0 to 7 do
     PopupHandles[i] := GetSubMenu(Attr.Menu,i);

  if StatusLine = nil then exit;

  HelpText[0] := #0;
  if Msg.LParamLo <> $FFFF then
  begin
    StrIdx := Msg.wParam;
{ pour choisir quelle phrase mettre en fonction de Study }
    if (StrIdx=151) and (StatusLine^.StudyFlag=id_TransStab)
            then StrIdx:=158;
    if (StrIdx=156) and (StatusLine^.StudyFlag=id_TransStab)
            then StrIdx:=157;
    if (Msg.lParamLo and MF_POPUP) <> 0 then
    begin
      I := 0;
      StrIdx := 0;
      repeat
        if PopupHandles[I] = Msg.wParam then StrIdx := 1000+i;
        inc(I);
      until (I > 7) or (StrIdx <> 0);
    end;
    if (StrIdx >= $0F00) and (StrIdx <= $0F0A) then
      StrCopy(HelpText,'Make this worksheet Current')
    else if (StrIdx <> 0) and (StrIdx < $F000) then
      LoadString(hInstance,StrIdx,HelpText,80);
  end;
  StatusLine^.SetHelpText(HelpText);
  DefWndProc(Msg);
end;

procedure TDesigner.WMSize(var Msg: TMessage);
var
  ClientX,ClientY,
  StatusX,StatusY,
  ClientW,ClientH,
  StatusW,StatusH  : integer;
begin
  ClientX := 0; ClientY := 0;
  ClientW := Msg.lParamLo;  ClientH := Msg.lParamHi;

  if StatusLine <> nil then
  with StatusLine^ do
  begin
    StatusX := ClientX-1; StatusY := ClientH-Height;
    StatusW := ClientW+2;  StatusH := Height+1;
    Dec(ClientH,Height);
    if StatusLine^.hWindow <> 0 then
      MoveWindow(StatusLine^.hWindow,StatusX,StatusY,StatusW,StatusH,True);
  end;

  if (ClientWnd <> nil) and (ClientWnd^.HWindow <> 0) then
    MoveWindow(ClientWnd^.HWindow, ClientX,ClientY,ClientW,ClientH,True);
end;

procedure TDesigner.GetWindowClass(var AWndClass: TWndClass);
begin
  inherited GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'PowerIcon');
end;

procedure TDesigner.WMDestroy;
begin
{ if a Help was opened via PowerD then close it }
  CloseHelp;
  inherited WMDestroy(Msg);
end;

Destructor TDesigner.Done;
var  PowComp : PowSymbType;
     I       : Integer;
begin
{ efface les images ressources }
for PowComp:=Generator to Link do
 if PowSymbRot[PowComp]<>0 then  for I:=0 to PowSymbRot[PowComp]-1 do
                                     DeleteObject(PowSymbImage[PowComp,I])
                           else DeleteObject(PowSymbImage[PowComp,0]);
DeleteObject( FaultImage);
inherited Done;
End;

End.